angular.module('MetronicApp').controller('CreditorEditCtrl', function($rootScope, $scope, settings, $http, filterFilter, $expMenus, $advExpTrans,$dbService,$stateParams) {
	$scope.$on('$viewContentLoaded', function() {   
			// initialize core components
		App.initAjax();
	});
	// set default layout mode
	$rootScope.settings.layout.pageContentWhite = true;
	$rootScope.settings.layout.pageBodySolid = false;
	$rootScope.settings.layout.pageSidebarClosed = false;
	$scope.orgMenuType = ($stateParams.menuType == "rcv" || $stateParams.menuType == "exp" ) ? $stateParams.menuType : "exp" ;	
    $scope.editTransId      =   "";
	$scope.editLv3Name		=	"";
	$scope.editLv1Menu		=	"";
	$scope.editAccountName	=	"";
    $scope.editTransDate    =   "";
    $scope.editTransValue   =   "";
    $scope.editTransComment =   "";  	
    //init data from db
    $scope.menus = $expMenus;
    $scope.advTrans = $advExpTrans;
    $scope.filterAdvTrans = $scope.advTrans;
    $scope.selectedLv2Menu = "0";
    $scope.lv1Menu = "";

    $scope.advTransEdit = function(tranId,menuType,lv1Menu) {
	$scope.lv1Menu = lv1Menu;
        $dbService.getAdvTranDetail(tranId,menuType,$scope.lv1Menu)
        .success(function(dat1) {
            $scope.editTransId      =   tranId;
			$scope.editLv3Name		=   dat1[0].lv3_name;
			$scope.editLv1Menu		=   dat1[0].lv1_menu;
			$scope.editAccountName	= 	dat1[0].account_name;
            $scope.editTransValue   =   (dat1[0].trans_val).replace(/,/g,"");
            $scope.editTransComment =   dat1[0].trans_comment;
            $scope.editTransDate    =   dat1[0].trans_date;
            
            $('#form_editAdvTrans').modal({
                show: 'true'
            });
        })
        .error(function(err) {console.log(err);} );
    }

	
	$scope.checkNum = function (checkVal)
	{
		var selectR = 0;
		var elemR = 0;
		var startR = 0;
		var endR = 0;
		checkVal = checkVal.replace(",","");
		if(checkVal == "")
		{
			checkVal = 0;
			$scope.editTransValue = 0;
		}
		else
		{
			var checkReg = new RegExp(/^\d+$/);
			checkValNum = Math.abs((parseFloat(checkVal).toFixed(2)));
			var checkOc = $scope.checkOccurrence(checkVal,".");
			if(checkReg.test(checkValNum) !== false || checkOc == 1 )
			{
				//console.log(checkVal);
				if(checkOc == 1)
				{
					//checkVal = checkVal+"01";
					endR = checkVal.length;
					startR = checkVal.length-2;
					elemR = $('[ng-model="transInputForm.amount"]');
					selectR = 1;
				}
				////$scope.transInputForm.amount = Math.abs((parseFloat(checkVal).toFixed(2)));
				//if(selectR = 1)
				//{
				//	selectRange(startR,endR,elemR);
				//}
			}
			else
			{
				if(checkVal.length == 1)
				{
					checkVal = 0;
				}
				else
				{
					checkVal = checkVal.substr(0,-1);
				}
				$scope.editTransValue = checkVal;
			}
		}
	}

	var selectRange = function(start, end, elem) {
		var el = elem[0];

        if (el) {
            el.focus();
            
            if (el.setSelectionRange) {
                el.setSelectionRange(start, end);
                
            } else if (el.createTextRange) {
                var range = el.createTextRange();
                range.collapse(true);
                range.moveEnd('character', end);
                range.moveStart('character', start);
                range.select();
                
            } else if (el.selectionStart) {
                el.selectionStart = start;
                el.selectionEnd = end;
            }
        }
	};
	
	$scope.checkOccurrence = function occurrences(string, subString, allowOverlapping) {

		string += "";
		subString += "";
		if (subString.length <= 0) return (string.length + 1);
	
		var n = 0,
			pos = 0,
			step = allowOverlapping ? 1 : subString.length;
	
		while (true) {
			pos = string.indexOf(subString, pos);
			if (pos >= 0) {
				++n;
				pos += step;
			} else break;
		}
		return n;
	}
	
	
    $scope.doTransEdit = function(menuType) 
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			var trans_id = $scope.editTransId;
			var edit_date_val = $scope.editTransDate;
			var edit_comment_val = $scope.editTransComment;
			$dbService.editAdvTran($scope.editTransId,menuType,$scope.lv1Type,$scope.editTransDate,$scope.editTransComment,$scope.editTransValue,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
			.success(function(dat1) {
				if(dat1.success){
					$dbService.getAdvTrans(menuType).then(function(dat2){
						$scope.advTrans = dat2.data;
						$scope.filterAdvTrans = $scope.advTrans;
					});
				} else {
					alert('Update error');
				}
			})
			.error(function(err) {console.log(err);} );
		}
    }

    $scope.advTransDelete = function(tranId,menuType,lv1Type) 
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$dbService.delAdvTran(tranId,menuType,lv1Type,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
			.success(function(dat1) {
				if(dat1.success){
					$dbService.getAdvTrans(menuType).then(function(dat2){
						$scope.advTrans = dat2.data;
						$scope.filterAdvTrans = $scope.advTrans;
						$scope.table.applyFilter();
						window.location.reload();
					});             
				} else {
					alert('Update error'); }
			})
			.error(function(err) {console.log(err);} );
		}
    }

    $scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.filterAdvTrans.length
            ,maxPage:  Math.ceil($scope.filterAdvTrans.length/5)
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.filterAdvTrans.length,name:"All"}
        ],
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchTrans.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.filterAdvTrans.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        },
        filter: function(mcf_id){
            if(mcf_id>0){
                $scope.filterAdvTrans = filterFilter($scope.advTrans,{lv2_id:mcf_id});
            }else{
                $scope.filterAdvTrans = $scope.advTrans;
            }
            this.applyFilter();
        },
        applyFilter: function(){
            this.config.curPage = 1;
            this.config.records = $scope.filterAdvTrans.length;
            this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
        }
    }
	
	$scope.showConfirmDel = function(delVal) 
	{	
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			//console.log(delVal);
			$scope.delData = delVal;
				$('#form_delete').modal({
					backdrop: 'static',
					show : 'true'
				});
		}
	} 

});