angular.module('MetronicApp').controller('DashboardController', function($rootScope, $scope, $http, $timeout, $sumData, $state, toastr) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();
        //toastr.info('We are ope# today from 10 to 22', 'Information');
       toastr.info('เรียนรู้เพิ่มเติมเกี่ยวกับหน้าแรก โดย<a href="#class?vid=10"><br>คลิกที่นี่</a>', 'เรียนรู้เพิ่มเติม');

		var data = $sumData;
	        $scope.summaryCashFlowData = data;
			$scope.summaryCashFlowData.netTotal = (data['summary_total'] < 0) ? (parseFloat(data['summary_total'])*-1.00) : (parseFloat(data['summary_total']));
			$scope.summaryCashFlowData.netTotalColor = (data['summary_total'] < 0) ? "red" : "green";
            $scope.summaryCashFlowAdvanced.receivings = data['adv_rcv'];
            $scope.summaryCashFlowAdvanced.expenses = data['adv_exp'];
			initHighCharts(data);
			if ($scope.summaryCashFlowData.rcv_percent == 0.00 && $scope.summaryCashFlowData.exp_percent == 0.00)
			{
				$scope.summaryCashFlowData.rcv_percent = "";
				$scope.summaryCashFlowData.exp_percent = "";
				Dashboards(0,0);
			}
			else
			{
				Dashboards($scope.summaryCashFlowData.rcv_percent,$scope.summaryCashFlowData.exp_percent);
				$scope.summaryCashFlowData.rcv_percent = $scope.summaryCashFlowData.rcv_percent+"%";
				$scope.summaryCashFlowData.exp_percent = $scope.summaryCashFlowData.exp_percent+"%";
			}
			//console.log($scope.userPermissions);
		setTimeout(function() {
		if($scope.userPermissions)
		{
			if(!$scope.userPermissions['cashflow-table'])
			{
				$('#dashboard-graphs').css('display','none');
			}
		}
		},100);
    });
    // set sidebar closed and body solid layout mode
    $rootScope.settings.layout.pageContentWhite = true;
    $rootScope.settings.layout.pageBodySolid = false;
    $rootScope.settings.layout.pageSidebarClosed = false;
	$scope.summaryCashFlowAdvanced = {
        'receivings' : 0.00,
        'expenses' : 0.00
    };

/*================Start Donut Dashboard==============*/
	var Dashboards = function(rcv_percent,exp_percent) {
		//console.log(rcv_percent);
		//console.log(exp_percent);
            Chart.defaults.global.tooltips.enabled = false;
			rcv_percent = (rcv_percent == 0 && exp_percent == 0) ? 100 : rcv_percent;
                var ctx = $('#mainChart');
                var mainChart = new Chart(ctx,{
                    type: 'doughnut',
                    data: {
                        labels: [
                            'Sleeping', 
                            'Designing'
                        ],
                        datasets:[
                            {
                                data: [exp_percent, rcv_percent],                  
                                backgroundColor: [
                                    '#f05b4f',
                                    '#01A79D'
                                ],
                                borderWidth: [0,0]
                            }
                        ],
                        scaleFontColor: "#FFFFFF",
                    },
                    options: {
                            legend: {display: false}
                    }
                });
};
/*===========================End Donut Dashboard===========================*/	

/*================Start HomeCharts (Stacked Columns) Dashboard==============*/

var initHighCharts = function(chartData)  {
var rcv_data = [];
var exp_data = [];
var adv_rcv_data = [];
var adv_exp_data = [];
var baseLine = [];
var xAxisData = [];
var d = new Date();
var n = d.getDate();
var currentDate = n-1;
var rcv_max = 0;
var exp_max = 0;
var adv_neg_temp = 0;
var neg_temp = 0; //Temp kepp negative value of exp_data
for(var day_i = 0; day_i < chartData.number_of_days; day_i++)
{
	rcv_data.push(chartData['rcv_data'][day_i]);
	neg_temp = Math.round(parseFloat(chartData['exp_data'][day_i]) * -1.00);
	exp_data.push(neg_temp);
    baseLine.push(0);
    if(day_i >= currentDate)
    {
        adv_rcv_data.push(chartData['adv_rcv_data'][day_i]);
        adv_neg_temp = Math.round(parseFloat(chartData['adv_exp_data'][day_i]) * -1.00);
	    adv_exp_data.push(adv_neg_temp);
    }
    else
    {
        adv_rcv_data.push(0);
        adv_exp_data.push(0);
    }

	if(chartData['rcv_data'][day_i]+adv_rcv_data[day_i] > rcv_max)
	{
		rcv_max  = chartData['rcv_data'][day_i]+adv_rcv_data[day_i];
	}
	if((neg_temp+adv_neg_temp) < exp_max)
	{
		exp_max  = (neg_temp+adv_neg_temp);
	}

	xAxisData.push(chartData['x-axis'][day_i]);
	
}
Highcharts.setOptions({
	   credits: {
		enabled: false
	   },
	   noData : {
		   position: {
			align: "center",
			verticalAlign: "bottom"
		   }
	   },
	   
});
    Highcharts.chart('barChart', {
        chart: {
		  backgroundColor: "#e6eeef",
            type: 'column'
        },
        title: {
            text: chartData['month']
        },
        xAxis: {
            categories: xAxisData
        },
        yAxis: {
            min: exp_max,
		  max: rcv_max,
		  title: ""
        },
       // tooltip: {
       //     headerFormat: '<b>วันที่ {point.x}</b><br/>',
       //     pointFormat: '{series.name}: {point.y}<br/>'
       // },
        plotOptions: {
            column: {
                stacking: 'normal'
            },
            line: {
                marker: {
                    enabled: false
                },
                tooltop: {
                    enabled: false
                },
                dataLabels: { 
                    enabled: false 
                },
                allowPointSelect: false,
                states: {
                    hover: {
                        enabled: false
                    }
                }
            }
        },
        series: [{
            name: 'รับเงิน',
		  color: '#01A79D',
		  pointWidth: 10,
            data : rcv_data,
            index:0
        }, {
            name: 'จ่ายเงิน',
		   color: '#f36a5a',
		   pointWidth: 10,
             data: exp_data,
             index:1
        },{
            name: 'เงินรอเรียกเก็บ',
		   color: 'rgba(1, 167, 157, 0.20)',
		   pointWidth: 10,
           dashStyle: 'longdash',
             data: adv_rcv_data,
             index:2
        },{
            name: 'เงินสดรอจ่าย',
		   color: 'rgba(243, 106, 90, 0.20)',
		   pointWidth: 10,
           dashStyle: 'longdash',
             data: adv_exp_data,
             index:3
        },{
            name: 'Base Lines',
            type: 'line',
            color: 'black',
            crosshair: false,
            lineWidth: 0.5,
            data: baseLine,
            enableMouseTracking : false,
            showInLegend: false
        }]
    });
}

/*==============================End Highcharts===============================*/	
});