angular.module('MetronicApp').controller('DebtorMainCtrl', function($rootScope, $scope, settings, $http, filterFilter, $lv3Menus, $debtors,$creditors,$dbService,$stateParams,toastr) {
	$scope.$on('$viewContentLoaded', function() {   
			// initialize core components
		App.initAjax();
		//toastr.info('We are open today from 10 to 22', 'Information');
       toastr.info('เรียนรู้เพิ่มเติมเกี่ยวกับกำหนดรับเงิน โดย<a href="#class?vid=12"> คลิกที่นี่</a>', 'เรียนรู้เพิ่มเติม');
	});
	// set default layout mode
	$rootScope.settings.layout.pageContentWhite = true;
	$rootScope.settings.layout.pageBodySolid = false;
	$rootScope.settings.layout.pageSidebarClosed = false;
	$scope.orgLv1Menu = ($stateParams.lv1Menu == "cfo" || $stateParams.lv1Menu == "cfi" || $stateParams.lv1Menu == "cff" ) ? $stateParams.lv1Menu : "cfo";
	$scope.orgMenuType =  "rcv" ;
	$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };	
	
	//get data via state's resolve provider
	$scope.lv3Menus = $lv3Menus;
	$scope.debtors = $debtors;
	$scope.creditors = $creditors;

	$scope.activity = {
		options : 1
	};

	$scope.activityLv1 = {
		1	: "cfo",
		2	: "cfi",
		3	: "cff"
	}
	
	$scope.filterlv3Menus = $lv3Menus[$scope.activityLv1[$scope.activity.options]];

	$scope.selectMenu = {
		Lv2		:	"0-0",
		Lv3		:	"0",
		formType:	'1'
	}

	$scope.modifiedLevels = ($scope.selectMenu.Lv2).split("-");
	
	var personProt = {
		name : "",
		address : {
			addr:"",
			subdistrict:"",
			district:"",
			province:"",
			postcode:""
		},	
		tax_id : "",
		telephone : "",
		email : "",
		comment : ""
	};

	$scope.debtor = $.extend(true,{},personProt);
	
	$scope.creditor = $.extend(true,{},personProt);
	
	$scope.checkForm = {
		name	:	''
	}
	
	$scope.resetDebtor = function(){
		$scope.debtor = $.extend(true,{},personProt);
	}

	$scope.resetCreditor = function(){
		$scope.creditor = $.extend(true,{},personProt);
	}
	
	Date.prototype.toDateInputValue = (function() {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	
	$scope.resetAdvancedTrans = function()
	{
		//if($scope.sessionUserData.packageValid !== true)
		//{
		//	$('#expiredModal').modal({
		//		backdrop: 'static',
		//		show: 'true'
		//	});
		//}
		//else
		//{
			$scope.advancedTrans = {
				Value : "0",
				Comment : "",
				Date : new Date().toDateInputValue(),
				debtor	: "",
				creditor: ""
			}
			$scope.selectMenu.lv2Name = "";
			$scope.selectMenu.formType = "";
		//}
	}
	$scope.resetAdvancedTrans();

	$scope.setActivityOp = function(index)
	{
		$scope.activity.options = index;
		$scope.selectMenu.Lv2 = "0-0";
		$scope.resetAdvancedTrans();
		$scope.modifiedLevels = ($scope.selectMenu.Lv2).split("-");
		$scope.filterlv3Menus = $lv3Menus[$scope.activityLv1[index]];
	}
	
	$scope.setSelectMenu = function(index)
	{
		$scope.resetAdvancedTrans();
		$scope.modifiedLevels = ($scope.selectMenu.Lv2).split("-");
		var haystack = $scope.lv3Menus[$scope.activityLv1[$scope.activity.options]];
		var needle = {lv2_id:$scope.modifiedLevels[0],lv3_id:$scope.modifiedLevels[1]};
		var menu = filterFilter(haystack,needle)[0];
		$scope.selectMenu.lv2Name = menu.lv2_name;
		$scope.selectMenu.formType = menu.form_type;	
	}

	$scope.openAddAdvance = function()
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.activity.options = 1;
			$scope.selectMenu.Lv2 = "0-0";
			$scope.resetAdvancedTrans();
			$scope.modifiedLevels = ($scope.selectMenu.Lv2).split("-");
			$('#form_modal3').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
	}
	
	$scope.saveAccountsDebtor = function()
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			/* 		var name 		= $scope.debtor.companyName ;
			var address 	= $scope.debtor.companyAddress ;
			var telephone 	= $scope.debtor.companyTelephone ;
			var email 		= $scope.debtor.companyEmail ;
			var comment 	= $scope.debtor.companyComment ;
			var menuType 	= $scope.orgMenuType; */
			var menuType 	= $scope.orgMenuType;
			let jsonDat = {
				menu_type: menuType,
				customer_detail: $scope.debtor,
				user_id: $scope.sessionUserData.userId,
				user_name: $scope.sessionUserData.userName
			};
			
			if(jsonDat.customer_detail.name !== "")
			{
				$scope.checkForm.name = "modal";
				$dbService.addAccount(jsonDat)
				.success(function(dat1) {
				if(dat1.success) 
				{ 
					$scope.debtor.name = "";
					$scope.debtor.address = {
						addr:"",
						subdistrict:"",
						district:"",
						province:"",
						postcode:""
					};
					$scope.debtor.tax_id = "";
					$scope.debtor.telephone = "";
					$scope.debtor.email = "";
					$scope.debtor.comment = "";
					$dbService.getAccounts(menuType).then(function(dat2){
						$scope.debtors = dat2.data;
					});
				}
				else
				{
					console.log('dd');
				}
				})
				.error(function(err) {console.log(err);} );
			}
			else
			{
				$scope.checkForm.name = "";
				swal({
					title: 'กรุณากรอกชื่อบริษัท'
				});
			}
		}
	}
	
	$scope.saveAccountsCreditor = function()
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
/* 			var name = $scope.creditor.companyName ;
			var address = $scope.creditor.companyAddress ;
			var telephone = $scope.creditor.companyTelephone ;
			var email = $scope.creditor.companyEmail ;
			var comment = $scope.creditor.companyComment ; */
			var menuType = 'exp';
			let jsonDat = {
				menu_type: menuType,
				customer_detail: $scope.creditor,
				user_id: $scope.sessionUserData.userId,
				user_name: $scope.sessionUserData.userName
			};		
			if(jsonDat.customer_detail.name !== "")
			{
				$scope.checkForm.name = "modal";
				$dbService.addAccount(jsonDat)
				.success(function(dat1) {
				if(dat1.success) 
				{ 
					$scope.creditor.name = "";
					$scope.creditor.address = {
						addr:"",
						subdistrict:"",
						district:"",
						province:"",
						postcode:""
					};
					$scope.creditor.tax_id = "";
					$scope.creditor.telephone = "";
					$scope.creditor.email = "";
					$scope.creditor.comment = "";
					$dbService.getAccounts(menuType).then(function(dat2){
						$scope.creditors = dat2.data;
					});
				}
				else
				{
					console.log('dd');
				}
				})
				.error(function(err) {console.log(err);} );
			}
			else
			{
				$scope.checkForm.name = "";
				swal({
					title: 'กรุณากรอกชื่อบริษัท'
				});
			}
		}
	}
		
	
	$scope.checkNum = function (checkVal)
	{
		var selectR = 0;
		var elemR = 0;
		var startR = 0;
		var endR = 0;
		if(checkVal == "")
		{
			checkVal = 0;
			$scope.advancedTrans.Value = 0;
		}
		else
		{
			var checkReg = new RegExp(/^\d+$/);
			checkValNum = Math.abs((parseFloat(checkVal).toFixed(2)));
			var checkOc = $scope.checkOccurrence(checkVal,".");
			if(checkReg.test(checkValNum) !== false || checkOc == 1 )
			{
				//console.log(checkVal);
				if(checkOc == 1)
				{
					//checkVal = checkVal+"01";
					endR = checkVal.length;
					startR = checkVal.length-2;
					elemR = $('[ng-model="transInputForm.amount"]');
					selectR = 1;
				}
				////$scope.transInputForm.amount = Math.abs((parseFloat(checkVal).toFixed(2)));
				//if(selectR = 1)
				//{
				//	selectRange(startR,endR,elemR);
				//}
			}
			else
			{
				if(checkVal.length == 1)
				{
					checkVal = 0;
				}
				else
				{
					checkVal = checkVal.substr(0,-1);
				}
				$scope.advancedTrans.Value = checkVal;
			}
		}
	}

	var selectRange = function(start, end, elem) {
		var el = elem[0];

        if (el) {
            el.focus();
            
            if (el.setSelectionRange) {
                el.setSelectionRange(start, end);
                
            } else if (el.createTextRange) {
                var range = el.createTextRange();
                range.collapse(true);
                range.moveEnd('character', end);
                range.moveStart('character', start);
                range.select();
                
            } else if (el.selectionStart) {
                el.selectionStart = start;
                el.selectionEnd = end;
            }
        }
	};
	
	$scope.checkOccurrence = function occurrences(string, subString, allowOverlapping) 
	{
		string += "";
		subString += "";
		if (subString.length <= 0) return (string.length + 1);
	
		var n = 0,
			pos = 0,
			step = allowOverlapping ? 1 : subString.length;
	
		while (true) {
			pos = string.indexOf(subString, pos);
			if (pos >= 0) {
				++n;
				pos += step;
			} else break;
		}
		return n;
	}
	
	$scope.saveAdvancedTrans = function()
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			var lv1Type = $scope.activityLv1[$scope.activity.options];
			var lv2Id = $scope.modifiedLevels[0];
			var lv3Id = $scope.modifiedLevels[1];
			var menuType = $scope.orgMenuType;
			var transDate = $scope.advancedTrans.Date;
			var transVal = $scope.advancedTrans.Value;
			var transComment = $scope.advancedTrans.Comment;
			var debtor = $scope.advancedTrans.debtor == "" ? "" : $scope.advancedTrans.debtor;
			var creditor = $scope.advancedTrans.creditor == "" ? "" : $scope.advancedTrans.creditor;
			
			var account = (debtor == "" && creditor == "") ? "" : ((debtor !== "") ? debtor : creditor);
			if($scope.modifiedLevels[0] > 0)
			{
				$dbService.newAdvanceTran(lv2Id,lv3Id,transDate,transVal,menuType,lv1Type,transComment,account,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
				.success(function(dat1) 
				{	
					if(dat1.success) 
					{   
						$scope.advancedTrans.Date = new Date().toDateInputValue();
						$scope.advancedTrans.Value = "";
						$scope.advancedTrans.Comment = "";
						$scope.advancedTrans.debtor = "";
						$scope.advancedTrans.creditor = "";
						
					}else{
						console.log(dat1);
					}
				})
				.error(function(err) {console.log(err);} );
			}
		}
	}
	   
    $scope.showAddDebtorModal = function() 
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$('#form_modal2').modal({
				backdrop: 'static',
				show : 'true'
			});
		}
	}
	
	$scope.showAddCreditorModal = function() 
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$('#form_modal4').modal({
				backdrop: 'static',
				show : 'true'
			});
		}
	}
});