angular.module('MetronicApp').controller('ExpenseHistoryCtrl',function($rootScope, $scope, settings, $http,filterFilter,$expMenus,$expTrans,$dbService,$stateParams) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();

        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
   
    });

    $scope.orgLv1Menu = ($stateParams.lv1Menu == "cfo" || $stateParams.lv1Menu == "cfi" || $stateParams.lv1Menu == "cff" ) ? $stateParams.lv1Menu : "cfo";
    $scope.orgMenuType = ($stateParams.menuType == "rcv" || $stateParams.menuType == "exp" ) ? $stateParams.menuType : "exp" ;
    $scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
    $scope.menuPic = { "cfo" : "coins.png", "cff" : "talk.png", "cfi" : "build.png" };

    $scope.editTransId      =   "";
	$scope.editLv3Name		=	"";
	$scope.editLv1Menu		=	"";
	$scope.editAccountName	=	"";
    $scope.editTransDate    =   "";
    $scope.editTransValue   =   "";
    $scope.editTransComment =   "";         
    //init data from db
    $scope.expMenu = filterFilter($expMenus,{lv1_menu:$stateParams.lv1Menu});
    $scope.expTrans = filterFilter($expTrans,{lv1_menu:$stateParams.lv1Menu});
    $scope.filterTrans = $scope.expTrans;
    $scope.selectedLv2Menu = "0";
    $scope.lv1Type = "";
	
    Date.prototype.toDateInputValue = (function() {
        var local = new Date(this);
        var newDate = ("0"+(local.getDate())).slice(-2)+"/"+("0"+(local.getMonth()+1)).slice(-2)+"/"+local.getFullYear();
        return newDate;
    });
    
    $scope.expTransEdit = function(tranId,menuType,lv1Type) {
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
				$scope.lv1Type = lv1Type;
			$dbService.getTranDetail(tranId,menuType,lv1Type)
			.success(function(dat1) {
				$scope.editTransId      =   tranId;
					$scope.editLv3Name		=   dat1[0].lv3_name;
					$scope.editLv1Menu		=   dat1[0].lv1_menu;
					$scope.editAccountName	= 	dat1[0].account_name;
				$scope.editTransValue   =   parseFloat(dat1[0].trans_val,2);
				$scope.editTransComment =   dat1[0].trans_comment;
				$scope.editTransDate    =   dat1[0].trans_date;
				
				$('#form_editExpTrans').modal({
					backdrop: 'static',
					show: 'true'
				});
			})
			.error(function(err) {console.log(err);} );
		}
    }
    
    $scope.expTransDelete = function(tranId,menuType,lv1Type) {
	if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$dbService.delTran(tranId,menuType,lv1Type,$scope.sessionUserData.userId,$scope.sessionUserData.fullName)
			.success(function(dat1) {
				if(dat1.success){
					$dbService.getTrans(menuType).then(function(dat2){
						$scope.expTrans = filterFilter(dat2.data,{lv1_menu:$stateParams.lv1Menu});
						$scope.filterTrans = $scope.expTrans;
						$scope.table.applyFilter();
						window.location.reload();
					});             
				} else {
					alert('Update error'); }
			})
			.error(function(err) {console.log(err);} );
		}
    }
    
    $scope.doTransEdit = function(menuType) {
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.editTransDate = ($scope.editTransDate == "") ? (new Date()).toDateInputValue("") : $scope.editTransDate;
				$dbService.editTran($scope.editTransId,menuType,$scope.lv1Type,$scope.editTransDate,$scope.editTransComment,$scope.editTransValue,$scope.sessionUserData.userId,$scope.sessionUserData.fullName)
				.success(function(dat1) {
					if(dat1.success){
						$dbService.getTrans(menuType).then(function(dat2){
							$scope.expTrans = filterFilter(dat2.data,{lv1_menu:$stateParams.lv1Menu});
							$scope.filterTrans = $scope.expTrans;
						});
					} else {
						alert('Update error');
					}
				})
				.error(function(err) {console.log(err);} );
		}
    }
    
	$scope.sortKey = 'trans_date_original';
	$scope.reverse = true;
        
    $scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.expTrans.length
            ,maxPage:  Math.ceil($scope.expTrans.length/5)
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.expTrans.length,name:"All"}
        ],
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchTrans.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.filterTrans.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        },
        filter: function(mcf_id){
            if(mcf_id>0){
                $scope.filterTrans = filterFilter($scope.expTrans,{lv2_id:mcf_id});
            }else{
                $scope.filterTrans = $scope.expTrans;
            }
            this.applyFilter();
        },
        applyFilter: function(){
            this.config.curPage = 1;
            this.config.records = $scope.filterTrans.length;
            this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
        }
    }
	
	$scope.showConfirmDel = function(delVal) 
	{	
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
		//console.log(delVal);
		$scope.delData = delVal;
		$scope.lv1Type = delVal.lv1_menu;
			$('#form_delete').modal({
				backdrop: 'static',
				show : 'true'
			});
		}
	} 
  
});
