angular.module('MetronicApp').controller('InvoiceCustomerCtrl', function($rootScope, $scope, settings, $http, multiFieldsFilter, $dbService, $customers) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();
        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
        //$scope.orgLv1Menu = ($scope.params.lv1Menu == "cfo" || $scope.params.lv1Menu == "cfi" || $scope.params.lv1Menu == "cff" ) ? $scope.params.lv1Menu : "cfo";
        //$scope.orgMenuType = ($scope.params.menuType == "rcv" || $scope.params.menuType == "exp" ) ? $scope.params.menuType : "rcv" ;
        //$scope.menuDesc = { "cfo" : "ดำเนินการ", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };     
    });	
	console.log($customers);
	//all procuts list
	$scope.masterList = $customers;
	
	//item handlers
	$scope.customer = {
		modal: {
			title: ""
		},
		detail: {
			mcf_account_id: "",
			name: "",
			tax_id: "",
			address: {
				addr: "",
				subdistrict: "",
				district: "",
				province: "",
				postcode: "",
			},
			telephone: "",
			email:"",
			comment: ""
		},
		create: function(){
			this.modal.title = "เพิ่มลูกค้า";
			this.detail.mcf_account_id = -1;  
			$('#formCustomerDetail').modal({
				backdrop: 'static',
				show: 'true'
			});
		},
		save: function(){
			var vm = this;
			var user_name = $scope.sessionUserData.userName;
			var	user_id = $scope.sessionUserData.userId;
			
			if(this.detail.mcf_account_id > 0){
				let jsonDat = {
					menu_type: 'rcv',
					customer_detail: this.detail,
					user_id: user_id,
					user_name: user_name
				};				
				//update item details
				$dbService.editAccount(jsonDat).then(
					function(dat){
						if(dat.data.success){
							vm.fetch();
							vm.clear($scope.customerDetail);
						}
					},
					function(err){console.log(err);vm.clear($scope.customerDetail);}
				);
			} else {
				//create new item
				let jsonDat = {
					menu_type: 'rcv',
					customer_detail: this.detail,
					user_id: user_id,
					user_name: user_name
				};
				$dbService.addAccount(jsonDat).then(
					function(dat){ 
						if(dat.data.success){ 
							vm.fetch();
							vm.clear($scope.customerDetail);
						}
					},
					function(err){console.log(err);vm.clear($scope.customerDetail);});
			}

		},
		edit: function(input){
			//return console.log(typeof input.address);
			this.modal.title = "แก้ไขรายชื่อลูกค้า";
			this.detail.mcf_account_id = input.mcf_account_id;
			this.detail.name = input.name;
			this.detail.tax_id = input.tax_id;
			this.detail.address = typeof input.address == "string" ? {
				addr: input.address,
				subdistrict: "",
				district: "",
				province: "",
				postcode: "",
				}: input.address,
			this.detail.telephone = input.telephone;
			this.detail.email = input.email;
			this.detail.comment = input.comment;
			$('#formCustomerDetail').modal({
				backdrop: 'static',
				show: 'true'
			});
		},
		promptDelete: function(input){
			this.detail.mcf_account_id = input.mcf_account_id;
			this.detail.name = input.name;
			this.detail.tax_id = input.tax_id;
			this.detail.address = input.address;
			this.detail.telephone = input.telephone;
			this.detail.email = input.email;
			this.detail.comment = input.comment;
			$('#form_delete').modal({
				backdrop: 'static',
				show : 'true'
			});
		},
		delete: function(id){
			var vm = this;
			var user_name = $scope.sessionUserData.userName;
			var	user_id = $scope.sessionUserData.userId;
			$dbService.delAccount(
				'rcv',
				id,
				user_id,
				user_name
			).then(
				function(dat){console.log(dat);
					if(dat.data.success){
						vm.fetch();
						vm.clear($scope.customerDetail);
					}
				});
		},
		fetch: function(){
			$dbService.getAccounts('rcv').then(
				function(dat){
					//console.log(dat.data);
					$scope.masterList = dat.data;
					$scope.table.refresh();
				},
				function(err2){console.log(err2);}
			);
		},
		clear: function(form){
			this.detail.mcf_account_id = this.detail.name = this.detail.tax_id = this.detail.address = this.detail.telephone = this.detail.email = this.detail.comment = "";
			form.$setPristine();
			form.$setUntouched();
			//console.log($scope.customerDetail);
		}
	};
	
	//table sorting params
	$scope.sortKey = 'mcf_account_id';
	$scope.reverse = false;
	
	//Table handler
	$scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.masterList.length
            ,maxPage:  Math.ceil($scope.masterList.length/5)
			,searchFields: ["name","email","telephone","tax_id"]
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.masterList.length,name:"All"}
        ],
		searchString: "",
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchList.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.masterList.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        },
		//For catagories filter
        // filter: function(mcf_id){
            // if(mcf_id>0){
                // $scope.filterTrans = filterFilter($scope.expTrans,{lv2_id:mcf_id});
            // }else{
                // $scope.filterTrans = $scope.expTrans;
            // }
            // this.refresh();
        // },
        refresh: function(){
            this.config.curPage = 1;
            this.config.records = $scope.masterList.length;
            this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
        }
    };	

});