angular.module('MetronicApp').controller('InvoiceDashboardCtrl', function($rootScope, $scope, settings, $http, multiFieldsFilter, $dbService, defaultReportDashboard) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();
        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		
	   //$scope.initColumnLineChartIncome($scope.reportData);
    });	
	$scope.reportData = defaultReportDashboard.data;
	$scope.report = {
		'summaryDays' : {
			"เมื่อวาน"		:	"1",
			"5 วันย้อนหลัง"		:	"5",
			"7 วันย้อนหลัง"		:	"7",
			"10 วันย้อนหลัง"	:	"10",
			"14 วันย้อนหลัง"	:	"14",
			"21 วันย้อนหลัง"	:	"21",
			"30 วันย้อนหลัง"	:	"30"
		},
		'selectedReportDays'	:	($scope.reportData.period_days).toString(),
		'incomeData'	:	{
			'quotation'		:	$scope.reportData.income_docs.quotation.count,
			'invoice'			:    $scope.reportData.income_docs.invoice.count,
			'receipt'			:    $scope.reportData.income_docs.receipt.count,
			'deliveryNote'		:    $scope.reportData.income_docs.delivery_note.count,
			'preReceipt'		:    $scope.reportData.income_docs.pre_receipt.count
		},
		'expenseData'	:	{
			'certificateReceipt'	:	$scope.reportData.expense_docs.certificate_receipt.count,
			'receiveForm'			:	$scope.reportData.expense_docs.receive_form.count,
			'withholdingForm'		:	$scope.reportData.expense_docs.withholding_form.count
		}
	};
	
	$scope.$watch('report.selectedReportDays',function(){
		$dbService.getInvoiceDashboard($scope.report.selectedReportDays).then(
			//on success
			function(dat){
				$scope.initColumnLineChartIncome(dat.data);
				$scope.report.incomeData.quotation 			= dat.data.income_docs.quotation.count;
				$scope.report.incomeData.invoice 				= dat.data.income_docs.invoice.count;
				$scope.report.incomeData.receipt 				= dat.data.income_docs.receipt.count;
				$scope.report.incomeData.deliveryNote 			= dat.data.income_docs.delivery_note.count;
				$scope.report.incomeData.preReceipt 			= dat.data.income_docs.pre_receipt.count;
				
				$scope.report.expenseData.certificateReceipt 	= dat.data.expense_docs.certificate_receipt.count;
				$scope.report.expenseData.receiveForm 			= dat.data.expense_docs.receive_form.count;
				$scope.report.expenseData.withholdingForm 		= dat.data.expense_docs.withholding_form.count;
			}
			//on errors
			,function(err){console.log(err);});
	});
	
	$scope.initColumnLineChartIncome = function(chartData)
	{
		var incomeHeaderKeys = Object.keys(chartData.income_header);
		var incomeQuotation = chartData.income_docs.quotation.total_val;
		var incomeInvoice = chartData.income_docs.invoice.total_val;
		var incomeReceipt = chartData.income_docs.receipt.total_val;
		var incomeDeliveryNote = chartData.income_docs.delivery_note.total_val;
		var incomePreReceipt = chartData.income_docs.pre_receipt.total_val;

		var expenseHeaderKeys = Object.keys(chartData.expense_header);
		var expenseCertificateReceipt = chartData.expense_docs.certificate_receipt.total_val;
		var expenseReceiveForm = chartData.expense_docs.receive_form.total_val;
		var expenseWithholdingTax = chartData.expense_docs.withholding_form.total_val;
		
		var xAxisIncomeData = [];
		var xAxisExpenseData = [];
		for(var header_i = 0; header_i < incomeHeaderKeys.length; header_i++)
		{
			xAxisIncomeData.push(chartData.income_header[incomeHeaderKeys[header_i]]);
		}
			
		
		for(var header_x = 0; header_x < expenseHeaderKeys.length; header_x++)
		{
			xAxisExpenseData.push(chartData.expense_header[expenseHeaderKeys[header_x]]);
		}
		
		var incomeSeriesData = [ {name : xAxisIncomeData[0], data :  [incomeQuotation] } , {name : xAxisIncomeData[1], data :  [incomeInvoice] }, {name : xAxisIncomeData[2], data :  [incomeReceipt] } , {name : xAxisIncomeData[3], data :  [incomeDeliveryNote] }, {name : xAxisIncomeData[4], data :  [incomePreReceipt]  }];
		var expenseSeriesData = [ {name : xAxisExpenseData[0], data :  [expenseCertificateReceipt] } , {name : xAxisExpenseData[1], data :  [expenseReceiveForm] }, {name : xAxisExpenseData[2], data :  [expenseWithholdingTax] }];

		Highcharts.setOptions({
			   credits: {
				enabled: false
			   },
			   noData : {
				   position: {
					align: "center",
					verticalAlign: "bottom"
				   }
			   },

		});

		Highcharts.chart("incomeChart", {
		        chart: {
		            type: "column"
		        },
			   title: {
				text: ''
			   },
		        xAxis: {
		            categories: ["ยอดเงินรวม"]
		        },
		        yAxis: {
					title: ""
		        },
		        plotOptions: {
		            column: {
		                dataLabels: {
		                    enabled: false
		                },
		                color : "#01A79D"
		            },
				  line: {
           			    marker: {
           			        enabled: false
           			    },
           			    tooltop: {
           			        enabled: false
           			    },
           			    dataLabels: { 
           			        enabled: false 
           			    },
           			    allowPointSelect: false,
           			    states: {
           			        hover: {
           			            enabled: false
           			        }
           			    }
           			}
		        },
		        credits: {
		            enabled: false
		        },
				series: incomeSeriesData
		    });
			
		Highcharts.chart("expChart", {
		        chart: {
		            type: "column"
		        },
			   title: {
				text: ''
			   },
		        xAxis: {
		            categories: ["ยอดเงินรวม"]
		        },
		        yAxis: {
					title: ""
		        },
		        plotOptions: {
		            column: {
		                dataLabels: {
		                    enabled: false
		                },
		                color : "#F05B4F"
		            },
				  line: {
           			    marker: {
           			        enabled: false
           			    },
           			    tooltop: {
           			        enabled: false
           			    },
           			    dataLabels: { 
           			        enabled: false 
           			    },
           			    allowPointSelect: false,
           			    states: {
           			        hover: {
           			            enabled: false
           			        }
           			    }
           			}
		        },
		        credits: {
		            enabled: false
		        },
				series: expenseSeriesData
		    });			
			
	}
	
});