angular.module('MetronicApp').controller('InvoiceExpenseAddCtrl.certificate_receipt', function(
	$rootScope,
	$scope,
	$state,
	$stateParams,
	settings,
	$http,
	filterFilter,
	multiFieldsFilter,
	$dbService,
	$customers,
	userDefault,
	invoiceConfigs,
	rcvMenus,
	$referList
) {
    $scope.$on('$viewContentLoaded', function() {   
        /* initialize core components */
        App.initAjax();
        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;


		
    });	
	/* set global constants */
	const FORM_TYPE = $stateParams.form;
	const FORM = serializeForms(userDefault)[FORM_TYPE];
	//const FORM_SUBTITLE = $stateParams.pageSubtitle;
	const USER = $scope.sessionUserData;
	/* set CFO menus, exclude from type 2 */
	const MENUS = filterFilter(rcvMenus,{lv1_menu: "cfo", form_type: "1"});
	// const CFI_MENUS = filterFilter(rcvMenus,{lv1_menu: "cfi", form_type: "1"});
	// const MENUS = CFO_MENUS.concat(CFI_MENUS);
	$state.current.data.pageTitle = "เพิ่ม"+ FORM.title;
	
	/* set form display conditional parameters */
	$scope.form = {
		title: "เพิ่ม"+ FORM.title,
		// WHT: FORM_TYPE == 'receipt' ? true : false,
		// VAT: userDefault.VAT_active ? true : false,
		// reference: FORM_TYPE == 'receipt' || FORM_TYPE == 'delivery_note' || FORM_TYPE == 'invoice' ? true : false,
		// CFO: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false,		
		// payment: FORM_TYPE == 'receipt' ? true : false	
	};
	
	/* set the cashflow-related scope */
	$scope.cashflow = {
		menus: MENUS,
		subMenus: MENUS[0].lv3,
		selectMenu: function(id){
			var menu = filterFilter(rcvMenus,{mcf_id: id}); 
			this.subMenus = menu[0].lv3;
			$scope.invoice.summary.cashflow.mcf_sub_id = 1;
			$scope.invoice.summary.cashflow.menuType = menu[0].lv1_menu;
		}
	};
	
	/* Date Format */
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	
	/* set customer info scope & control */
	$scope.customer = {
		masterList: $customers,
		detail: {
			name: "",
			address: {
				addr:"",
				subdistrict:"",
				district:"",
				province:"",
				postcode:""
			},
			phone: "",
			taxId: ""
		},
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = typeof c.address == "string" ? {addr:c.address, subdistrict:"", district:"", province:"", postcode:""} : c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};

	/* set reference invoice list scope & control */
	$scope.reference = {
		masterList: $referList,
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject;
			//console.log(c);
			$scope.reference.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			//var i = this.$parent.$index;
			//console.log(i);
			//$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			console.log(c);
			
			/* add item list */
			$scope.item.list = c.item_list;
			setTimeout(function(){
				for(var i in c.item_list){
					let inputId = "#item_" + i +"_value";
					$(inputId).val(c.item_list[i].name);
				}
			}, 500); 
			/* add customer detail */
			$scope.customer.detail = c.customer_detail;
			$scope.$broadcast('angucomplete-alt:changeInput', 'customerInfo', c.customer_detail.name);
			
			/* add invoice summary */
			$scope.invoice.summary.vatType = c.summary.vatType;
			$scope.invoice.summary.print = c.summary.print;
			$scope.invoice.summary.discountInput = c.summary.discountInput;
			$scope.invoice.summary.withWHT = c.summary.withWHT;
			$scope.invoice.updateSummary($scope.item.list);
			
			/* update reference number  */
			$scope.invoice.summary.reference = c.summary.number;
		}
	};
	
	/* invoice's item list scope & control */
	$scope.item = {
		dummy: {
			date: new Date().toDateInputValue(""),
			note: "",
			description: "",
			total: "0.00"
		},
		list: [],
		//masterList: $allItems,
		addToList: function(input){
			//copy then push
			var copy = $.extend(true, {}, input);
			this.list.push(copy);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		removeFromList: function(i){
			//remove item
			this.list.splice(i, 1);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		}/* ,
		autoFill: function(obj,i){
			//update row data
			this.list[i].item_id = obj.item_id;
			this.list[i].name = obj.name;
			this.list[i].description = obj.description;
			this.list[i].unit_price = obj.unit_price_int;
			this.list[i].number = obj.number;
			this.list[i].qty = 1;
			this.list[i].subtotal = obj.unit_price_int;
			this.list[i].discount = "0.00";
			this.list[i].total = obj.unit_price;
			//sum invoice
			this.pricing(i);
			$scope.invoice.updateSummary(this.list);
		},
		pricing: function(i){
			//sum item
			this.list[i].subtotal = ( this.list[i].qty * this.list[i].unit_price ).toFixed(2);
			this.list[i].discount = getDiscount(this.list[i].subtotal,this.list[i].discountInput);
			this.list[i].total = (this.list[i].subtotal - this.list[i].discount).toFixed(2);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		} */
	};
	/* set invoice scope & control */
	$scope.invoice = {
		summary: {
			form: FORM_TYPE,
			reference: "",
			number: getRunningNumber(userDefault, FORM_TYPE),
			date: new Date().toDateInputValue(""),
			user: {
				name: USER.fullName,
				position: ""
			},
			
			// subtotal: "0.00",
			// discount: "0.00",
			// discountInput: "0.00",
			// vatType:  userDefault.VAT_active  ? invoiceConfigs.vatType[0].id.toString() : "0",
			// vatRate: invoiceConfigs.vatRate,
			// VAT: "0.00",
			// withWHT: false,
			// whtRate: invoiceConfigs.whtRate,
			// WHT: "0.00",
			total: "0.00",
			comment: "",
			cashflow: {
				mcf_id: $scope.cashflow.menus[0].mcf_id,
				mcf_sub_id: $scope.cashflow.subMenus[0].mcf_sub_id,
				menuType: $scope.cashflow.menus[0].lv1_menu,
				date: new Date().toDateInputValue("")
			},
			print: {
				logo: userDefault.logo,
				signature: userDefault.signature,
				stamp: userDefault.stamp,
				print_as_set: userDefault.print_as_set,
				print_header: userDefault.header_id
			}			
		},
		// vatType: invoiceConfigs.vatType,
		// whtRateOptions: invoiceConfigs.whtRateOptions,
		updateSummary: function(list){
			//get sum item (subtotal)
			var sum = this.sumItemList(list);
			this.summary.total = sum;
			//get all amounts e.g. subtotal, vat, total
			// var amount = this.getAmount(sum);
			//update invoice amount
			// this.summary.subtotal = amount.subtotal;
			// this.summary.VAT = amount.VAT;
			// this.summary.total = amount.total;
			// this.summary.WHT = amount.WHT;
		},
		sumItemList: function(list){
			var result = 0;
			//sum every items in item list
			for(i=0; i<list.length; i++){ //console.log(result);
				result += parseFloat(list[i].total);
			}
			return result;
		},
/* 		getAmount: function(input){
			var subtotal = parseFloat(input);
			var result = {};
			// calculate subtotal, vat, total by vatType condition
			switch(this.summary.vatType) {
				// No VAT
				case "0":
				default: 
					result.subtotal = subtotal.toFixed(2);
					this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
					result.VAT = "0.00";
					result.WHT = this.getWHT(this.summary.withWHT, result.subtotal); 
					result.total = ( subtotal - parseFloat(this.summary.discount) ).toFixed(2);
					break;
				// VAT excluded
				case "1":
					result.subtotal = subtotal.toFixed(2);
					this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
					var subtotalAfterDiscount = result.subtotal - parseFloat(this.summary.discount);
					result.VAT = (subtotalAfterDiscount * this.summary.vatRate / 100).toFixed(2);
					result.WHT = this.getWHT(this.summary.withWHT, subtotalAfterDiscount); 
					result.total = ( parseFloat(subtotalAfterDiscount) + parseFloat(result.VAT) ).toFixed(2);
					break;
				// VAT included
				case "2":
					//result.subtotal = (subtotal / (1 + (this.summary.vatRate / 100) ) ).toFixed(2);
					this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
					var subtotalAfterDiscount = subtotal - this.summary.discount;
					result.subtotal = ( (100 * subtotalAfterDiscount) / (this.summary.vatRate + 100) ).toFixed(2);
					result.VAT = (subtotalAfterDiscount - result.subtotal).toFixed(2);
					result.WHT = this.getWHT(this.summary.withWHT, result.subtotal); 
					result.total = (subtotalAfterDiscount).toFixed(2);
					break;
			}

			return result;
		}, */
/* 		getWHT: function(flag,subtotal){
			if(flag){
				return ( subtotal * this.summary.whtRate / 100 ).toFixed(2);
			} else {
				return "0.00";
			}
		}, */
		save: function(){
			var vm = this;
			var jsonDat = {
				type: "expense_documents",
				summary: this.summary,
				itemList: $scope.item.list,
				customer: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			$scope.ajaxProcessing = true;
			$dbService.insertInvoice(jsonDat).then(
				//on success
				function(dat){
					vm.updateInvoiceIndex(FORM_TYPE, getInvoiceIndex());
					// vm.saveCashflow(jsonDat.summary);
					vm.saveCashflow(jsonDat.summary, dat.data.inserted_id['$oid']);												
					$scope.ajaxProcessing = false;
					$state.go('invoice-expense-manage',{
						form: FORM_TYPE
					});
				}
				//on errors
				,function(err){console.log(err);$scope.ajaxProcessing = false;});
		},
		saveCashflow: function(tran, doc_id){
			user_id = USER.userId;
			user_name = USER.userName;
			comment = "เป็นการบันทึกรายจ่ายรวม ณ วันที่ "+ tran.cashflow.date + " เอกสารอ้างอิงเลขที่: " + tran.number;
			$dbService.newTran(tran.cashflow.mcf_id, tran.cashflow.mcf_sub_id,tran.cashflow.date,tran.total,'exp',tran.cashflow.menuType,comment,-1,user_id,user_name).then(
				function(dat){
					var trans_id = dat.data.inserted_id['$oid'];
					$dbService.updateInvoiceTransInfo("expense_documents", doc_id, trans_id).then(
						function(dat2){console.log(dat2);},
						function(err){console.log(err);});
				},
				function(err){alert(err);});
		},
		updateInvoiceIndex: function(form,used_number){
			$dbService.updateInvoiceIndex(form,used_number).then(
				function(){},
				function(err){alert(err);});
		}
	};
	
	$scope.ui = {
		printPreview: function(input){
			let obj = {
				//type: "expense_documents",
				summary:  $scope.invoice.summary,
				item_list: $scope.item.list,
				customer_detail: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			
			let	json_dat = JSON.stringify(obj);
			//let target =  window.location.origin + "/mcf_merged/docs/preview?json_dat="+json_dat;
			let target =  window.location.origin + "/docs/preview/expense/"+FORM_TYPE;

			let mapForm = document.createElement("form");
			mapForm.target = "preview";
			mapForm.method = "POST";
			mapForm.action = target;
		
			let mapInput = document.createElement("input");
			mapInput.type = "hidden";
			mapInput.name = "jsonDat";
			mapInput.value = json_dat;
			mapForm.appendChild(mapInput);
		
			document.body.appendChild(mapForm);
		
			map = window.open("", "preview", "fullscreen=yes");
			if (map) {
				mapForm.submit();
			} else {
				alert('You must allow popups for this map to work.');
			}
			//$window.open(target, '_self');
			//$window.open(target,'','fullscreen=yes');
			//console.log(formData);
		}
	};		
	initUI();

	
	function getDiscount(subtotal,input) {
		if(input.indexOf("%") > -1){
			let rate = input.slice(0,input.length-1);
			var discount =  ((subtotal * rate) / 100 ).toFixed(2);
		} else {
			var discount = input;
		}
		return discount;			
	}
		
	/* get invoice header */
	function getRunningNumber(configs,form){
		//console.log(configs);console.log(form);
		var formConfig = configs.document_configs[form];
		var digits = formConfig.auto_increment.length;
		var zeros = '00000000';
		var runningNumber = formConfig.last_used_id != "" ? ( zeros+(parseInt( formConfig.last_used_id ) + 1)).slice(-1*digits) : formConfig.auto_increment ;
		//var result;
		switch(configs.header_number_id){
			case 0:
			default:
				return formConfig.prefix + runningNumber;
				break;
			case 1:
			case 2:
				return formConfig.prefix + formConfig.middle + runningNumber;
				break;
		}
	}
	
	/* get invoice header's number */
	function getInvoiceIndex(){
		var runningNumber = $scope.invoice.summary.number;
		var index = runningNumber.replace(/[^0-9\.]/g, '');
		return index;
	}
	
	function initUI(){
		/* init first item.list row */
		$scope.item.addToList($scope.item.dummy);

	}
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}
	
});
