angular.module('MetronicApp').controller('InvoiceExpenseAddCtrl.withholding_form', function(
	$rootScope,
	$scope,
	$state,
	$stateParams,
	settings,
	$http,
	filterFilter,
	multiFieldsFilter,
	$dbService,
	companyInfo,
	$customers,
	userDefault,
	invoiceConfigs,
	rcvMenus,
	$referList
) {
    $scope.$on('$viewContentLoaded', function() {   
        /* initialize core components */
        App.initAjax();
        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
    });	
	/* set global constants */
	const FORM_TYPE = $stateParams.form;
	const FORM = serializeForms(userDefault)[FORM_TYPE];
	const USER = $scope.sessionUserData;
	const COMPANY = companyInfo.result;
	$state.current.data.pageTitle = "เพิ่ม"+ FORM.title;
	
	/* set form display conditional parameters */
	$scope.form = {
		title: "เพิ่ม"+ FORM.title
	};
	
	
	/* Date Format */
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	
	$scope.dateRangeChange = function(input){
		//input.d1 == input.d1 == "" ? new Date().toDateInputValue("")
		console.log(input);
		let d1 = new Date(input.d1).getTime()/1000;
		let d2 = new Date(input.d2).getTime()/1000;
		console.log(d1);
		console.log(d2);
	}
	
	/* set customer info scope & control */
	$scope.customer = {
		masterList: $customers,
		detail: {
			name: "",
			address: {
				addr:"",
				subdistrict:"",
				district:"",
				province:"",
				postcode:""
			},
			phone: "",
			taxId: ""
		},
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = typeof c.address == "string" ? {addr:c.address, subdistrict:"", district:"", provice:"", postcode:""} : c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};

	/* invoice's item list scope & control */
	$scope.item = {
		list: {
			"1": {},
			"2": {},
			"3": {},
			"4-1": {},
			"4-2-1-1": {},
			"4-2-1-2": {},
			"4-2-1-3": {},
			"4-2-1-4": {},
			"4-2-2-1": {},
			"4-2-2-2": {},
			"4-2-2-3": {},
			"4-2-2-4": {},
			"4-2-2-5": {},
			"5": {},
			"6": {}
		}
	};
	/* set invoice scope & control */
	$scope.invoice = {
		summary: {
			form: FORM_TYPE,
			reference: "",
			//book_number:  new Date().getFullYear(),
			number: getRunningNumber(userDefault, FORM_TYPE),
			date: new Date().toDateInputValue(""),
			payer: {
				name: COMPANY.name,
				address: getAddressLine(COMPANY.address),
				tax_id11: "",
				tax_id13: COMPANY.tax_id
				
			},
			payee: {
				name: "",
				address: "",
				tax_id11: "",
				tax_id13: ""
			},
			user: {
				name: USER.fullName		
			},
			net_paid: "0.00",
			net_deducted: "0.00",
			fund: {
				government_pension: "",
				social_security: "",
				retirement: ""
			},
			paid_option: {
				index: "",
				etc: ""
			},
			attachment: {
				index: "",
				document: 0
			},
			comment: "",
			print: {
				logo: userDefault.logo,
				signature: userDefault.signature,
				stamp: userDefault.stamp,
				print_as_set: userDefault.print_as_set,
				print_header: userDefault.header_id
			}			
		},
		updateSummary: function(list){
			//get sum item (subtotal)
			var net_paid = this.sumItemList(list,"paid");
			var net_deducted = this.sumItemList(list,"deducted");
			this.summary.net_paid = net_paid;
			this.summary.net_deducted = net_deducted;
		},
		sumItemList: function(list,type){
			var result = 0; 
			//console.log(list);
			//sum every items in item list
			for(let i in list){ 
				;
				if(typeof list[i][type] !== "undefined" && list[i][type] != "" ){
					result += parseFloat(list[i][type]);
				}
			}
			return result.toFixed(2);
		},
		save: function(){
			var vm = this;
			var jsonDat = {
				type: "expense_documents",
				summary: this.summary,
				itemList: $scope.item.list,
				//customer: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			console.log(jsonDat);
			$scope.ajaxProcessing = true;
			$dbService.insertInvoice(jsonDat).then(
				//on success
				function(dat){
					vm.updateInvoiceIndex(FORM_TYPE, getInvoiceIndex());
					$scope.ajaxProcessing = false;
					$state.go('invoice-expense-manage',{
						form: FORM_TYPE
					});
				}
				//on errors
				,function(err){console.log(err);$scope.ajaxProcessing = false;});
		},
		updateInvoiceIndex: function(form,used_number){
			$dbService.updateInvoiceIndex(form,used_number).then(
				function(){},
				function(err){alert(err);});
		}
	};
	
	$scope.ui = {
		printPreview: function(input){
			let obj = {
				//type: "expense_documents",
				summary:  $scope.invoice.summary,
				item_list: $scope.item.list,
				customer_detail: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			
			let	json_dat = JSON.stringify(obj);
			//let target =  window.location.origin + "/mcf_merged/docs/preview?json_dat="+json_dat;
			let target =  window.location.origin + "/docs/preview/expense/"+FORM_TYPE;

			let mapForm = document.createElement("form");
			mapForm.target = "preview";
			mapForm.method = "POST";
			mapForm.action = target;
		
			let mapInput = document.createElement("input");
			mapInput.type = "hidden";
			mapInput.name = "jsonDat";
			mapInput.value = json_dat;
			mapForm.appendChild(mapInput);
		
			document.body.appendChild(mapForm);
		
			map = window.open("", "preview", "fullscreen=yes");
			if (map) {
				mapForm.submit();
			} else {
				alert('You must allow popups for this map to work.');
			}
			//$window.open(target, '_self');
			//$window.open(target,'','fullscreen=yes');
			//console.log(formData);
		}
	};	
	
	function getDiscount(subtotal,input) {
		if(input.indexOf("%") > -1){
			let rate = input.slice(0,input.length-1);
			var discount =  ((subtotal * rate) / 100 ).toFixed(2);
		} else {
			var discount = input;
		}
		return discount;			
	}
		
	/* get invoice header */
	function getRunningNumber(configs,form){
		//console.log(configs);console.log(form);
		var formConfig = configs.document_configs[form];
		var digits = formConfig.auto_increment.length;
		var zeros = '00000000';
		var runningNumber = formConfig.last_used_id != "" ? ( zeros+(parseInt( formConfig.last_used_id ) + 1)).slice(-1*digits) : formConfig.auto_increment ;
		//var result;
		switch(configs.header_number_id){
			case 0:
			default:
				return formConfig.prefix + runningNumber;
				break;
			case 1:
			case 2:
				return formConfig.prefix + formConfig.middle + runningNumber;
				break;
		}
	}
	
	/* get invoice header's number */
	function getInvoiceIndex(){
		var runningNumber = $scope.invoice.summary.number;
		var index = runningNumber.replace(/[^0-9\.]/g, '');
		return index;
	}
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}
	
	function getAddressLine(input){
		let type = typeof input;
		let key = ["addr", "subdistrict", "district", "province", "postcode"];
		if(type == "array" || type == "object"){
			let output = "";
			for(let i in key){
				output += input[key[i]] ? input[key[i]]+" " : "";
			}
			return output;
		} else {
			return input;
		}
		
	}
	
});
