angular.module('MetronicApp').controller('InvoiceExpenseCtrl', function($rootScope, $scope, $state, settings, $http, userDefault) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();

        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
    });	
	
	$scope.forms = serializeForms(userDefault);
	$scope.ui = {
		goAdd: function(key,value){
			$state.go('invoice-add',{
				form: key,
				pageSubtitle: $scope.forms[key].title
			});
		},
		goEdit: function(key,value){
			$state.go('invoice-manage',{
				form: key
			});
		}
	};
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}
});