angular.module('MetronicApp').controller('InvoiceExpenseEditCtrl.withholding_form', function(
	$rootScope,
	$scope,
	$state,
	$stateParams,
	settings,
	$http,
	filterFilter,
	multiFieldsFilter,
	$dbService,
	$allItems,
	$customers,
	userDefault,
	invoiceConfigs,
	rcvMenus,
	invoiceData
){
    $scope.$on('$viewContentLoaded', function() {   
        /* initialize core components */
        App.initAjax();
	
        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		
		//setTimeout(function(){ initAnguComplete(); }, 500);
		
		console.log(invoiceData);
    });
	
	/* set global constants */
	const FORM_TYPE = $stateParams.form;
	const TYPE = $stateParams.type;
	const USER = $scope.sessionUserData;
	const FORM = serializeForms(userDefault)[FORM_TYPE]; //console.log(FORM);
	$state.current.data.pageTitle = "แก้ไข"+ FORM.title;
	/* set form display conditional parameters */
	$scope.form = {
		//WHT: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false,
		//VAT: userDefault.VAT_active ? true : false,
		//note: FORM_TYPE == 'invoice' ? true : false,
		//CFO: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false
	};	
	
	
	/* set customer info scope & control */
	$scope.customer = {
		masterList: $customers,
		detail: invoiceData.customer_detail,
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = typeof c.address == "string" ? {addr:c.address, subdistrict:"", district:"", province:"", postcode:""} : c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};	
	
	
	/* set item list scope & control */
	$scope.item = {
		list: invoiceData.item_list
	};
	
	/* set invoice scope & control */
	$scope.invoice = {
		summary: invoiceData.summary,
		updateSummary: function(list){
			//get sum item (subtotal)
			var net_paid = this.sumItemList(list,"paid");
			var net_deducted = this.sumItemList(list,"deducted");
			this.summary.net_paid = net_paid;
			this.summary.net_deducted = net_deducted;
		},
		sumItemList: function(list,type){
			var result = 0; 
			//console.log(list);
			//sum every items in item list
			for(let i in list){ 
				;
				if(typeof list[i][type] !== "undefined" && list[i][type] != ""){
					result += parseFloat(list[i][type]);
				}
			}
			return result.toFixed(2);
		},
		save: function(){
			var vm = this;
			var jsonDat = {
				type: "expense_documents",
				summary: this.summary,
				itemList: $scope.item.list,
				//customer: $scope.customer.detail,
				mongoId: $stateParams.mongoId,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			$scope.ajaxProcessing = true;
			var formData = new FormData();
			formData.append('jsonData', JSON.stringify(jsonDat));
			$dbService.editInvoice(formData).then(
				//on success
				function(dat){
					//console.log(dat.data);
					// vm.updateInvoiceIndex(FORM_TYPE, getInvoiceIndex());
					// if($scope.form.CFO){
						// vm.saveCashflow(jsonDat.summary);
					// }
					$scope.ajaxProcessing = false;
					$state.go('invoice-expense-manage',{
						form: FORM_TYPE
					});					
				}
				//on errors
				,function(err){console.log(err);$scope.ajaxProcessing = false;});
		},
		/*saveCashflow: function(tran){
			$dbService.newTran(tran.cashflow.mcf_id, tran.cashflow.mcf_sub_id,tran.date,tran.total,'rcv','cfo',"",-1,USER.userId,USER.userName).then(
				function(){},
				function(err){alert(err);});
		}, */
		updateInvoiceIndex: function(form,used_number){
			$dbService.updateInvoiceIndex(form,used_number).then(
				function(){},
				function(err){alert(err);});
		}		
	};
	
	$scope.ui = {
		printPreview: function(input){
			let obj = {
				//type: "expense_documents",
				summary:  $scope.invoice.summary,
				item_list: $scope.item.list,
				customer_detail: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			
			let	json_dat = JSON.stringify(obj);
			// let target =  window.location.origin + "/mcf_merged/docs/preview?json_dat="+json_dat;
			let target =  window.location.origin + "/docs/preview/expense/"+FORM_TYPE;

			let mapForm = document.createElement("form");
			mapForm.target = "preview";
			mapForm.method = "POST";
			mapForm.action = target;
		
			let mapInput = document.createElement("input");
			mapInput.type = "hidden";
			mapInput.name = "jsonDat";
			mapInput.value = json_dat;
			mapForm.appendChild(mapInput);
		
			document.body.appendChild(mapForm);
		
			map = window.open("", "preview", "fullscreen=yes");
			if (map) {
				mapForm.submit();
			} else {
				alert('You must allow popups for this map to work.');
			}
			//$window.open(target, '_self');
			//$window.open(target,'','fullscreen=yes');
			//console.log(formData);
		}
	};		
	
	/* get invoice header */
	function getRunningNumber(configs,form){
		//console.log(configs);console.log(form);
		var formConfig = configs.document_configs[form];
		var digits = formConfig.auto_increment.length;
		var zeros = '00000000';
		var runningNumber = formConfig.last_used_id != "" ? ( zeros+(parseInt( formConfig.last_used_id ) + 1)).slice(-1*digits) : formConfig.auto_increment ;
		//var result;
		switch(configs.header_number_id){
			case 0:
			default:
				return formConfig.prefix + runningNumber;
				break;
			case 1:
			case 2:
				return formConfig.prefix + formConfig.middle + runningNumber;
				break;
		}
	}
	
	/* get invoice header's number */
	function getInvoiceIndex(){
		var runningNumber = $scope.invoice.summary.number;
		var index = runningNumber.replace(/[^0-9\.]/g, '');
		return index;
	}
	
	/* get discount amount */
	function getDiscountAmount(subtotal,discount){
		let sign =  discount.substr(discount.length-1);
		let number = discount.slice(0,discount.length-1);
		let isRate = (sign === "%");
		
		if(isRate){
			return ((subtotal * number) / 100).toFixed(2);
		} else {
			return (parseFloat(discount)).toFixed(2);
		}
		
				// if(isNaN(discount) && !isRate){
					// return "0.00";
				// } else {
					// return isRate ?  ((subtotal * number) / 100).toFixed(2) : (parseFloat(discount)).toFixed(2);
				// }		
	}
	
	/* set autocomplete input value */
	function initAnguComplete(){
		/* angucomplete-alt change-input does not work by programmed triggered!!! */
		//$scope.$broadcast('angucomplete-alt:changeInput','customerInfo','hello');
		//$('#customerInfo_value').val(invoiceData.customer_detail.name);
		//$scope.$broadcast('angucomplete-alt:changeInput', 'customerInfo', invoiceData.customer_detail.name);
/* 		// for (prop in $scope.item.list){
			// let inputId = "#item_"+prop+"_value";
			$scope.$broadcast('angucomplete-alt:changeInput', inputId, $scope.item.list[prop].name);
			// $(inputId).val($scope.item.list[prop].name);
		// } */
	}
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}		
});
