angular.module('MetronicApp').controller('InvoiceExpenseManageCtrl.withholding_form', function(
	$rootScope, 
	$scope,
	$state,
	$window,
	settings,
	$http, 
	multiFieldsFilter, 
	$dbService, 
	$stateParams, 
	$invoices,
	userDefault
) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();

        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
		//console.log($invoices);
    });
	var FORM = serializeForms(userDefault)[$stateParams.form];
	$state.current.data.pageTitle = "จัดการ"+FORM.title;
	$scope.masterList = $invoices;
	$scope.form = {
		title: FORM.title
	};
	
	$scope.invoice;
	
	$scope.ui = {
		editInvoice: function(objectID,invoiceId){
			$state.go('invoice-expense-edit',{
				form: $stateParams.form,
				mongoId: objectID.$oid,
				invoiceId: invoiceId
			});
		},
		printInvoice: function(input){
			let target =  window.location.origin + "/docs/expense?FORM="+$stateParams.form+"&MID="+input.$oid;
			$window.open(target, '_blank');
		},
		promptDelete: function(invoice){
			$scope.invoice = invoice;
			$('#form_delete').modal({
				backdrop: 'static',
				show : 'true'
			});
		},		
		deleteinvoice: function(invoice){
			console.log(invoice);
			let jsonDat = {
				mongoId: invoice._id.$oid,
				type: 'expense_documents',
				user: {
					mcf_user_id: $scope.sessionUserData.userId,
					user_name: $scope.sessionUserData.userName
				}
			};
			$dbService.deleteInvoice(jsonDat).then(function(dat){
				//console.log(dat.data);
				if(dat.data.success){
					$dbService.getInvoice('expense_documents', invoice.summary.form).then(function(dat2){
						$scope.masterList = dat2.data;
						//console.log(dat2.data);
					});
				}
			});
		}	
	};
	//table sorting params
	$scope.sortKey = 'date';
	$scope.reverse = false;
	//Table handler
	$scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.masterList.length
            ,maxPage:  Math.ceil($scope.masterList.length/5)
			,searchFields: ["summary.number","summary.net_deducted_int","summary.date","last_update_user","summary.payee.name"]
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.masterList.length,name:"All"}
        ],
		searchString: "",
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchList.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.masterList.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        },
		//For catagories filter
        // filter: function(mcf_id){
            // if(mcf_id>0){
                // $scope.filterTrans = filterFilter($scope.expTrans,{lv2_id:mcf_id});
            // }else{
                // $scope.filterTrans = $scope.expTrans;
            // }
            // this.refresh();
        // },
        refresh: function(){
            this.config.curPage = 1;
            this.config.records = $scope.masterList.length;
            this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
        }
    };
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}	
	
});