angular.module('MetronicApp').controller('InvoiceHistoryCtrl', function($rootScope, $scope, settings, $http, multiFieldsFilter, $dbService, $allItems, $allAccounts) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();

        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
        //$scope.orgLv1Menu = ($scope.params.lv1Menu == "cfo" || $scope.params.lv1Menu == "cfi" || $scope.params.lv1Menu == "cff" ) ? $scope.params.lv1Menu : "cfo";
        //$scope.orgMenuType = ($scope.params.menuType == "rcv" || $scope.params.menuType == "exp" ) ? $scope.params.menuType : "rcv" ;
        //$scope.menuDesc = { "cfo" : "ดำเนินการ", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };     
		
		////
    });
	//Date Format
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	
	//customer info control
	$scope.customer = {
		masterList: $allAccounts,
		detail: {
			name: "",
			address: "",
			phone: "",
			taxId: ""
		},
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};
	
	//invoice's item list control
	$scope.item = {
		dummy: {
			item_id: "",
			name: "",
			description: "",
			unit_price: "0.00",
			number: "",
			qty: 0,
			subtotal: "0.00",
			discount: "0.00",
			total: "0.00"
		},
		list: [],
		masterList: $allItems,
		addToList: function(input){
			//copy then push
			var copy = $.extend(true, {}, input);
			this.list.push(copy);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		removeFromList: function(i){
			//remove item
			this.list.splice(i, 1);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		selected: function(input,index){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var obj = input.originalObject; 
			$scope.item.autoFill(obj,index);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.item.list[i].name = name;
		},
		autoFill: function(obj,i){
			//update row data
			this.list[i].item_id = obj.item_id;
			this.list[i].name = obj.name;
			this.list[i].description = obj.description;
			this.list[i].unit_price = obj.unit_price;
			this.list[i].number = obj.number;
			this.list[i].qty = 1;
			this.list[i].subtotal = obj.unit_price;
			//this.list[i].discount = "0.00";
			this.list[i].total = obj.unit_price;
			//sum invoice
			this.pricing(i);
			$scope.invoice.updateSummary(this.list);
		},
		pricing: function(i){
			//sum item
			this.list[i].subtotal = parseInt(this.list[i].qty) * parseFloat(this.list[i].unit_price);
			this.list[i].total = parseFloat(this.list[i].subtotal) - parseFloat(this.list[i].discount);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		}
	};
	//invoice control
	$scope.invoice = {
		summary: {
			number: "HS00000001",
			date: new Date().toDateInputValue(""),
			user:"",
			subtotal: "0.00",
			discount: "0.00",
			vatType: "0",
			vatRate: 0.07,
			VAT: "0.00",
			total: "0.00"
		},
		vatType: [
			{id:0, title:"ไม่มี VAT"},
			{id:1, title:"แยก VAT"},
			{id:2, title:"รวม VAT"}
		],
		updateSummary: function(list){
			//get sum item 
			var sum = this.sumItemList(list);
			//get all amounts
			var amount = this.getAmount(sum);
			//update invoice amount
			this.summary.subtotal = amount.subtotal;
			this.summary.VAT = amount.VAT;
			this.summary.total = amount.total;
		},
		sumItemList: function(list){
			var result = 0;
			//sum every items in item list
			for(i=0; i<list.length; i++){
				result += parseFloat(list[i].total);
			}
			return result;
		},
		getAmount: function(input){
			var subtotal = parseFloat(input);
			var result = {};
			switch(this.summary.vatType) {
				case "0":
				default: 
					result.subtotal = subtotal;
					result.VAT = "0.00";
					result.total = subtotal - parseFloat(this.summary.discount);
					break;
				case "1":
					result.subtotal = subtotal;
					result.VAT = subtotal * this.summary.vatRate;
					result.total = (subtotal + result.VAT) - parseFloat(this.summary.discount);
					break;
				case "2":
					result.subtotal = subtotal / (1 + this.summary.vatRate);
					result.VAT = subtotal - result.subtotal;
					result.total = subtotal;
					break;
			}
			return result;
		},
		save: function(){
			var jsonDat = {
				summary: this.summary,
				itemList: $scope.item.list,
				customer: $scope.customer.detail,
				user: { 
					mcf_user_id: $scope.sessionUserData.userId,
					user_name: $scope.sessionUserData.userName
				}
			//
			};
			$dbService.insertInvoice(jsonDat).then(function(dat){console.log(dat);});
		}
	};
	
	//init first item.list row
	$scope.item.addToList($scope.item.dummy);
	
	
	
});