angular.module('MetronicApp').controller('InvoiceIncomeAddCtrl', function(
	$rootScope,
	$scope,
	$state,
	$window,
	$stateParams,
	settings,
	$http,
	filterFilter,
	multiFieldsFilter,
	$dbService,
	$allItems,
	$customers,
	userDefault,
	invoiceConfigs,
	rcvMenus,
	$referList,
	$mathService
) {
    $scope.$on('$viewContentLoaded', function() {   
        /* initialize core components */
        App.initAjax();
        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		// console.log($scope.invoice.summary);
		setTimeout(function(){
			$('.date-picker').datepicker({
				endDate : '0',
				language: 'th',
				format: 'dd-mm-yyyy',
				rtl: App.isRTL(),
				orientation: "left",
				autoclose: true
			})
		},2000);								 
    });
	/* set global constants */
	const FORM_TYPE = $stateParams.form;
	const FORM = serializeForms(userDefault)[FORM_TYPE];
	//const FORM_SUBTITLE = $stateParams.pageSubtitle;
	const USER = $scope.sessionUserData;
	const CFO_MENUS = filterFilter(rcvMenus,{lv1_menu:"cfo", form_type: 1}); /* set CFO menus, exclude from type 2 */
	$state.current.data.pageTitle = "เพิ่ม"+ FORM.title;
	
	/* set form display conditional parameters */
	$scope.form = {
		title: "เพิ่ม"+ FORM.title,
		// WHT: FORM_TYPE == 'receipt' ? true : false,
		WHT: invoiceConfigs.whtList.indexOf(FORM_TYPE) > -1 ? true : false,
		VAT: userDefault.VAT_active ? true : false,
		itemVAT: userDefault.VAT_active && userDefault.VAT_item_type ? true : false,
		//itemVAT: true,
		reference: FORM_TYPE == 'receipt' || FORM_TYPE == 'delivery_note' || FORM_TYPE == 'invoice' ? true : false,
		CFO: FORM_TYPE == 'receipt' ? true : false,		
		payment: FORM_TYPE == 'receipt' ? true : false,
		warningMessage: FORM_TYPE == 'pre_receipt' ? true : false
	};
	
	/* set the cashflow-related scope */
	$scope.cashflow = {
		menus: CFO_MENUS,
		subMenus: CFO_MENUS[0].lv3,
		selectMenu: function(id){
			var menu = filterFilter(rcvMenus,{mcf_id: id}); 
			this.subMenus = menu[0].lv3;
		}
	};
	
	/* Date Format */
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});

	/* set customer info scope & control */
	$scope.customer = {
		masterList: $customers,
		detail: {
			name: "",
			address: {
				addr:"",
				subdistrict:"",
				district:"",
				province:"",
				postcode:""
			},
			phone: "",
			taxId: ""
		},
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = typeof c.address == "string" ? {addr:c.address, subdistrict:"", district:"", province:"", postcode:""} : c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};

	/* set reference invoice list scope & control */
	$scope.reference = {
		masterList: $referList,
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject;
			//console.log(c);
			$scope.reference.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			//var i = this.$parent.$index;
			//console.log(i);
			//$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			//console.log(c);
			
			/* add item list */
			$scope.item.list = c.item_list;
			setTimeout(function(){
				for(var i in c.item_list){
					let inputId = "#item_" + i +"_value";
					$(inputId).val(c.item_list[i].name);
				}
			}, 500); 
			/* add customer detail */
			$scope.customer.detail = c.customer_detail;
			$scope.$broadcast('angucomplete-alt:changeInput', 'customerInfo', c.customer_detail.name);
			
			/* add invoice summary */
			$scope.invoice.summary.vatType = c.summary.vatType;
			// $scope.invoice.summary.print = c.summary.print;
			$scope.invoice.summary.print = {
				logo: userDefault.logo,
				signature: userDefault.signature,
				stamp: userDefault.stamp,
				print_as_set: userDefault.print_as_set,
				print_header: userDefault.header_id
			};
			$scope.invoice.summary.discountInput = c.summary.discountInput;
			$scope.invoice.summary.withWHT = c.summary.withWHT;
			$scope.invoice.updateSummary($scope.item.list);
			
			/* update reference number  */
			$scope.invoice.summary.reference.number = c.summary.number;
			$scope.invoice.summary.reference.mongoId = c._id.$oid;
			//console.log($scope.invoice.summary);
		}
	};
	
	/* invoice's item list scope & control */
	$scope.item = {
		dummy: {
			item_id: "",
			name: "",
			description: "",
			unit_price: "0.00",
			//number: "",
			qty: 0,
			subtotal: "0.00",
			discount: "0.00",
			discountInput: "0.00",
			total: "0.00",
			doVAT: false
		},
		list: [],
		masterList: $allItems,
		addToList: function(input){
			//copy then push
			var copy = $.extend(true, {}, input);
			this.list.push(copy);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		removeFromList: function(i){
			//remove item
/* 			console.log(i);
			console.log($scope.item.list);
			return; */
			this.list.splice(i, 1);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		selected: function(input,index){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var obj = input.originalObject; 
			$scope.item.autoFill(obj,index);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.item.list[i].name = name;
		},
		autoFill: function(obj,i){
			//update row data
			this.list[i].item_id = obj.item_id;
			this.list[i].name = obj.name;
			this.list[i].description = obj.description;
			this.list[i].unit_price = obj.unit_price_int;
			//this.list[i].number = obj.number;
			this.list[i].qty = 1;
			this.list[i].subtotal = obj.unit_price_int;
			this.list[i].doVAT = typeof obj.doVAT == 'undefined' ? false : obj.doVAT;
			this.list[i].total = obj.unit_price;
			//sum invoice
			this.pricing(i);
			$scope.invoice.updateSummary(this.list);
		},
		pricing: function(i){
			//sum item
			this.list[i].subtotal = ( this.list[i].qty * this.list[i].unit_price ).toFixed(2);
			this.list[i].discount = getDiscount(this.list[i].subtotal,this.list[i].discountInput);
			this.list[i].total = (this.list[i].subtotal - this.list[i].discount).toFixed(2);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		}
	};
	/* set invoice scope & control */
	$scope.invoice = {
		summary: {
			form: FORM_TYPE,
			reference: {
				number: "",
				mongoId: ""
			},
			number: getRunningNumber(userDefault, FORM_TYPE),
			date: new Date().toDateInputValue(""),
			user: USER.fullName,
			subtotal: "0.00",
			discount: "0.00",
			discountInput: "0.00",
			vatType:  userDefault.VAT_active  ? invoiceConfigs.vatType[0].id.toString() : "0",
			itemVAT: $scope.form.itemVAT,
			vatRate: invoiceConfigs.vatRate,
			VAT: "0.00",
			withWHT: false,
			whtRate: invoiceConfigs.whtRate,
			WHT: "0.00",
			total: "0.00",
			amountToPay: "0.00",
			note: "",
			comment: "",
			cashflow: {
				mcf_id: $scope.cashflow.menus[0].mcf_id ,
				mcf_sub_id: $scope.cashflow.subMenus[0].mcf_sub_id,
				date: new Date().toDateInputValue("")
			},
			print: {
				logo: userDefault.logo,
				signature: userDefault.signature,
				stamp: userDefault.stamp,
				print_as_set: userDefault.print_as_set,
				print_header: userDefault.header_id
			},
			payment: {
				cash: {
					active: false
				},
				transfer: {
					active: false,
					bank_name: "",
					account_number: ""
				},
				cheque: {
					active: false,
					bank_name: "",
					cheque_number: ""
				}
			}
		},
		vatType: invoiceConfigs.vatType,
		whtRateOptions: invoiceConfigs.whtRateOptions,
		updateSummary: function(list){
			//get sum item (subtotal)
			let itemVAT = $scope.form.itemVAT
			var sum = this.sumItemList(list, itemVAT);
			//get all amounts e.g. subtotal, vat, total
			var amount = this.getAmount(sum);
			//update invoice amount
			this.summary.subtotal = amount.subtotal;
			this.summary.VAT = amount.VAT;
			this.summary.total = amount.total;
			this.summary.WHT = amount.WHT;
			this.summary.amountToPay = amount.amountToPay;
		},
		sumItemList: function(list, itemVAT){
			//sum every items in item list
			//for itemVAT options
			var result;
			if(itemVAT){
				// result[0] = noVAT, result[1] = doVAT
				result = [0,0];
				for(i=0; i<list.length; i++){
					if(list[i].doVAT){
						result[1] += parseFloat(list[i].total);
					} else {
						result[0] += parseFloat(list[i].total);
					}
				}
			} else {
				//for not itemVAT options
				result = 0;
				for(i=0; i<list.length; i++){
					result += parseFloat(list[i].total);
				}
			}
			return result;
		},
		getAmount: function(input){ 
			let itemVAT = typeof input == "object" ? true : false;
			var subtotal = itemVAT ? [parseFloat(input[0]), parseFloat(input[1])] : parseFloat(input);
			var result = {};
			//console.log(subtotal);
			/* calculate subtotal, vat, total by vatType condition */
			switch(this.summary.vatType) {
				/* No VAT */
				case "0":
				default: 
					// result.subtotal = subtotal.toFixed(2);
					this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
					// result.total = ( subtotal - parseFloat(this.summary.discount) ).toFixed(2);
					result.subtotal = ( subtotal - parseFloat(this.summary.discount) ).toFixed(2);
					result.total = result.subtotal;
					result.VAT = "0.00";
					result.WHT = this.getWHT(this.summary.withWHT, result.subtotal);					
					result.amountToPay = result.total - result.WHT;
					break;
				/* VAT excluded */
				case "1":
					if(itemVAT){
						// result.subtotal = [
							// subtotal[0].toFixed(2),
							// subtotal[1].toFixed(2)
							// ];
						let absSubtotal = (subtotal[0] + subtotal[1]);
						this.summary.discount = getDiscount(absSubtotal, this.summary.discountInput);
						let absSubtotalAfterDiscount = absSubtotal - this.summary.discount;
						result.subtotalAfterDiscount = [
							this.summary.discount > 0 ? subtotal[0] * $mathService.notZeroDevision(absSubtotalAfterDiscount, absSubtotal) : subtotal[0],
							this.summary.discount > 0 ? subtotal[1] * $mathService.notZeroDevision(absSubtotalAfterDiscount, absSubtotal) : subtotal[1]
						];
						result.subtotal = result.subtotalAfterDiscount;
						result.VAT = ( $mathService.notZeroDevision( result.subtotalAfterDiscount[1] * this.summary.vatRate, 100 ) ).toFixed(2);
						result.WHT = this.getWHT(this.summary.withWHT, absSubtotal); 
						result.total = ( parseFloat(result.subtotalAfterDiscount[0]) + parseFloat(result.subtotalAfterDiscount[1]) + parseFloat(result.VAT) ).toFixed(2);
						result.amountToPay = result.total - result.WHT;
					} else {
						// result.subtotal = subtotal.toFixed(2);
						this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
						result.subtotalAfterDiscount = subtotal - parseFloat(this.summary.discount);
						result.subtotal = result.subtotalAfterDiscount;
						//result.subtotal = result.subtotalAfterDiscount;
						result.VAT = ( $mathService.notZeroDevision( result.subtotalAfterDiscount * this.summary.vatRate, 100 ) ).toFixed(2);
						result.WHT = this.getWHT(this.summary.withWHT, result.subtotalAfterDiscount); 
						result.total = ( parseFloat(result.subtotalAfterDiscount) + parseFloat(result.VAT) ).toFixed(2);
						result.amountToPay = result.total - result.WHT;
						console.log(result);
					}
					break;
				/* VAT included */
				case "2":
					if(itemVAT) {
						/* backup */
						// let absTotal = (subtotal[0] + subtotal[1]);
						// result.total = absTotal.toFixed(2);
						// result.subtotalAfterDiscount = [
							// subtotal[0].toFixed(2),
							// (subtotal[1] * 100 / 107 ).toFixed(2)
						// ];
						// result.VAT = (result.total - result.subtotalAfterDiscount[0] - result.subtotalAfterDiscount[1]).toFixed(2);
						// result.absSubtotalAfterDiscount = parseFloat( result.subtotalAfterDiscount[0] ) + parseFloat( result.subtotalAfterDiscount[1] );
						// result.absSubtotal = getSubtotal(result.absSubtotalAfterDiscount, this.summary.discountInput);
						// this.summary.discount = result.absSubtotal - result.absSubtotalAfterDiscount;
						// result.subtotal = [
							// this.summary.discount > 0 ? ((result.subtotalAfterDiscount[0] * result.absSubtotal) / (result.absSubtotal - this.summary.discount)).toFixed(2) : result.subtotalAfterDiscount[0],
							// this.summary.discount > 0 ? ((result.subtotalAfterDiscount[1] * result.absSubtotal) / (result.absSubtotal - this.summary.discount)).toFixed(2) : result.subtotalAfterDiscount[1]
						// ];
						// result.WHT = this.getWHT(this.summary.withWHT, result.absSubtotal);
						/* revision round3 */
						var absTotal = (subtotal[0] + subtotal[1]);
						this.summary.discount = getDiscount(absTotal, this.summary.discountInput);
						var absTotalAfterDiscount = absTotal - this.summary.discount;
						result.total = absTotalAfterDiscount.toFixed(2);
						// result.subtotal = [
							// subtotal[0].toFixed(2),
							// subtotal[1].toFixed(2)
						// ];
						var vatBase = subtotal[1] - ( $mathService.notZeroDevision( subtotal[1], absTotal ) * this.summary.discount );
						var nonVatBase = subtotal[0] - ( $mathService.notZeroDevision( subtotal[0], absTotal ) * this.summary.discount );
						result.VAT = ( vatBase * $mathService.notZeroDevision(this.summary.vatRate, (this.summary.vatRate + 100) ) );
						result.subtotal = [
							nonVatBase.toFixed(2),
							(vatBase - result.VAT).toFixed(2),
						];
						result.WHT = this.getWHT( this.summary.withWHT, (vatBase - result.VAT) );
						result.amountToPay = result.total - result.WHT;
					} else {
						/* backup */
						// result.total = (subtotal).toFixed(2);
						// result.subtotalAfterDiscount = ( (result.total * 100 ) / 107 ).toFixed(2);
						// result.subtotal = getSubtotal(result.subtotalAfterDiscount, this.summary.discountInput);					
						// this.summary.discount = result.subtotal - result.subtotalAfterDiscount;
						// result.VAT = (result.total - result.subtotalAfterDiscount).toFixed(2);
						// result.WHT = this.getWHT(this.summary.withWHT, result.subtotal);
						/* revision round3 */
						this.summary.discount = getDiscount(subtotal, this.summary.discountInput);
						var absTotalAfterDiscount = subtotal - this.summary.discount;
						result.total = (absTotalAfterDiscount).toFixed(2);
						// result.subtotal = subtotal.toFixed(2);
						//var vatBase = absTotalAfterDiscount * (100 - this.summary.vatRate);
						result.VAT = ( $mathService.notZeroDevision( (absTotalAfterDiscount * this.summary.vatRate), (this.summary.vatRate + 100) ) ).toFixed(2);
						result.subtotal = ( absTotalAfterDiscount - result.VAT).toFixed(2);
						result.WHT = this.getWHT( this.summary.withWHT, (absTotalAfterDiscount - result.VAT) );
						result.amountToPay = result.total - result.WHT;
					}
					break;
			}
			
			return result;
		},
		getWHT: function(flag,subtotal){
			if(flag){
				return ( subtotal * this.summary.whtRate / 100 ).toFixed(2);
			} else {
				return "0.00";
			}
		},
		save: function(){
			var vm = this;
			var jsonDat = {
				type: "income_documents",
				summary: this.summary,
				itemList: $scope.item.list,
				customer: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			}; //console.log(jsonDat);return;
			$scope.ajaxProcessing = true;
			$dbService.insertInvoice(jsonDat).then(
				//on success
				function(dat){
					vm.updateInvoiceIndex(FORM_TYPE, getInvoiceIndex());
					/* auto add new items if any */
					let itemsToAdd = getNewItems(jsonDat.itemList);
					if(itemsToAdd.length > 0){
						vm.saveNewItems(itemsToAdd);
					}
					/* auto add new customer  */
					let customerToAdd = getNewCustomer(jsonDat.customer);
					if(customerToAdd){
						vm.saveNewCustomer(customerToAdd);
					}
					/* add receivings trans  */
					if($scope.form.CFO){
						vm.saveCashflow(jsonDat.summary, dat.data.inserted_id['$oid']);
					}
					/* marked reference invoice used if any */
					// if(vm.summary.reference.number.length > 0 && FORM_TYPE == "receipt"){
					if(vm.summary.reference.number.length > 0){
						vm.markReferrer(vm.summary);
					}
					$scope.ajaxProcessing = false;
					$state.go('invoice-income-manage',{
						form: FORM_TYPE
					});
				}
				//on errors
				,function(err){console.log(err);$scope.ajaxProcessing = false;});
		},
		saveCashflow: function(tran, doc_id){
			let user_id = USER.userId;
			let user_name = USER.userName;
			let tranTotal = tran.withWHT ? tran.amountToPay : tran.total ;
			let comment = "เป็นการบันทึกรายรับรวม ณ วันที่ "+ tran.cashflow.date + " เอกสารอ้างอิงเลขที่: " + tran.number;
			//$dbService.newTran(tran.cashflow.mcf_id, tran.cashflow.mcf_sub_id,tran.cashflow.date,tran.total,'rcv','cfo',"",-1,USER.userId,USER.userName).then(
			$dbService.newTran(tran.cashflow.mcf_id, tran.cashflow.mcf_sub_id,tran.cashflow.date,tranTotal,'rcv','cfo',comment,-1,user_id,user_name).then(
				function(dat){
					var trans_id = dat.data.inserted_id['$oid'];
					$dbService.updateInvoiceTransInfo("income_documents", doc_id, trans_id).then(
						function(dat2){console.log(dat2);},
						function(err){console.log(err);});
				},
				function(err){alert(err);});
		},
		saveNewItems: function(list){
			let user = {
				mcf_user_id: USER.userId,
				user_name: USER.userName
			};
			let jsonDat = {
				items : list,
				user: user
			};
			$dbService.bulkInsertInvoiceItem(jsonDat).then(
				function(dat){console.log(dat.data);},
				function(err){});
		},
		saveNewCustomer: function(customer){
			let jsonDat = {
				menu_type: 'rcv',
				customer_detail: customer,
				user_id: USER.userId,
				user_name: USER.userName
			};
			$dbService.addAccount(jsonDat).then(
				function(dat){console.log(dat);},
				function(err){console.log(err);vm.clear($scope.customerDetail);});
		},		
		updateInvoiceIndex: function(form,used_number){
			$dbService.updateInvoiceIndex(form,used_number).then(
				function(){},
				function(err){alert(err);});
		},
		markReferrer: function(summary){
			let ref_id = summary.reference.mongoId;
			let ref_number = summary.reference.number;
			let ref_by = summary.number;
			$dbService.updateInvoiceReferrer(ref_id, ref_number, ref_by).then(
				function(dat){},
				function(err){alert(err);});
		}
	};
	
	
	$scope.ui = {
		printPreview: function(input){
			let obj = {
				type: "income_documents",
				summary:  $scope.invoice.summary,
				item_list: $scope.item.list,
				customer_detail: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			
			let	json_dat = JSON.stringify(obj);
			// let target =  window.location.origin + "/mcf_merged/docs/preview?json_dat="+json_dat;
			let target =  window.location.origin + "/docs/preview/income/"+FORM_TYPE;
			console.log(target);

			let mapForm = document.createElement("form");
			mapForm.target = "preview";
			mapForm.method = "POST";
			mapForm.action = target;
		
			let mapInput = document.createElement("input");
			mapInput.type = "hidden";
			mapInput.name = "jsonDat";
			mapInput.value = json_dat;
			mapForm.appendChild(mapInput);
		
			document.body.appendChild(mapForm);
		
			map = window.open("", "preview", "fullscreen=yes");
			if (map) {
				mapForm.submit();
			} else {
				alert('You must allow popups for this map to work.');
			}
			//$window.open(target, '_self');
			//$window.open(target,'','fullscreen=yes');
			//console.log(formData);
		}
	};	
	
	/* init item list's first row */
	initUI();

	/* calculate discount value from input & current subtotal */
	function getDiscount(subtotal,input) {
		if(input.indexOf("%") > -1){
			let rate = input.slice(0,input.length-1);
			var discount =  ((subtotal * rate) / 100 ).toFixed(2);
		} else {
			var discount = input;
		}
		return discount;
	}

	/* calculate reverted subtotal for VAT(IN) */
	function getSubtotal(total,input) {
		if(input.indexOf("%") > -1){
			let rate = input.slice(0,input.length-1);
			let rate2 = 100 - rate;
			var subtotal =  (total / (rate2 / 100) ).toFixed(2);
		} else {
			var subtotal = parseFloat(input) + parseFloat(total);
		}
		return subtotal;			
	}
		
	/* get invoice header */
	function getRunningNumber(configs,form){
		//console.log(configs);console.log(form);
		var formConfig = configs.document_configs[form];
		var digits = formConfig.auto_increment.length;
		var zeros = '00000000';
		var runningNumber = formConfig.last_used_id != "" ? ( zeros+(parseInt( formConfig.last_used_id ) + 1)).slice(-1*digits) : formConfig.auto_increment ;
		//var result;
		switch(configs.header_number_id){
			case 0:
			default:
				return formConfig.prefix + runningNumber;
				break;
			case 1:
			case 2:
				return formConfig.prefix + formConfig.middle + runningNumber;
				break;
		}
	}
	
	/* get invoice header's number */
	function getInvoiceIndex(){
		var runningNumber = $scope.invoice.summary.number;
		var index = runningNumber.replace(/[^0-9\.]/g, '');
		return index;
	}
	
	function initUI(){
		/* init first item.list row */
		$scope.item.addToList($scope.item.dummy);	
	}
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}
	
	/* check whether the invoice consist of new item ? */
	function getNewItems(list){
		let newItems = [];
		for ( i in list ){
			if( list[i].name != "" ){
				matched = filterFilter($allItems,{ name: list[i].name , description: list[i].description});
				//newItems.push(matched);
				if(matched.length == 0){
					newItems.push(list[i]);
				}
			}
			
		}
		//console.log(newItems);
		return newItems;
	}

	/* check whether the invoice's customer is new? */
	function getNewCustomer(customer){
		matched = filterFilter($customers,{ name: customer.name , tax_id: customer.taxId});
		if(matched.length == 0){
			let newCustomer = {
				name: customer.name,
				address: customer.address,
				tax_id: customer.taxId,
				telephone: customer.phone,
				email: "",
				comment: ""
			};
			return newCustomer;
		}
		
		return false;
	}
	
});
