angular.module('MetronicApp').controller('InvoiceIncomeCtrl', function($rootScope, $scope, $state, settings, $http, userDefault, invoiceConfigs, $dbService) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();

        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		
		
		let flag = $scope.initialInfo.flag;
		if(!flag.company || !flag.user){
			$('#promptInfoModal').modal({
				backdrop: 'static',
				show: 'true'
			});		
		}		
    });	
	
	$scope.forms = serializeForms(userDefault);
/* 	$scope.ui = {
		goAdd: function(key,value){
			$state.go('invoice-add',{
				form: key,
				type: "income",
				pageSubtitle: $scope.forms[key].title
			});
		},
		goEdit: function(key,value){
			$state.go('invoice-manage',{
				form: key
			});
		}
	}; */
	
	/* company info & user info */
	$scope.initialInfo = {
		company: $rootScope.companyData
		,user: $rootScope.userData
		,vatSettings: {
			VAT_active: userDefault.VAT_active
			,VAT_item_type: userDefault.VAT_item_type
		}
		,flag: $rootScope.initialSetupFlag
	};

	/* ui control */
	$scope.ui = {
		configs: invoiceConfigs,
		doSave : function(info){
			//console.log(info.flag);
			var jsonDat = {};
			jsonDat.user = {
				user_name: info.user.userName,
				mcf_user_id: info.user.userId
			};
			jsonDat.VAT_data = info.vatSettings;

			if(!info.flag.company){
				jsonDat.company_data = info.company;
				jsonDat.id = 1;
			}
			if(!info.flag.user){
				jsonDat.user_data = info.user;
			}
			//console.log(jsonDat);
			$dbService.updateInitialSetup(jsonDat).then(
				function(dat){
					//console.log(dat.data);
					if(dat.data.success){
						//$('#promptInfoModal').modal('hide');
						//console.log('done');
						location.reload(true);
					}
				},
				function(err){console.log(err);
			});
		},
		formValid: function(form){
			return form.$invalid || !form.$dirty;
		}
	};	
	
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}
});