angular.module('MetronicApp').controller('InvoiceIncomeEditCtrl', function(
	$rootScope,
	$scope,
	$state,
	$stateParams,
	settings,
	$http,
	filterFilter,
	multiFieldsFilter,
	$dbService,
	$allItems,
	$customers,
	userDefault,
	invoiceConfigs,
	rcvMenus,
	invoiceData,
	$mathService
){
    $scope.$on('$viewContentLoaded', function() {   
        /* initialize core components */
        App.initAjax();
	
        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		//console.log(invoiceData);
		
		/* init autocomplete search inputs */
		setTimeout(function(){
			initAnguComplete();
		}, 1000);
		
		//console.log(invoiceData.item_list);

    });	
	/* set global constants */
	const FORM_TYPE = $stateParams.form;
	const TYPE = $stateParams.type;
	const USER = $scope.sessionUserData;
	const CFO_MENUS = filterFilter(rcvMenus,{lv1_menu:"cfo", form_type: 1}); /* set CFO menus, exclude from type 2 */
	const FORM = serializeForms(userDefault)[FORM_TYPE]; //console.log(FORM);
	$state.current.data.pageTitle = "แก้ไข"+ FORM.title;
	/* set form display conditional parameters */
	$scope.form = {
		// WHT: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false,
		WHT: invoiceConfigs.whtList.indexOf(FORM_TYPE) > -1 ? true : false,
		VAT: userDefault.VAT_active ? true : false,
		itemVAT: invoiceData.summary.itemVAT ? true : false,
		//note: FORM_TYPE == 'invoice' ? true : false,
		CFO: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false,
		payment: FORM_TYPE == 'receipt' ? true : false	
	};	
	
	
	/* set customer info scope & control */
	$scope.customer = {
		masterList: $customers,
		detail: invoiceData.customer_detail,
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = typeof c.address == "string" ? {addr:c.address, subdistrict:"", district:"", province:"", postcode:""} : c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};	
	
	
	/* set item list scope & control */
	$scope.item = {
		dummy: {
			item_id: "",
			name: "",
			description: "",
			unit_price: "0.00",
			//number: "",
			qty: 0,
			subtotal: "0.00",
			discount: "0.00",
			discountInput: "0.00",
			total: "0.00",
			doVAT: false
		},		
		list: invoiceData.item_list,
		masterList: $allItems,
		addToList: function(input){
			//copy then push
			var copy = $.extend(true, {}, input);
			this.list.push(copy);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		removeFromList: function(i){
			//remove item
			this.list.splice(i, 1);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		selected: function(input,index){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var obj = input.originalObject; 
			$scope.item.autoFill(obj,index);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.item.list[i].name = name;
		},
		autoFill: function(obj,i){
			//update row data
			this.list[i].item_id = obj.item_id;
			this.list[i].name = obj.name;
			this.list[i].description = obj.description;
			this.list[i].unit_price = obj.unit_price_int;
			//this.list[i].number = obj.number;
			this.list[i].qty = 1;
			this.list[i].subtotal = obj.unit_price_int;
			this.list[i].doVAT = typeof obj.doVAT == 'undefined' ? false : obj.doVAT;
			this.list[i].total = obj.unit_price;
			//sum invoice
			this.pricing(i);
			$scope.invoice.updateSummary(this.list);
		},
		pricing: function(i){
			//sum item
			this.list[i].subtotal = ( this.list[i].qty * this.list[i].unit_price ).toFixed(2);
			this.list[i].discount = getDiscount(this.list[i].subtotal,this.list[i].discountInput);
			this.list[i].total = (this.list[i].subtotal - this.list[i].discount).toFixed(2);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		}
	};
	
	/* set invoice scope & control */
	$scope.invoice = {
		summary: $.extend({},invoiceData.summary),
		vatType: invoiceConfigs.vatType,
		whtRateOptions: invoiceConfigs.whtRateOptions,
		updateSummary: function(list){
			//get sum item (subtotal)
			// let itemVAT = $scope.form.itemVAT
			let itemVAT = this.summary.itemVAT
			var sum = this.sumItemList(list, itemVAT);
			//get all amounts e.g. subtotal, vat, total
			var amount = this.getAmount(sum);
			//update invoice amount
			this.summary.subtotal = amount.subtotal;
			this.summary.VAT = amount.VAT;
			this.summary.total = amount.total;
			this.summary.WHT = amount.WHT;
			this.summary.amountToPay = amount.amountToPay;
		},
		sumItemList: function(list, itemVAT){
			//sum every items in item list
			//for itemVAT options
			var result;
			if(itemVAT){
				// result[0] = noVAT, result[1] = doVAT
				result = [0,0];
				for(i=0; i<list.length; i++){
					if(list[i].doVAT){
						result[1] += parseFloat(list[i].total);
					} else {
						result[0] += parseFloat(list[i].total);
					}
				}
			} else {
				//for not itemVAT options
				result = 0;
				for(i=0; i<list.length; i++){
					result += parseFloat(list[i].total);
				}
			}
			return result;
		},
		getAmount: function(input){ 
			let itemVAT = typeof input == "object" ? true : false;
			var subtotal = itemVAT ? [parseFloat(input[0]), parseFloat(input[1])] : parseFloat(input);
			var result = {};
			//console.log(subtotal);
			/* calculate subtotal, vat, total by vatType condition */
			switch(this.summary.vatType) {
				/* No VAT */
				case "0":
				default: 
					// result.subtotal = subtotal.toFixed(2);
					this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
					// result.total = ( subtotal - parseFloat(this.summary.discount) ).toFixed(2);
					result.subtotal = ( subtotal - parseFloat(this.summary.discount) ).toFixed(2);
					result.total = result.subtotal;
					result.VAT = "0.00";
					result.WHT = this.getWHT(this.summary.withWHT, result.subtotal);					
					result.amountToPay = result.total - result.WHT;
					break;
				/* VAT excluded */
				case "1":
					if(itemVAT){
						// result.subtotal = [
							// subtotal[0].toFixed(2),
							// subtotal[1].toFixed(2)
							// ];
						let absSubtotal = (subtotal[0] + subtotal[1]);
						this.summary.discount = getDiscount(absSubtotal, this.summary.discountInput);
						let absSubtotalAfterDiscount = absSubtotal - this.summary.discount;
						result.subtotalAfterDiscount = [
							// this.summary.discount > 0 ? subtotal[0] * absSubtotalAfterDiscount / absSubtotal : subtotal[0],
							// this.summary.discount > 0 ? subtotal[1] * absSubtotalAfterDiscount / absSubtotal : subtotal[1]
							this.summary.discount > 0 ? subtotal[0] * $mathService.notZeroDevision(absSubtotalAfterDiscount, absSubtotal) : subtotal[0],
							this.summary.discount > 0 ? subtotal[1] * $mathService.notZeroDevision(absSubtotalAfterDiscount, absSubtotal) : subtotal[1]							
						];
						result.subtotal = result.subtotalAfterDiscount;
						result.VAT = ( $mathService.notZeroDevision( result.subtotalAfterDiscount[1] * this.summary.vatRate, 100 ) ).toFixed(2);
						result.WHT = this.getWHT(this.summary.withWHT, absSubtotal); 
						result.total = ( parseFloat(result.subtotalAfterDiscount[0]) + parseFloat(result.subtotalAfterDiscount[1]) + parseFloat(result.VAT) ).toFixed(2);
						result.amountToPay = result.total - result.WHT;
					} else {
						result.subtotal = subtotal.toFixed(2);
						this.summary.discount = getDiscount(subtotal,this.summary.discountInput);
						result.subtotalAfterDiscount = result.subtotal - parseFloat(this.summary.discount);
						// result.VAT = (result.subtotalAfterDiscount * this.summary.vatRate / 100).toFixed(2);
						result.VAT = ( $mathService.notZeroDevision( result.subtotalAfterDiscount * this.summary.vatRate, 100 ) ).toFixed(2);
						result.WHT = this.getWHT(this.summary.withWHT, result.subtotalAfterDiscount); 
						result.total = ( parseFloat(result.subtotalAfterDiscount) + parseFloat(result.VAT) ).toFixed(2);
						result.amountToPay = result.total - result.WHT;
					}
					break;
				/* VAT included */
				case "2":
					if(itemVAT){
						/* backup */
						// let absTotal = (subtotal[0] + subtotal[1]);
						// result.total = absTotal.toFixed(2);
						// result.subtotalAfterDiscount = [
							// subtotal[0].toFixed(2),
							// (subtotal[1] * 100 / 107 ).toFixed(2)
						// ];
						// result.VAT = (result.total - result.subtotalAfterDiscount[0] - result.subtotalAfterDiscount[1]).toFixed(2);
						// result.absSubtotalAfterDiscount = parseFloat( result.subtotalAfterDiscount[0] ) + parseFloat( result.subtotalAfterDiscount[1] );
						// result.absSubtotal = getSubtotal(result.absSubtotalAfterDiscount, this.summary.discountInput);
						// this.summary.discount = result.absSubtotal - result.absSubtotalAfterDiscount;
						// result.subtotal = [
							// this.summary.discount > 0 ? ((result.subtotalAfterDiscount[0] * result.absSubtotal) / (result.absSubtotal - this.summary.discount)).toFixed(2) : result.subtotalAfterDiscount[0],
							// this.summary.discount > 0 ? ((result.subtotalAfterDiscount[1] * result.absSubtotal) / (result.absSubtotal - this.summary.discount)).toFixed(2) : result.subtotalAfterDiscount[1]
						// ];
						// result.WHT = this.getWHT(this.summary.withWHT, result.absSubtotal);
						/* revision round3 */
						var absTotal = (subtotal[0] + subtotal[1]);
						this.summary.discount = getDiscount(absTotal, this.summary.discountInput);
						var absTotalAfterDiscount = absTotal - this.summary.discount;
						result.total = absTotalAfterDiscount.toFixed(2);
						// result.subtotal = [
							// subtotal[0].toFixed(2),
							// subtotal[1].toFixed(2)
						// ];
						var vatBase = subtotal[1] - ( ( subtotal[1] / absTotal ) * this.summary.discount );
						var nonVatBase = subtotal[0] - ( $mathService.notZeroDevision( subtotal[0], absTotal ) * this.summary.discount );
						// result.VAT = ( vatBase * this.summary.vatRate / (this.summary.vatRate + 100) ).toFixed(2);
						result.VAT = ( vatBase * $mathService.notZeroDevision(this.summary.vatRate, (this.summary.vatRate + 100) ) ).toFixed(2);
						result.subtotal = [
							nonVatBase.toFixed(2),
							(vatBase - result.VAT).toFixed(2),
						];						
						result.WHT = this.getWHT( this.summary.withWHT, (vatBase - result.VAT) );
						result.amountToPay = result.total - result.WHT;
					} else {
						/* backup */
						// result.total = (subtotal).toFixed(2);
						// result.subtotalAfterDiscount = ( (result.total * 100 ) / 107 ).toFixed(2); console.log(subtotalAfterDiscount);
						// result.subtotal = getSubtotal(result.subtotalAfterDiscount, this.summary.discountInput);					
						// this.summary.discount = result.subtotal - result.subtotalAfterDiscount;
						// result.VAT = (result.total - result.subtotalAfterDiscount).toFixed(2);
						// result.WHT = this.getWHT(this.summary.withWHT, result.subtotal);
						/* revision round3 */
						this.summary.discount = getDiscount(subtotal, this.summary.discountInput);
						var absTotalAfterDiscount = subtotal - this.summary.discount;
						result.total = (absTotalAfterDiscount).toFixed(2);
						//result.subtotal = subtotal.toFixed(2);
						//var vatBase = absTotalAfterDiscount * (100 - this.summary.vatRate);
						// result.VAT = ( absTotalAfterDiscount * this.summary.vatRate / (this.summary.vatRate + 100) ).toFixed(2);
						result.VAT = ( $mathService.notZeroDevision( (absTotalAfterDiscount * this.summary.vatRate), (this.summary.vatRate + 100) ) ).toFixed(2);
						result.subtotal = ( absTotalAfterDiscount - result.VAT).toFixed(2);
						result.WHT = this.getWHT( this.summary.withWHT, (absTotalAfterDiscount - result.VAT) );
						result.amountToPay = result.total - result.WHT;
					}
					break;
			}
			//console.log(result);console.log(this.summary.discount);
			return result;
		},
		getWHT: function(flag,subtotal){
			if(flag){
				return ( subtotal * this.summary.whtRate / 100 ).toFixed(2);
			} else {
				return 0;
			}
		},
/* 		changeDiscount: function(input,list){
			this.summary.discount = getDiscountAmount(this.summary.subtotal,input);
			//console.log("sdf");
			this.updateSummary(list);
		}, */
		save: function(){
			var vm = this;
			var isUpdateCashflowFlag =  $scope.form.CFO ? vm.isUpdateCashflow(invoiceData.summary, $scope.invoice.summary) : false;																											  
			var jsonDat = {
				type: "income_documents",
				summary: this.summary,
				itemList: $scope.item.list,
				customer: $scope.customer.detail,
				mongoId: $stateParams.mongoId,
				docId: $stateParams.invoiceId,
				updateCashflow: isUpdateCashflowFlag,						 
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			$scope.ajaxProcessing = true;
			var formData = new FormData();
			// formData.append('jsonData', JSON.stringify(jsonDat));
			formData.append('jsonData', angular.toJson(jsonDat));
			$dbService.editInvoice(formData).then(
				//on success
				function(dat){
					//console.log(dat.data);return;
					$scope.ajaxProcessing = false;
					$state.go('invoice-income-manage',{
						form: FORM_TYPE
					});					
				}
				//on errors
				,function(err){console.log(err);$scope.ajaxProcessing = false;});
		},
		updateInvoiceIndex: function(form,used_number){
			$dbService.updateInvoiceIndex(form,used_number).then(
				function(){},
				function(err){alert(err);});
		},	
		isUpdateCashflow: function(oldData, newData){
			if( oldData.cashflow.trans_id !== undefined ) {
				var change = {
					trans_date: oldData.date === newData.date ? false: newData.date,
					trans_comment: oldData.number === newData.number && oldData.date === newData.date ? false: "เป็นการบันทึกรายรับรวม ณ วันที่ "+ newData.date +" เอกสารอ้างอิงเลขที่: "+newData.number,
					trans_val: oldData.amountToPay === newData.amountToPay ? false: newData.amountToPay
				};
				if( change.trans_comment || change.trans_val || change.trans_date){
					return change;
				} else {
					return false;
				}
			}
			return false;
		}
			
	};

	$scope.ui = {
		printPreview: function(input){
			let obj = {
				type: "income_documents",
				summary:  $scope.invoice.summary,
				item_list: $scope.item.list,
				customer_detail: $scope.customer.detail,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			
			let	json_dat = JSON.stringify(obj);
			//let target =  window.location.origin + "/mcf_merged/docs/preview?json_dat="+json_dat;
			let target =  window.location.origin + "/docs/preview/income/"+FORM_TYPE;

			let mapForm = document.createElement("form");
			mapForm.target = "preview";
			mapForm.method = "POST";
			mapForm.action = target;
		
			let mapInput = document.createElement("input");
			mapInput.type = "hidden";
			mapInput.name = "jsonDat";
			mapInput.value = json_dat;
			mapForm.appendChild(mapInput);
		
			document.body.appendChild(mapForm);
		
			map = window.open("", "preview", "fullscreen=yes");
			if (map) {
				mapForm.submit();
			} else {
				alert('You must allow popups for this map to work.');
			}
			//$window.open(target, '_self');
			//$window.open(target,'','fullscreen=yes');
			//console.log(formData);
		}
	};	
	
	/* get invoice header */
	function getRunningNumber(configs,form){
		//console.log(configs);console.log(form);
		var formConfig = configs.document_configs[form];
		var digits = formConfig.auto_increment.length;
		var zeros = '00000000';
		var runningNumber = formConfig.last_used_id != "" ? ( zeros+(parseInt( formConfig.last_used_id ) + 1)).slice(-1*digits) : formConfig.auto_increment ;
		//var result;
		switch(configs.header_number_id){
			case 0:
			default:
				return formConfig.prefix + runningNumber;
				break;
			case 1:
			case 2:
				return formConfig.prefix + formConfig.middle + runningNumber;
				break;
		}
	}
	
	/* get invoice header's number */
	function getInvoiceIndex(){
		var runningNumber = $scope.invoice.summary.number;
		var index = runningNumber.replace(/[^0-9\.]/g, '');
		return index;
	}
	
	/* calculate discount value from input & current subtotal */
	function getDiscount(subtotal,input) {
		if(input.indexOf("%") > -1){
			let rate = input.slice(0,input.length-1);
			var discount =  ((subtotal * rate) / 100 ).toFixed(2);
		} else {
			var discount = input;
		}
		return discount;			
	}

	/* calculate reverted subtotal for VAT(IN) */
	function getSubtotal(total,input) {
		if(input.indexOf("%") > -1){
			let rate = input.slice(0,input.length-1);
			let rate2 = 100 - rate;
			var subtotal =  (total / (rate2 / 100) ).toFixed(2);
		} else {
			var subtotal = parseFloat(input) + parseFloat(total);
		}
		return subtotal;			
	}
	
	/* set autocomplete input value */
	function initAnguComplete(){
		/* angucomplete-alt change-input does not work by programmed triggered!!! */
		//$scope.$broadcast('angucomplete-alt:changeInput','customerInfo','hello');
		$('#customerInfo_value').val(invoiceData.customer_detail.name);
		//$scope.$broadcast('angucomplete-alt:changeInput', 'customerInfo', invoiceData.customer_detail.name);
		for (prop in $scope.item.list){
			let inputId = "#item_"+prop+"_value";
			//$scope.$broadcast('angucomplete-alt:changeInput', inputId, $scope.item.list[prop].name);
			$(inputId).val($scope.item.list[prop].name);
		}
	}
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}		
});
