angular.module('MetronicApp').controller('InvoiceItemCtrl', function($rootScope, $scope, settings, $http, multiFieldsFilter, $dbService, $allItems) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();
        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
        //$scope.orgLv1Menu = ($scope.params.lv1Menu == "cfo" || $scope.params.lv1Menu == "cfi" || $scope.params.lv1Menu == "cff" ) ? $scope.params.lv1Menu : "cfo";
        //$scope.orgMenuType = ($scope.params.menuType == "rcv" || $scope.params.menuType == "exp" ) ? $scope.params.menuType : "rcv" ;
        //$scope.menuDesc = { "cfo" : "ดำเนินการ", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };     
    });	
	//console.log($allItems);
	//all procuts list
	$scope.masterList = $allItems;
	
	//item handlers
	$scope.item = {
		modal: {
			title: ""
		},
		detail: {
			item_id: "",
			name: "",
			//number: "",
			description: "",
			unit_price: "",
			doVAT: false
		},
		create: function(){
			this.modal.title = "สร้างสินค้า";
			this.detail.item_id = -1;  
			$('#formItemDetail').modal({
				backdrop: 'static',
				show: 'true'
			});
		},
		save: function(){
			var vm = this;
			var userInfo = {
				user_name: $scope.sessionUserData.userName,
				user_id: $scope.sessionUserData.userId
			};
			if(this.detail.item_id > 0){
				//update item details
				$dbService.editInvoiceItem(this.detail,userInfo).then(
					function(dat){
						if(dat.data.success){
							vm.fetch();
							vm.clear($scope.itemForm);
						}
					},
					function(err){console.log(err);vm.clear($scope.itemForm);}
				);
			} else {
				//create new item
				$dbService.insertInvoiceItem(this.detail,userInfo).then(
					function(dat){ 
						if(dat.data.success){ 
							vm.fetch();
							vm.clear($scope.itemForm);
						}
					},
					function(err){console.log(err);vm.clear($scope.itemForm);});
			}

		},
		edit: function(input){
			this.modal.title = "แก้ไขสินค้า";
			this.detail.item_id = input.item_id;
			this.detail.name = input.name;
			//this.detail.number = input.number;
			this.detail.doVAT = input.doVAT;
			this.detail.description = input.description;
			this.detail.unit_price = input.unit_price_int;
			$('#formItemDetail').modal({
				backdrop: 'static',
				show: 'true'
			});
		},
		promptDelete: function(input){
			this.detail.item_id = input.item_id;
			this.detail.name = input.name;
			//this.detail.number = input.number;
			this.detail.doVAT = input.doVAT;
			this.detail.description = input.description;
			this.detail.unit_price = input.unit_price;
			$('#form_delete').modal({
				backdrop: 'static',
				show : 'true'
			});
		},
		delete: function(id){
			var vm = this;
			var userInfo = {
				user_name: $scope.sessionUserData.userName,
				user_id: $scope.sessionUserData.userId
			};
			$dbService.deleteInvoiceItem(id,userInfo).then(
				function(dat){
					if(dat.data.success){
						vm.fetch();
						vm.clear();
					}
				});
		},
		fetch: function(){
			$dbService.getInvoiceItem().then(
				function(dat){
					console.log(dat.data);
					$scope.masterList = dat.data;
					$scope.table.refresh();
				},
				function(err2){console.log(err2);}
			);
		},
		clear: function(form){
			this.detail.item_id = this.detail.name = this.detail.number = this.detail.description = this.detail.unit_price = "";
			form.$setPristine();
			form.$setUntouched();
		},
		invalid: function(form){
			let item = this.detail;
			let valid = item.name.length > 0 && item.unit_price != "" && form.$dirty
			if(valid){
				return false;
			} else {
				return true;
			}
			
		}
	};
	
	//table sorting params
	$scope.sortKey = 'index';
	$scope.reverse = false;
	
	//Table handler
	$scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.masterList.length
            ,maxPage:  Math.ceil($scope.masterList.length/5)
			,searchFields: ["name","description","unit_price","last_update_user"]
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.masterList.length,name:"All"}
        ],
		searchString: "",
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchList.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.masterList.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        },
		//For catagories filter
        // filter: function(mcf_id){
            // if(mcf_id>0){
                // $scope.filterTrans = filterFilter($scope.expTrans,{lv2_id:mcf_id});
            // }else{
                // $scope.filterTrans = $scope.expTrans;
            // }
            // this.refresh();
        // },
        refresh: function(){
            this.config.curPage = 1;
            this.config.records = $scope.masterList.length;
            this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
        }
    };	

});