angular.module('MetronicApp').controller('InvoiceEditCtrl', function(
	$rootScope,
	$scope,
	$state,
	$stateParams,
	settings,
	$http,
	filterFilter,
	multiFieldsFilter,
	$dbService,
	$allItems,
	$customers,
	userDefault,
	invoiceConfigs,
	rcvMenus,
	invoiceData
){
    $scope.$on('$viewContentLoaded', function() {   
        /* initialize core components */
        App.initAjax();
	
        /* set default layout mode */
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		console.log(invoiceData);
		
		/* init autocomplete search inputs */
		setTimeout(function(){
			initAnguComplete();
		}, 1000);

    });	
	/* set global constants */
	const FORM_TYPE = $stateParams.form;
	const USER = $scope.sessionUserData;
	const CFO_MENUS = filterFilter(rcvMenus,{lv1_menu:"cfo", form_type: 1}); /* set CFO menus, exclude from type 2 */
	const FORM = serializeForms(userDefault)[FORM_TYPE]; //console.log(FORM);
	$state.current.data.pageTitle = "แก้ไข"+ FORM.title;
	/* set form display conditional parameters */
	$scope.form = {
		WHT: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false,
		VAT: userDefault.VAT_active ? true : false,
		//note: FORM_TYPE == 'invoice' ? true : false,
		CFO: FORM_TYPE == 'invoice' || FORM_TYPE == 'receipt' ? true : false
	};	
	
	
	/* set customer info scope & control */
	$scope.customer = {
		masterList: $customers,
		detail: invoiceData.customer_detail,
		selected: function(input){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var c = input.originalObject; 
			$scope.customer.autoFill(c);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.customer.detail.name = name;
		},		
		autoFill: function(c){
			this.detail.name = c.name;
			this.detail.address = c.address;
			this.detail.phone = c.telephone;
			this.detail.taxId = c.tax_id;
		}
	};	
	
	
	/* set item list scope & control */
	$scope.item = {
		dummy: {
			item_id: "",
			name: "",
			description: "",
			unit_price: "0.00",
			number: "",
			qty: 0,
			subtotal: "0.00",
			discount: "0.00",
			discountInput: "0.00",
			total: "0.00"
		},		
		list: invoiceData.item_list,
		masterList: $allItems,
		addToList: function(input){
			//copy then push
			var copy = $.extend(true, {}, input);
			this.list.push(copy);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		removeFromList: function(i){
			//remove item
			this.list.splice(i, 1);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		selected: function(input,index){
			/*warning!, inside angucomplete-alt scope now*/
			if(typeof input == 'undefined'){return;}
			var obj = input.originalObject; 
			$scope.item.autoFill(obj,index);
		},
		nameChanged: function(name){
			/*warning!, inside angucomplete-alt scope now*/
			var i = this.$parent.$index;
			$scope.item.list[i].name = name;
		},
		autoFill: function(obj,i){
			//update row data
			this.list[i].item_id = obj.item_id;
			this.list[i].name = obj.name;
			this.list[i].description = obj.description;
			this.list[i].unit_price = obj.unit_price_int;
			this.list[i].number = obj.number;
			this.list[i].qty = 1;
			this.list[i].subtotal = obj.unit_price_int;
			//this.list[i].discount = "0.00";
			this.list[i].total = obj.unit_price;
			//sum invoice
			this.pricing(i);
			$scope.invoice.updateSummary(this.list);
		},
		pricing: function(i){
			//sum item
			this.list[i].subtotal = ( this.list[i].qty * this.list[i].unit_price ).toFixed(2);
			this.list[i].total = (this.list[i].subtotal - this.list[i].discount).toFixed(2);
			//sum invoice
			$scope.invoice.updateSummary(this.list);
		},
		changeDiscount: function(){
			
		}
	};
	
	/* set invoice scope & control */
	$scope.invoice = {
		summary: invoiceData.summary,
		vatType: invoiceConfigs.vatType,
		whtRateOptions: invoiceConfigs.whtRateOptions,
		updateSummary: function(list){
			//get sum item (subtotal)
			var sum = this.sumItemList(list);
			//get all amounts e.g. subtotal, vat, total
			var amount = this.getAmount(sum);
			//update invoice amount
			this.summary.subtotal = amount.subtotal;
			this.summary.VAT = amount.VAT;
			this.summary.total = amount.total;
			this.summary.WHT = amount.WHT;
		},
		sumItemList: function(list){
			var result = 0;
			//sum every items in item list
			for(i=0; i<list.length; i++){
				result += parseFloat(list[i].total);
			}
			return result;
		},
		getAmount: function(input){
			var subtotal = parseFloat(input);
			var result = {};
			/* calculate subtotal, vat, total by vatType condition */
			switch(this.summary.vatType) {
				/* No VAT */
				case "0":
				default: 
					result.subtotal = subtotal.toFixed(2);
					result.VAT = "0.00";
					result.total = ( subtotal - parseFloat(this.summary.discount) ).toFixed(2);
					break;
				/* VAT excluded */
				case "1":
					result.subtotal = subtotal.toFixed(2);
					result.VAT = (subtotal * this.summary.vatRate / 100).toFixed(2);
					result.total = ( (subtotal + parseFloat(result.VAT)) - (this.summary.discount) ).toFixed(2);
					break;
				/* VAT included */
				case "2":
					//result.subtotal = (subtotal / (1 + (this.summary.vatRate / 100) ) ).toFixed(2);
					result.subtotal = ( (100 * subtotal) / (this.summary.vatRate + 100) ).toFixed(2);
					result.VAT = (subtotal - result.subtotal).toFixed(2);
					result.total = subtotal.toFixed(2);
					break;
			}
			/* calculate withholding tax by withWHT flag */
			result.WHT = this.getWHT(this.summary.withWHT, result.subtotal);
			return result;
		},
		getWHT: function(flag,subtotal){
			if(flag){
				return ( subtotal * this.summary.whtRate / 100 ).toFixed(2);
			} else {
				return "0.00";
			}
		},
		changeDiscount: function(input,list){
			this.summary.discount = getDiscountAmount(this.summary.subtotal,input);
			//console.log("sdf");
			this.updateSummary(list);
		},
		save: function(){
			var vm = this;
			var jsonDat = {
				summary: this.summary,
				itemList: $scope.item.list,
				customer: $scope.customer.detail,
				mongoId: $stateParams.mongoId,
				user: { 
					mcf_user_id: USER.userId,
					user_name: USER.userName
				}
			};
			$scope.ajaxProcessing = true;
			var formData = new FormData();
			formData.append('jsonData', JSON.stringify(jsonDat));
			$dbService.editInvoice(formData).then(
				//on success
				function(dat){
					console.log(dat.data);
					// vm.updateInvoiceIndex(FORM_TYPE, getInvoiceIndex());
					// if($scope.form.CFO){
						// vm.saveCashflow(jsonDat.summary);
					// }
					$scope.ajaxProcessing = false;
				}
				//on errors
				,function(err){console.log(err);$scope.ajaxProcessing = false;});
		},
		saveCashflow: function(tran){
			$dbService.newTran(tran.cashflow.mcf_id, tran.cashflow.mcf_sub_id,tran.date,tran.total,'rcv','cfo',"",-1,USER.userId,USER.userName).then(
				function(){},
				function(err){alert(err);});
		},
		updateInvoiceIndex: function(form,used_number){
			$dbService.updateInvoiceIndex(form,used_number).then(
				function(){},
				function(err){alert(err);});
		}		
	};
	
	/* get invoice header */
	function getRunningNumber(configs,form){
		//console.log(configs);console.log(form);
		var formConfig = configs.document_configs[form];
		var digits = formConfig.auto_increment.length;
		var zeros = '00000000';
		var runningNumber = formConfig.last_used_id != "" ? ( zeros+(parseInt( formConfig.last_used_id ) + 1)).slice(-1*digits) : formConfig.auto_increment ;
		//var result;
		switch(configs.header_number_id){
			case 0:
			default:
				return formConfig.prefix + runningNumber;
				break;
			case 1:
			case 2:
				return formConfig.prefix + formConfig.middle + runningNumber;
				break;
		}
	}
	
	/* get invoice header's number */
	function getInvoiceIndex(){
		var runningNumber = $scope.invoice.summary.number;
		var index = runningNumber.replace(/[^0-9\.]/g, '');
		return index;
	}
	
	/* get discount amount */
	function getDiscountAmount(subtotal,discount){
		let sign =  discount.substr(discount.length-1);
		let number = discount.slice(0,discount.length-1);
		let isRate = (sign === "%");
		
		if(isRate){
			return ((subtotal * number) / 100).toFixed(2);
		} else {
			return (parseFloat(discount)).toFixed(2);
		}
		
				// if(isNaN(discount) && !isRate){
					// return "0.00";
				// } else {
					// return isRate ?  ((subtotal * number) / 100).toFixed(2) : (parseFloat(discount)).toFixed(2);
				// }		
	}
	
	/* set autocomplete input value */
	function initAnguComplete(){
		/* angucomplete-alt change-input does not work by programmed triggered!!! */
		//$scope.$broadcast('angucomplete-alt:changeInput','customerInfo','hello');
		$('#customerInfo_value').val(invoiceData.customer_detail.name);
		//$scope.$broadcast('angucomplete-alt:changeInput', 'customerInfo', invoiceData.customer_detail.name);
		for (prop in $scope.item.list){
			let inputId = "#item_"+prop+"_value";
			//$scope.$broadcast('angucomplete-alt:changeInput', inputId, $scope.item.list[prop].name);
			$(inputId).val($scope.item.list[prop].name);
		}
	}
	
	function serializeForms(obj){
		//console.log(userDefault);
		var forms = obj.document_configs;
		for(let prop in forms){
			if(prop == obj.tax_invoice.attach_with){
				forms[prop].title += "/" + obj.tax_invoice.title;
			}
		}
		return forms;
	}		
});
