angular.module('MetronicApp').filter('contains', function() {
  return function (arr, needle) {
	if(arr !== undefined)
	{
		var objKeys = Object.keys(arr);
		return objKeys.indexOf(needle) >= 0;	
	}
	else
	{
		return ;
	}
  };
});

angular.module('MetronicApp').filter('not_in', function() {
  return function (arr, needle) {
	if(arr !== undefined)
	{
		var objKeys = Object.keys(arr);
		return objKeys.indexOf(needle) < 0;
	}
	else
	{
		return ;
	}
  };
});



angular.module('MetronicApp').controller('ReportCashFlowCompareController', ['$rootScope', '$scope', 'settings', '$http','$filter',function($rootScope, $scope, settings,$http,$filter) {
    $scope.$on('$viewContentLoaded', function() {   
		// initialize core components
		App.initAjax();
	
		// set default layout mode
		$rootScope.settings.layout.pageContentWhite = true;
		$rootScope.settings.layout.pageBodySolid = false;
		$rootScope.settings.layout.pageSidebarClosed = false;
		
		$scope.opts= {};
		$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
		var monthNames = [ "มกราคม", "กุมภาพันธ์", "มีนาคม", "เมษายน", "พฤษภาคม", "มิถุนายน", "กรกฎาคม", "สิงหาคม", "กันยายน",  "ตุลาคม",  "พฤศจิกายน",  "ธันวาคม"];
		
		var date = new Date();
		//var firstDayTemp = new Date(date.getFullYear(), date.getMonth()-1, 1);
		var firstDayTemp = new Date(date.getFullYear(), date.getMonth(), 1);
		var firstDay = ("0"+(firstDayTemp.getDate())).slice(-2)+"-"+("0"+(firstDayTemp.getMonth()+1)).slice(-2)+"-"+firstDayTemp.getFullYear();
		//var lastDayTemp = new Date(date.getFullYear(), date.getMonth() , 0);
		var lastDayTemp = new Date(date.getFullYear(), date.getMonth()+1 , 0);
		var lastDay = ("0"+(lastDayTemp.getDate())).slice(-2)+"-"+("0"+(lastDayTemp.getMonth()+1)).slice(-2)+"-"+lastDayTemp.getFullYear();
		
		$scope.reportType = {
			'1' : 'ตามจริง',
			'2' : 'ประมาณการ'
		}
		$scope.queryReportType = 3;
		$scope.cashflowCompare = false;

		$scope.report = {
			'startDate'	:	firstDay,
			'endDate'	:	lastDay,
			'monthName'	:	monthNames[date.getMonth()],
			'headerType':   $scope.reportType[$scope.queryReportType]
		};
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	$scope.queryReportSelect = {
		reportType  : "1"
	}

	$scope.getReportCashFlowSummary = function (start,end) {

			//var getLink = $scope.sessionUserData.memberId == '873' ? 'php_data/cashflowCompareExport.php?business_id=1&startDate='+$scope.report.startDate+'&endDate='+$scope.report.endDate+'&type='+$scope.queryReportType+'&download=false' : 'php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&download=true';
			
		if($scope.sessionUserData.reportLevels == "lv2_only")
		{
			//var getLink = $scope.sessionUserData.memberId == '873' ? 'php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&download=false': 'php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&download=true';
			
			
			//var getLink = $scope.sessionUserData.memberId == '873' ? 'php_data/cashflowCompareExport.php?business_id=1&startDate='+$scope.report.startDate+'&endDate='+$scope.report.endDate+'&type='+$scope.queryReportType : 'php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType;
			var getLink = 'php_data/cashflowCompareExport.php?business_id=1&startDate='+$scope.report.startDate+'&endDate='+$scope.report.endDate+'&type='+$scope.queryReportType;
			
			//var getLink = 'php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&download=true';
			
			
			
			$http.get(getLink)
			.success(function(data) {
				console.log(data);
				$scope.cashflowSummary = data['summary']['period'];
				$scope.sumTotal = parseFloat((data['summary']['period']['cfo']['summary'] !== undefined ? data['summary']['period']['cfo']['summary'] : 0.00)) + parseFloat((data['summary']['period']['cfi']['summary'] !== undefined ? data['summary']['period']['cfi']['summary'] : 0.00)) + parseFloat((data['summary']['period']['cff']['summary'] !== undefined ? data['summary']['period']['cff']['summary'] : 0.00));
				if ($scope.queryReportType == 3) 
				{
					$scope.sumTotalForecast = parseFloat((data['summary']['period']['cfo']['summary_forecast'] !== undefined ? data['summary']['period']['cfo']['summary_forecast'] : 0.00)) + parseFloat((data['summary']['period']['cfi']['summary_forecast'] !== undefined ? data['summary']['period']['cfi']['summary_forecast'] : 0.00)) + parseFloat((data['summary']['period']['cff']['summary_forecast'] !== undefined ? data['summary']['period']['cff']['summary_forecast'] : 0.00));
					$scope.sumTotalDifference = $scope.sumTotal - $scope.sumTotalForecast;
				}
				$scope.cashflowRCV = data['rcv']['period'] !== undefined ?
					{
						'CFO' : data['rcv']['period']['cfo'] !== undefined ? data['rcv']['period']['cfo'] : [],
						'CFF' : data['rcv']['period']['cff'] !== undefined ? data['rcv']['period']['cff'] : [],
						'CFI' : data['rcv']['period']['cfi'] !== undefined ? data['rcv']['period']['cfi'] : []
					}:
					{
						'CFO' : [],
						'CFF' : [],					
						'CFI' : []					
					};					
				$scope.cashflowEXP = data['exp']['period'] !== undefined ?
					{
						'CFO' : data['exp']['period']['cfo'] !== undefined ? data['exp']['period']['cfo'] : {},
						'CFF' : data['exp']['period']['cff'] !== undefined ? data['exp']['period']['cff'] : {},
						'CFI' : data['exp']['period']['cfi'] !== undefined ? data['exp']['period']['cfi'] : {}
					}:
					{
						'CFO' : {},
						'CFF' : {},				
						'CFI' : {}				
					};
				$scope.cashflowRCVAdv = data['rcvAdv']['period'] !== undefined ?
					{
						'CFO' : data['rcvAdv']['period']['cfo'] !== undefined ? data['rcvAdv']['period']['cfo'] : [],
						'CFF' : data['rcvAdv']['period']['cff'] !== undefined ? data['rcvAdv']['period']['cff'] : [],
						'CFI' : data['rcvAdv']['period']['cfi'] !== undefined ? data['rcvAdv']['period']['cfi'] : []
					}:
					{
						'CFO' : [],
						'CFF' : [],					
						'CFI' : []					
					};					
				$scope.cashflowEXPAdv = data['expAdv']['period'] !== undefined ? 
					{
						'CFO' : data['expAdv']['period']['cfo'] !== undefined ? data['expAdv']['period']['cfo'] : [],
						'CFF' : data['expAdv']['period']['cff'] !== undefined ? data['expAdv']['period']['cff'] : [],
						'CFI' : data['expAdv']['period']['cfi'] !== undefined ? data['expAdv']['period']['cfi'] : []
					}:
					{
						'CFO' : [],
						'CFF' : [],					
						'CFI' : []					
					};
				
				$scope.cashflowCompare = data['cashflowCompare']['period'] !== undefined ?
					{
						'CFO' : data['cashflowCompare']['period']['cfo'] !== undefined ? data['cashflowCompare']['period']['cfo'] : {},
						'CFF' : data['cashflowCompare']['period']['cff'] !== undefined ? data['cashflowCompare']['period']['cff'] : {},
						'CFI' : data['cashflowCompare']['period']['cfi'] !== undefined ? data['cashflowCompare']['period']['cfi'] : {}
					}:
					{
						'CFO' : [],
						'CFF' : [],					
						'CFI' : []					
					};
				//console.log($scope.sumTotal);
			})
			.error(function(err) {console.log(err);} );
		}
		else if($scope.sessionUserData.reportLevels == "lv2_lv3")
		{
			//var getLink = $scope.sessionUserData.memberId == '873' ? 'php_data/cashflowCompareExport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&download=false': 'php_data/cashflowCompareExport.php?business_id=1&startDate='+$scope.report.startDate+'&endDate='+$scope.report.endDate+'&type='+$scope.queryReportType+'&download=false';
			var getLink = 'php_data/cashflowCompareExport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&download=false';
			$http.get(getLink)
			.success(function(data) {
				//console.log(data);
				if(data['rcv']['period'] !== undefined)
				{
					$scope.cashflowRCV = {
						'CFO' : (data['rcv']['period']['cfo'] !== undefined ) ? data['rcv']['period']['cfo'] : [],
						'CFF' : (data['rcv']['period']['cff'] !== undefined ) ? data['rcv']['period']['cff'] : [],
						'CFI' : (data['rcv']['period']['cfi'] !== undefined ) ? data['rcv']['period']['cfi'] : []
					}
				}
				else
				{
					$scope.cashflowRCV = {
						'CFO' : [],
						'CFF' : [],
						'CFI' : []
					}
				}
				
				if(data['rcvAdv']['period'] !== undefined)
				{
					$scope.cashflowRCVAdv = {
						'CFO' : (data['rcvAdv']['period']['cfo'] !== undefined ) ? data['rcvAdv']['period']['cfo'] : [],
						'CFF' : (data['rcvAdv']['period']['cff'] !== undefined ) ? data['rcvAdv']['period']['cff'] : [],
						'CFI' : (data['rcvAdv']['period']['cfi'] !== undefined ) ? data['rcvAdv']['period']['cfi'] : []
					}
				}
				else
				{
					$scope.cashflowRCVAdv = {
						'CFO' : [],
						'CFF' : [],
						'CFI' : []
					}
				}
				
				
				if(data['exp']['period'] !== undefined)
				{
					$scope.cashflowEXP = {
						'CFO' : (data['exp']['period']['cfo'] !== undefined  ) ? data['exp']['period']['cfo'] : [],
						'CFF' : (data['exp']['period']['cff'] !== undefined  ) ? data['exp']['period']['cff'] : [],
						'CFI' : (data['exp']['period']['cfi'] !== undefined  ) ? data['exp']['period']['cfi'] : []
					}
				}
				else
				{
					$scope.cashflowEXP = {
						'CFO' :  [],
						'CFF' :  [],
						'CFI' :  []
					}
				}
				if(data['expAdv']['period'] !== undefined)
				{
					$scope.cashflowEXPAdv = {
						'CFO' : (data['expAdv']['period']['cfo'] !== undefined  ) ? data['expAdv']['period']['cfo'] : [],
						'CFF' : (data['expAdv']['period']['cff'] !== undefined  ) ? data['expAdv']['period']['cff'] : [],
						'CFI' : (data['expAdv']['period']['cfi'] !== undefined  ) ? data['expAdv']['period']['cfi'] : []
					}
				}
				else
				{
					$scope.cashflowEXPAdv = {
						'CFO' :  [],
						'CFF' :  [],
						'CFI' :  []
					}
				}
				if(data['cashflowCompare']['period'] !== undefined)
				{
					$scope.cashflowCompare = {
						'CFO' : data['cashflowCompare']['period']['cfo'] !== undefined ? data['cashflowCompare']['period']['cfo'] : {},
						'CFF' : data['cashflowCompare']['period']['cff'] !== undefined ? data['cashflowCompare']['period']['cff'] : {},
						'CFI' : data['cashflowCompare']['period']['cfi'] !== undefined ? data['cashflowCompare']['period']['cfi'] : {}
					};
				}
				else
				{
					$scope.cashflowCompare = {
						'CFO' :  {},
						'CFF' :  {},
						'CFI' :  {}
					};
				}
				$scope.cashflowSummary = data['summary']['period'];
				$scope.sumTotal = parseFloat((data['summary']['period']['cfo']['summary'] !== undefined ? data['summary']['period']['cfo']['summary'] : 0.00)) + parseFloat((data['summary']['period']['cfi']['summary'] !== undefined ? data['summary']['period']['cfi']['summary'] : 0.00)) + parseFloat((data['summary']['period']['cff']['summary'] !== undefined ? data['summary']['period']['cff']['summary'] : 0.00));
				if ($scope.queryReportType == 3) 
				{
					$scope.sumTotalForecast = parseFloat((data['summary']['period']['cfo']['summary_forecast'] !== undefined ? data['summary']['period']['cfo']['summary_forecast'] : 0.00)) + parseFloat((data['summary']['period']['cfi']['summary_forecast'] !== undefined ? data['summary']['period']['cfi']['summary_forecast'] : 0.00)) + parseFloat((data['summary']['period']['cff']['summary_forecast'] !== undefined ? data['summary']['period']['cff']['summary_forecast'] : 0.00));
					$scope.sumTotalDifference = $scope.sumTotal - $scope.sumTotalForecast;
				}
				
				
				$("#cashflow_data .lv2-header-name").each(function() {
					var checkNextTR = $(this).next();
					if($(checkNextTR).hasClass("lv2-header-name") || $(checkNextTR).hasClass("row-activity-total") || $(checkNextTR).hasClass("row-net-total"))
					{
						$(this).css('display','none');
					}
				});
				
			})
			.error(function(err) {console.log(err);} );
		

	
		}
		if($scope.queryReportType == 1 || $scope.queryReportType == 2)
		{
			$scope.cashflowCompare = false;
			$scope.report.headerType = $scope.reportType[$scope.queryReportType];
		}
		else if ($scope.queryReportType == 3)
		{
			$scope.cashflowCompare = true;
			$scope.report.headerType = "ตามจริง";
		}
	}
	$scope.getReportCashFlowSummary("","");
	$scope.queryReport = function() 
	{
		var start_date = $scope.report.startDate;
		var end_date = $scope.report.endDate;
		$scope.getReportCashFlowSummary(start_date,end_date);
	}
	
	$scope.setReportType = function(reportType) 
	{
		$scope.queryReportType = $scope.queryReportSelect.reportType;
	}
	
	$scope.compareExcel = function(tableName)
	{
		//var reportYear = ($scope.report.endDate).substr(6,4);
		//$("#cashflow_data").table2excel({
		//	// exclude CSS class
		//	//exclude: ".noExl",
		//	name: "Worksheet Name",
		//	filename: (new Date).toDateInputValue()+"_"+$scope.sessionUserData.businessName+"_"+reportYear
		//	}); 
		
		// if($scope.sessionUserData.packageValid !== true)
		if(false)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			document.location.href = 'php_data/cashflowCompareExport.php?business_id=1&startDate='+$scope.report.startDate+'&endDate='+$scope.report.endDate+'&type='+$scope.queryReportType+'&download=true';
		}
		
		//$http.get('php_data/cashflowCompareExport.php?business_id=1&startDate='+$scope.report.startDate+'&endDate='+$scope.report.endDate+'&type='+$scope.queryReportType)
		//.success(function(result) {	
		//		console.log(result)
		//	}).error(function(errRes) {
		//		console.log('err');
		//		console.log(errRes);
		//});
     }
	 
	
	});

	
	
}]);
