angular.module('MetronicApp').controller('ReportCashFlowGraphController', ['$rootScope', '$scope', 'settings', '$http',function($rootScope, $scope, settings,$http) {
    $scope.$on('$viewContentLoaded', function() {   
		// initialize core components
		App.initAjax();
		// set default layout mode
		$rootScope.settings.layout.pageContentWhite = true;
		$rootScope.settings.layout.pageBodySolid = false;
		$rootScope.settings.layout.pageSidebarClosed = false;
		
		$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
		var monthNames = [ "มกราคม", "กุมภาพันธ์", "มีนาคม", "เมษายน", "พฤษภาคม", "มิถุนายน", "กรกฎาคม", "สิงหาคม", "กันยายน",  "ตุลาคม",  "พฤศจิกายน",  "ธันวาคม"];
		
		//var date = new Date();
		//var firstDay = new Date(date.getFullYear(), date.getMonth(), 1);
		//var lastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);
		
		var date = new Date();
		var firstDayTemp = new Date(date.getFullYear(), date.getMonth(), 1);
		var firstDay = ("0"+(firstDayTemp.getDate())).slice(-2)+"-"+("0"+(firstDayTemp.getMonth()+1)).slice(-2)+"-"+firstDayTemp.getFullYear();
		var lastDayTemp = new Date(date.getFullYear(), date.getMonth() + 1, 0);
		var lastDay = ("0"+(lastDayTemp.getDate())).slice(-2)+"-"+("0"+(lastDayTemp.getMonth()+1)).slice(-2)+"-"+lastDayTemp.getFullYear();
		$scope.pieSumTotal = 0;

		$scope.reportType = {
			'1' : 'ตามจริง',
			'2' : 'ประมาณการ'
		}
		$scope.queryReportType = 2;
		$scope.queryReportCategory = 4;
		$scope.cashflowCompare = false;

		$scope.report = {
			'startDate'	:	firstDay,
			'endDate'		:	lastDay,
			'monthName'	:	monthNames[date.getMonth()],
			'headerType' : $scope.reportType[$scope.queryReportType]
		};

		$scope.graphChartVisible = {
			initSinglePie 	: 	false,
			initAllPie		:	false,
			initColumnLines		:	false
		}

	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});

	$scope.summaryCashFlowAdvanced = {
		'receivings' 	: 	0,
		'expenses'	:	0
	}
	$scope.queryReportSelect = {
		reportType  : "2"
	}
	$scope.queryReportCategorySelect = {
		reportCategory  : "4"
	}
	
	$scope.getReportCashFlowSummary = function (start,end) {

			$http.get('php_data/getCashflowGraph.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType+'&category='+$scope.queryReportCategory,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} )
			.success(function(data) {
				$scope.cashflowSummary = data['summary'];
				$scope.summaryCashFlowAdvanced.receivings = data['rcv_adv_summ'];
				$scope.summaryCashFlowAdvanced.expenses = data['exp_adv_summ'];
				//console.log(data);
				//$scope.sumTotal = parseFloat(data['summary']['cfo']['summary']) + parseFloat(data['summary']['cfi']['summary']) + parseFloat(data['summary']['cff']['summary']);
					if($scope.queryReportType == 1 )
					{
						$scope.graphChartVisible.initColumnLines = false;

						if($scope.queryReportCategory == 4 )
						{
							$scope.graphChartVisible.initAllPie = true;
							$scope.graphChartVisible.initSinglePie = false;
							//console.log(data);
							var summTotal = data.summary.cfo.summary+data.summary.cff.summary+data.summary.cfi.summary;
							//console.log(summTotal);
							$scope.pieSumTotal = summTotal;
							$scope.pieSumColor = (summTotal < 0) == true ? "red" : "green";
							setTimeout(function(){ $scope.initAllPieCharts(data)},0);
						}
						else if ($scope.queryReportCategory < 4 )
						{
							$scope.graphChartVisible.initSinglePie = true;
							$scope.graphChartVisible.initAllPie = false;
							setTimeout(function(){ $scope.initSinglePieChart(data)},0);
						}
					}
					else if ($scope.queryReportType == 2)
					{
						//console.log(data);
						$scope.graphChartVisible.initColumnLines = true;
						$scope.graphChartVisible.initSinglePie = false;
						$scope.graphChartVisible.initAllPie = false;
						setTimeout(function(){ $scope.initColumnLineChart(data,$scope.queryReportCategory,'column')},0);
					}
					else if ($scope.queryReportType == 3)
					{
						//console.log(data);
						$scope.graphChartVisible.initColumnLines = true;
						$scope.graphChartVisible.initSinglePie = false;
						$scope.graphChartVisible.initAllPie = false;
						setTimeout(function(){ $scope.initColumnLineChart(data,$scope.queryReportCategory,'line')},0);
					}
				})
			.error(function(err) {console.log(err);} );

	}
	
	$scope.queryReport = function() 
	{
		var start_date = $scope.report.startDate;
		var end_date = $scope.report.endDate;
		$scope.getReportCashFlowSummary(start_date,end_date);
	}

	$scope.setReportType = function() 
	{
		$scope.queryReportType = $scope.queryReportSelect.reportType;
	}

	//$scope.setReportCategory = function(reportCategory) 
	//{
	//	$scope.queryReportCategory = reportCategory;
	//}

	$scope.setReportCategory = function()
	{
		$scope.queryReportCategory = $scope.queryReportCategorySelect.reportCategory;
	}
	
$scope.getReportCashFlowSummary($scope.report.startDate,$scope.report.endDate);

$scope.initSinglePieChart = function (chartData)
	{
		//console.log(chartData);
		var sumData = chartData['summary'][chartData['chartType']]['summary_formatted'];
		var rcvData = (chartData['rcv'][chartData['chartType']] !== undefined) ? chartData['rcv'][chartData['chartType']]['trans_val'] : 0;
		var expData = (chartData['exp'][chartData['chartType']] !== undefined) ? chartData['exp'][chartData['chartType']]['trans_val'] : 0;
		var chartTypesText = {
			'cfo'	:	'ดำเนินงาน',
			'cfi'	:	'ลงทุน',
			'cff'	:	'จัดหาเงิน'
		}
		rcvData = (rcvData == 0 && expData == 0) == true ? 100 : rcvData;
		if(sumData.substring(0,1) == "-")
		{
			sumData = sumData.substring(1);
			var dataColor = "red";
		}
		else
		{
			var dataColor = "green";
		}
		
		if(rcvData == "0.00" && expData == "0.00")
		{
			var startingColor = "#afbbc2";
		}
		else
		{
			var startingColor = "#01A79D";
		}
		
		
		Highcharts.setOptions({
			   credits: {
				enabled: false
			   },
			   noData : {
				   position: {
					align: "center",
					verticalAlign: "bottom"
				   }
			   },

		});

		   Highcharts.chart('chart1', {
        chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie'
        },
        title: {
            text: chartTypesText[chartData['chartType']]+' <br><br>'+sumData,
			style: {
        		 color: dataColor,
			},
			verticalAlign: 'middle'
        },
        plotOptions: {
            pie: {
                allowPointSelect: false,
			  innerSize: "60%",
                dataLabels: {
                    enabled: false
                }
            }
        },
        series: [{
            name: 'ยอดรวม',
            colorByPoint: true,
            data: [{
                name: 'รับเงิน',
				//color: '#01A79D',
				color: startingColor,
                y: rcvData
            }, {
                name: 'จ่ายเงิน',
				color: '#f05b4f',
                y: expData
            }]
        }]
    });

	}



	$scope.initAllPieCharts = function (chartData)
	{

		var sumDataCFO = chartData['summary']['cfo']['summary_formatted'];
		var rcvDataCFO = (chartData['rcv']['cfo'] !== undefined) ? chartData['rcv']['cfo']['trans_val'] : 0;
		var expDataCFO = (chartData['exp']['cfo'] !== undefined) ? chartData['exp']['cfo']['trans_val'] : 0;
		var mouseHoverCFO = (rcvDataCFO == 0 && expDataCFO == 0) == true ? false : true;
		rcvDataCFO = (rcvDataCFO == 0 && expDataCFO == 0) == true ? 100 : rcvDataCFO;

		var sumDataCFF = chartData['summary']['cff']['summary_formatted'];
		var rcvDataCFF = (chartData['rcv']['cff'] !== undefined) ? chartData['rcv']['cff']['trans_val'] : 0;
		var expDataCFF = (chartData['exp']['cff'] !== undefined) ? chartData['exp']['cff']['trans_val'] : 0;
		var mouseHoverCFF = (rcvDataCFF == 0 && expDataCFF == 0) == true ? false : true;
		rcvDataCFF = (rcvDataCFF == 0 && expDataCFF == 0) == true ? 100 : rcvDataCFF;

		var sumDataCFI = chartData['summary']['cfi']['summary_formatted'];
		var rcvDataCFI = (chartData['rcv']['cfi'] !== undefined) ? chartData['rcv']['cfi']['trans_val'] : 0;
		var expDataCFI = (chartData['exp']['cfi'] !== undefined) ? chartData['exp']['cfi']['trans_val'] : 0;
		var mouseHoverCFI = (rcvDataCFI == 0 && expDataCFI == 0) == true ? false : true;
		rcvDataCFI = (rcvDataCFI == 0 && expDataCFI == 0) == true ? 100 : rcvDataCFI;

		var sumTotal = sumDataCFO+sumDataCFF+sumDataCFI;
		
		var dataColorCFO = (sumDataCFO.substring(0,1) == "-") == true ? "red" : "green";
		sumDataCFO = (sumDataCFO.substring(0,1) == "-") == true ? sumDataCFO.substring(1) : sumDataCFO;
		var dataColorCFF = (sumDataCFF.substring(0,1) == "-") == true ? "red" : "green";
		sumDataCFF = (sumDataCFF.substring(0,1) == "-") == true ? sumDataCFF.substring(1) : sumDataCFF;
		var dataColorCFI = (sumDataCFI.substring(0,1) == "-") == true ? "red" : "green";
		sumDataCFI = (sumDataCFI.substring(0,1) == "-") == true ? sumDataCFI.substring(1) : sumDataCFI;
		
		Highcharts.setOptions({
			   credits: {
				enabled: false
			   },
			   noData : {
				   position: {
					align: "center",
					verticalAlign: "bottom"
				   }
			   },

		});

		
		if(rcvDataCFO == 100 && expDataCFO == "0.00")
		{
			var startingColorCFO = "#afbbc2";
		}
		else
		{
			var startingColorCFO = "#01A79D";
		}
		
		if(rcvDataCFI == 100 && expDataCFI == "0.00")
		{
			var startingColorCFI = "#afbbc2";
			
		}
		else
		{
			var startingColorCFI = "#01A79D";
		}
		
		if(rcvDataCFF == 100 && expDataCFF == "0.00")
		{
			var startingColorCFF = "#afbbc2";
		}
		else
		{
			var startingColorCFF = "#01A79D";
		}
		
		
		
		
		   Highcharts.chart('chart1', {
        chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie'
        },
        title: {
            text: 'ดำเนินงาน <br>'+sumDataCFO,
			style: {
        		 color: dataColorCFO,
			},
			verticalAlign: 'middle'
        },
        plotOptions: {
            pie: {
                allowPointSelect: false,
			  innerSize: "60%",
                dataLabels: {
                    enabled: false
                },
				enableMouseTracking : mouseHoverCFO
            }
        },
        series: [{
            name: 'ยอดรวม',
            colorByPoint: true,
            data: [{
                name: 'รับเงิน',
				//color: '#01A79D',
				color: startingColorCFO,
                y: rcvDataCFO
            }, {
                name: 'จ่ายเงิน',
				color: '#f05b4f',
                y: expDataCFO
            }]
        }]
    });

	Highcharts.chart('chart2', {
        chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie'
        },
        title: {
			text: 'ลงทุน <br>'+sumDataCFI,
			style: {
        		 color: dataColorCFI,
			},
			verticalAlign: 'middle'
        },
       // tooltip: {
       //     pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
       // },
        plotOptions: {
            pie: {
                allowPointSelect: false,
				innerSize: "60%",
                dataLabels: {
                    enabled: false
                },
				enableMouseTracking : mouseHoverCFI
            }
        },
        series: [{
            name: 'ยอดรวม',
            colorByPoint: true,
            data: [{
                name: 'รับเงิน',
				//color: '#01A79D',
				color: startingColorCFI,
                y: rcvDataCFI
            }, {
                name: 'จ่ายเงิน',
				color: '#f05b4f',
                y: expDataCFI
            }]
        }]
    });


	Highcharts.chart('chart3', {
        chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie'
        },
        title: {
			text: 'จัดหาเงิน <br>'+sumDataCFF,
			style: {
        		 color: dataColorCFF,
			},
			verticalAlign: 'middle'
        },
       // tooltip: {
       //     pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
       // },
        plotOptions: {
            pie: {
                allowPointSelect: false,
			  	innerSize: "60%",
                dataLabels: {
                    enabled: false
                },
				enableMouseTracking : mouseHoverCFF
            }
        },
        series: [{
            name: 'ยอดรวม',
            colorByPoint: true,
            data: [{
                name: 'รับเงิน',
				//color: '#01A79D',
				color: startingColorCFF,
                y: rcvDataCFF
            }, {
                name: 'จ่ายเงิน',
				color: '#f05b4f',
                y: expDataCFF
            }]
        }]
    });


	}

	$scope.initColumnLineChart = function(chartData,category,chartType)
	{
		var cfoData = [];
		var cffData = [];
		var cfiData = [];
		var xAxisData = [];
		var baseLine = [];

		var yMax = 0;
		var yMin = 0;


		var cfoColor = '#7cb5ec';
		var cfiColor = '#db9715';
		var cffColor = '#44b6ae';

		var cfoName = 'ดำเนินงาน';
		var cffName = 'จัดหาเงิน';
		var cfiName = 'ลงทุน';

		var chartDates = chartData['report_header'] ;

		for(var day_i = 0; day_i < chartData.number_of_days; day_i++)
		{
			xAxisData.push(chartData['period_array'][day_i].replace("-","/"));
			cfoData.push(chartData['cfo'][day_i]);
			yMax = (chartData['cfo'][day_i] > yMax) ? chartData['cfo'][day_i] : yMax;
			yMin = (chartData['cfo'][day_i] < yMin) ? chartData['cfo'][day_i] : yMin;

			cffData.push(chartData['cff'][day_i]);
			yMax = (chartData['cff'][day_i] > yMax) ? chartData['cff'][day_i] : yMax;
			yMin = (chartData['cff'][day_i] < yMin) ? chartData['cff'][day_i] : yMin;

			cfiData.push(chartData['cfi'][day_i]);
			yMax = (chartData['cfi'][day_i] > yMax) ? chartData['cfi'][day_i] : yMax;
			yMin = (chartData['cfi'][day_i] < yMin) ? chartData['cfi'][day_i] : yMin;

			baseLine.push(0);
		}

		if(category == 1)
		{
			var seriesData = [{ name : cfoName, data : cfoData, color: cfoColor }]
		}
		if(category == 2)
		{
			var seriesData = [{ name : cfiName, data : cfiData, color: cfiColor }]
		}
		if(category == 3)
		{
			var seriesData = [{ name : cffName, data : cffData, color: cffColor }]
		}
		if(category == 4)
		{
			var seriesData = [{ name : cfoName, data : cfoData, color: cfoColor },{ name : cfiName, data : cfiData, color: cfiColor },{ name : cffName, data : cffData, color: cffColor }, { name: 'Base Lines', type: 'line', color: 'black', crosshair: false,lineWidth: 0.5, data: baseLine, enableMouseTracking : false, showInLegend: false}]
		}
		
		Highcharts.setOptions({
			   credits: {
				enabled: false
			   },
			   noData : {
				   position: {
					align: "center",
					verticalAlign: "bottom"
				   }
			   },

		});

		Highcharts.chart('chart1', {
		        chart: {
		            type: chartType
		        },
			   title: {
				text: ''
			   },
		     //   title: {
		     //       text: 'รายงานกระแสเงินสด'
		     //   },
			//	subtitle: {
			//		text: chartDates
			//	},
		        xAxis: {
		            //categories: ['Africa', 'America', 'Asia', 'Europe', 'Oceania']
		            categories: xAxisData
		        },
		        yAxis: {
		            min: yMin,
					max: yMax,
					title: ""
		            //title: {
		            //    text: 'Population (millions)',
		            //    align: 'high'
		            //},
		            //labels: {
		            //    overflow: 'justify'
		            //}
		        },
		        //tooltip: {
		        //    valueSuffix: ' millions'
		        //},
		        plotOptions: {
		            column: {
		                dataLabels: {
		                    enabled: false
		                }
		            },
					line: {
           			    marker: {
           			        enabled: false
           			    },
           			    tooltop: {
           			        enabled: false
           			    },
           			    dataLabels: { 
           			        enabled: false 
           			    },
           			    allowPointSelect: false,
           			    states: {
           			        hover: {
           			            enabled: false
           			        }
           			    }
           			}
		        },
		        legend: {
		            layout: 'vertical',
		            align: 'right',
		            verticalAlign: 'top',
		            x: -40,
		            y: 80,
		            floating: true,
		            borderWidth: 1,
		            backgroundColor: ((Highcharts.theme && Highcharts.theme.legendBackgroundColor) || '#FFFFFF'),
		            shadow: true
		        },
		        credits: {
		            enabled: false
		        },
				series: seriesData
		        // series: [{
		        //     name: 'CFO',
		        //     //data: [5, 3, 4, 7, 2] //cfoSummary
		        //     data: cfoData,
				// 	color: '#7cb5ec'
		        // }, {
		        //     name: 'CFI',
		        //     //data: [2, 2, 3, 2, 1] //cfiSummary
		        //     data: cfiData,
				// 	color: '#db9715'
		        // }, {
		        //     name: 'CFF',
		        //     //data: [3, 4, 4, 2, 5] //cffSummary
		        //     data: cffData,
				// 	color: '#44b6ae'
		        // }]
		    });
	}
	//$scope.initHighChartsPie("");


	    });
}]);
