angular.module('MetronicApp').controller('ReportCashFlowTableController', ['$rootScope', '$scope', 'settings', '$http','$filter',function($rootScope, $scope, settings,$http,$filter) {
    $scope.$on('$viewContentLoaded', function() {   
		// initialize core components
		App.initAjax();
	
		// set default layout mode
		$rootScope.settings.layout.pageContentWhite = true;
		$rootScope.settings.layout.pageBodySolid = false;
		$rootScope.settings.layout.pageSidebarClosed = false;
	});
	
	$scope.cashflowSummaryContent = "<p>กระแสเงินสดสุทธิสำหรับระยะเวลา เพิ่มขึ้น  <u>3,848,500</u> บาท"
				+" เป็นการเพิ่มขึ้นจากกิจกรรมดำเนินงาน จำนวน <u>2,991,500</u> บาท"
				+" โดยมีการรับเงินระหว่างเดือนทั้งสิ้น <u>7,905,300 </u>บาท"
				+" มาจาก อาหาร เป็นเงิน <u>4,535,800</u> บาท คิดเป็น 57.4%"
				+" รองลงมาประกอบด้วย สินค้าอุปโภค เป็นเงิน 2,800,000 บาท คิดเป็น 35.4% ตามลำดับ</p>"
				+"<p>ในด้านรายจ่ายเพื่อกิจกรรมดำเนินงาน มากกว่า 44.7% เป็นการจ่ายเพื่อ อาหาร เป็นเงิน 2,198,400 บาท"
				+" นอกจากนี้ ในระหว่างเดือน ได้มีการจ่ายลงทุนไปทั้งสิ้น 1,200,000 บาท"
				+" เพื่อ เงินสดจ่ายลงทุน จำนวนเงิน 1,200,000 บาท คิดเป็น 100% ของเงินลงทุนทั้งหมด"
				+ " ในด้านของการจัดหาเงินนั้น กิจการได้มีการจัดหาเงินจำนวน 2,057,000 บาท"
				+ " โดยเป็นการจัดหาเงินจาก เงินสดรับจากการกู้ยืม จำนวน 1,200,000 บาท คิดเป็น 52.2%, เงินสดรับจากการลงทุน จำนวน 1,100,000 บาท คิดเป็น 47.8%"
				+" และมีการจ่ายคืนเงิน เพื่อ อื่นๆ จำนวน 134,000 บาท คิดเป็น 55.1%, เงินสดจ่ายชำระเงินกู้ 109,000 บาท คิดเป็น 44.9%</p>";
				
				
	$scope.BI = {
			show: function(){
				$('#BIModal').modal({
					backdrop: 'static',
					show: 'true'
				});
			},
			title: "บทวิเคราะห์กระแสเงินสด",
			content: $scope.cashflowSummaryContent
	};
	
	
	
	$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
		var monthNames = { 
			"01"	:	"มกราคม", 
			"02"	:	"กุมภาพันธ์", 
			"03"	:	"มีนาคม", 
			"04"	:	"เมษายน", 
			"05"	:	"พฤษภาคม", 
			"06"	:	"มิถุนายน", 
			"07"	:	"กรกฎาคม", 
			"08"	:	"สิงหาคม", 
			"09"	:	"กันยายน",  
			"10"	:	"ตุลาคม",  
			"11"	:	"พฤศจิกายน",  
			"12"	:	"ธันวาคม"
		};
	


		var date = new Date();
		//var firstDayTemp = new Date(date.getFullYear(), date.getMonth()-1, 1);
		var firstDayTemp = new Date(date.getFullYear(), date.getMonth(), 1);
		var curYear = firstDayTemp.getFullYear();
		var firstDay = ("0"+(firstDayTemp.getDate())).slice(-2)+"-"+("0"+(firstDayTemp.getMonth()+1)).slice(-2)+"-"+firstDayTemp.getFullYear();
		//var lastDayTemp = new Date(date.getFullYear(), date.getMonth(), 0);
		var lastDayTemp = new Date(date.getFullYear(), date.getMonth()+1, 0);
		var lastDay = ("0"+(lastDayTemp.getDate())).slice(-2)+"-"+("0"+(lastDayTemp.getMonth()+1)).slice(-2)+"-"+lastDayTemp.getFullYear();
		var curMonth = ("0"+(firstDayTemp.getMonth()+1)).slice(-2);
		var nextMonth = (firstDayTemp.getMonth()+1) == 12 ? "12" : ("0"+(firstDayTemp.getMonth()+2)).slice(-2);
		$scope.reportType = {
			'1' : 'ตามจริง',
			'2' : 'ประมาณการ'
		}
		$scope.queryReportType = 1;
		$scope.refreshTable = {
			'type' : 1
		};
		$scope.cashflowCompare = false;
		//$scope.excelFormat = {
		//	displayType : 3
		//};

		$scope.report = {
			'startDate'		:	firstDay.toString(),
			'endDate'			:	lastDay.toString(),
			'monthName'		:	monthNames[date.getMonth()],
			'headerType'		:	$scope.reportType[$scope.queryReportType],
			'forYear'			:	curYear.toString(),
			'startMonth'		:	curMonth.toString(),
			'endMonth'		:	nextMonth.toString(),
			'excelFormatType'	:	"3"
		};
		
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	$scope.queryReportSelect = {
		reportType  : "1"
	}

	$scope.getReportCashFlowSummary = function (start,end,year) {
		
			$http.get('php_data/getUserSessions.php?business_id=1&session_id='+$scope.usingCookies)
			.success(function(data2) {
			if(data2.success)
			{
				$scope.sessionUserData.reportHidden = data2.report_hidden;
				$scope.sessionUserData.reportDeleted = data2.report_deleted;
				$scope.sessionUserData.reportLevels = data2.report_levels;
			}
			});
			
			var reportYear = year == "" ? $scope.report.forYear : year;
			
			//var getLink = $scope.sessionUserData.memberId == '873' ? 'php_data/cashFlowExport.php?business_id=1&report_start_date='+$scope.report.startDate+'&report_end_date='+$scope.report.endDate+'&report_year='+reportYear+'&display_report_type='+$scope.queryReportType+'&display_report_type='+$scope.queryReportType+'&excel_report_format='+$scope.report.excelFormatType+'&report_for_year='+$scope.report.forYear+'&report_start_month='+$scope.report.startMonth+'&report_end_month='+$scope.report.endMonth+'&download=false' : 'php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType;
			var getLink = 'php_data/cashFlowExport.php?business_id=1&report_start_date='+$scope.report.startDate+'&report_end_date='+$scope.report.endDate+'&report_year='+reportYear+'&display_report_type='+$scope.queryReportType+'&display_report_type='+$scope.queryReportType+'&excel_report_format='+$scope.report.excelFormatType+'&report_for_year='+$scope.report.forYear+'&report_start_month='+$scope.report.startMonth+'&report_end_month='+$scope.report.endMonth+'&download=false';
			
			//var getLink = 'php_data/cashFlowExport.php?business_id=1&report_start_date='+$scope.report.startDate+'&report_end_date='+$scope.report.endDate+'&report_year='+reportYear+'&display_report_type='+$scope.queryReportType+'&display_report_type='+$scope.queryReportType+'&excel_report_format='+$scope.report.excelFormatType+'&report_for_year='+$scope.report.forYear+'&report_start_month='+$scope.report.startMonth+'&report_end_month='+$scope.report.endMonth+'&download=false';
	
			//console.log(getLink);
	
			//$http.get('php_data/getCashflowReport.php?business_id=1&startDate='+start+'&endDate='+end+'&type='+$scope.queryReportType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} )
			$http.get(getLink,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} )
			.success(function(data) {
					//$('.BI-header').html(data['header']);
					$('.BI-content').html(data['content']);
					//$('.BI-footer').html(data['footer']);
				//if($scope.sessionUserData.memberId == '873')
				//{
					if($scope.report.excelFormatType == '1')
					{
						$scope.monthHeaders = { 
							0		:		'ม.ค.',
							1		:		'ก.พ.',
							2		:		'มี.ค.',
							3		:		'เม.ษ.',
							4		:		'พ.ค.',
							5		:		'มิ.ย.',
							6		:		'ก.ค.',
							7		:		'ส.ค.',
							8		:		'ก.ย.',
							9		:		'ต.ค.',
							10		:		'พ.ย.',
							11		:		'ธ.ค.'
						};	
						$scope.loopArrays = {
							0		:	"01",
							1		:	"02",
							2		:	"03",
							3		:	"04",
							4		:	"05",
							5		:	"06",
							6		:	"07",
							7		:	"08",
							8		:	"09",
							9		:	"10",
							10		:	"11",
							11		:	"12"
						}
						$scope.loopLength = 12;
						$scope.cashflowSummary = data['summary'];
						$scope.sumTotal = data['summAll'];
						
						$scope.rcvMenu = {
							'CFO' : data['rcvHeader']['cfo'],
							'CFI' : data['rcvHeader']['cfi'],
							'CFF' : data['rcvHeader']['cff']
						}
						
						$scope.expMenu = {
							'CFO' : data['expHeader']['cfo'],
							'CFI' : data['expHeader']['cfi'],
							'CFF' : data['expHeader']['cff']
						}
						
						$scope.cashflowRCV = {
							'rcvData' : data['rcv']
						};
						$scope.cashflowEXP = {
							'expData' : data['exp']
						};
					}
					else if($scope.report.excelFormatType == '2')
					{
						$scope.fullLoopArrays = {
							0		:	"01",
							1		:	"02",
							2		:	"03",
							3		:	"04",
							4		:	"05",
							5		:	"06",
							6		:	"07",
							7		:	"08",
							8		:	"09",
							9		:	"10",
							10		:	"11",
							11		:	"12"
						}
						$scope.fullMonthHeaders = { 
							0		:		'ม.ค.',
							1		:		'ก.พ.',
							2		:		'มี.ค.',
							3		:		'เม.ษ.',
							4		:		'พ.ค.',
							5		:		'มิ.ย.',
							6		:		'ก.ค.',
							7		:		'ส.ค.',
							8		:		'ก.ย.',
							9		:		'ต.ค.',
							10		:		'พ.ย.',
							11		:		'ธ.ค.'
						};	
						
						var startMonthLoop = parseInt(data['reportStartMonth'])-1;
						var endMonthLoop = parseInt(data['reportEndMonth'])-1;
						
						
						$scope.loopArrays = {}
						$scope.monthHeaders = {}
						for(var loopCheck = startMonthLoop; loopCheck <= endMonthLoop; loopCheck++)
						{
							$scope.loopArrays[loopCheck] = $scope.fullLoopArrays[loopCheck];
							$scope.monthHeaders[loopCheck] = $scope.fullMonthHeaders[loopCheck];
						}
						
						$scope.loopLength = endMonthLoop - startMonthLoop + 1;
						$scope.cashflowSummary = data['summary'];
						$scope.sumTotal = data['summAll'];
						
						$scope.rcvMenu = {
							'CFO' : data['rcvHeader']['cfo'],
							'CFI' : data['rcvHeader']['cfi'],
							'CFF' : data['rcvHeader']['cff']
						}
						
						$scope.expMenu = {
							'CFO' : data['expHeader']['cfo'],
							'CFI' : data['expHeader']['cfi'],
							'CFF' : data['expHeader']['cff']
						}
						
						$scope.cashflowRCV = {
							'rcvData' : data['rcv']
						};
						$scope.cashflowEXP = {
							'expData' : data['exp']
						};
					}
					else if($scope.report.excelFormatType == '3')
					{
						$scope.cashflowSummary = data['summary']['period'];
						$scope.sumTotal = parseFloat((data['summary']['period']['cfo'] !== undefined) ? data['summary']['period']['cfo']['summary'] : 0.00) + parseFloat((data['summary']['period']['cfi'] !== undefined) ? data['summary']['period']['cfi']['summary'] : 0.00) + parseFloat((data['summary']['period']['cff'] !== undefined) ? data['summary']['period']['cff']['summary'] : 0.00);
						if ($scope.queryReportType == 3) 
						{
							$scope.sumTotalForecast = parseFloat((data['summary']['period']['cfo'] !== undefined) ? data['summary']['period']['cfo']['summary_forecast'] : 0.00) + parseFloat((data['summary']['period']['cfi'] !== undefined) ? data['summary']['period']['cfi']['summary_forecast'] : 0.00) + parseFloat((data['summary']['period']['cff'] !== undefined) ? data['summary']['period']['cff']['summary_forecast'] : 0.00);
							$scope.sumTotalDifference = $scope.sumTotal - $scope.sumTotalForecast;
						}
						$scope.cashflowRCV = {
							'CFO' : data['rcv']['period']['cfo'],
							'CFF' : data['rcv']['period']['cff'],
							'CFI' : data['rcv']['period']['cfi']
						};
						$scope.cashflowEXP = {
							'CFO' : data['exp']['period']['cfo'],
							'CFF' : data['exp']['period']['cff'],
							'CFI' : data['exp']['period']['cfi']
						};
					}
					
					$scope.refreshTable.type = $scope.report.excelFormatType;
				//}
				//else
				//{
				//	$scope.cashflowSummary = data['summary'];
				//	$scope.sumTotal = parseFloat((data['summary']['cfo'] !== undefined) ? data['summary']['cfo']['summary'] : 0.00) + parseFloat((data['summary']['cfi'] !== undefined) ? data['summary']['cfi']['summary'] : 0.00) + parseFloat((data['summary']['cff'] !== undefined) ? data['summary']['cff']['summary'] : 0.00);
				//	if ($scope.queryReportType == 3) 
				//	{
				//		$scope.sumTotalForecast = parseFloat((data['summary']['cfo'] !== undefined) ? data['summary']['cfo']['summary_forecast'] : 0.00) + parseFloat((data['summary']['cfi'] !== undefined) ? data['summary']['cfi']['summary_forecast'] : 0.00) + parseFloat((data['summary']['cff'] !== undefined) ? data['summary']['cff']['summary_forecast'] : 0.00);
				//		$scope.sumTotalDifference = $scope.sumTotal - $scope.sumTotalForecast;
				//	}
				//	$scope.cashflowRCV = {
				//		'CFO' : data['rcv']['cfo'],
				//		'CFF' : data['rcv']['cff'],
				//		'CFI' : data['rcv']['cfi']
				//	};
				//	$scope.cashflowEXP = {
				//		'CFO' : data['exp']['cfo'],
				//		'CFF' : data['exp']['cff'],
				//		'CFI' : data['exp']['cfi']
				//	};
				//
				//	$scope.refreshTable.type = $scope.report.excelFormatType;
				//}
			})
			.error(function(err) {console.log(err);} );
		if($scope.queryReportType == 1 || $scope.queryReportType == 2)
		{
			$scope.cashflowCompare = false;
			$scope.report.headerType = $scope.reportType[$scope.queryReportType];
		}
		else if ($scope.queryReportType == 3)
		{
			$scope.cashflowCompare = true;
			$scope.report.headerType = "ตามจริง";
		}
	}
	
	//$scope.getReportCashFlowSummary("","","");
	$scope.getReportCashFlowSummary($scope.report.startDate,$scope.report.endDate,$scope.report.forYear);
	$scope.queryReport = function() 
	{
		var start_date = $scope.report.startDate;
		var end_date = $scope.report.endDate;

		if($scope.report.excelFormatType == "1")
		{
			var reportYear = $scope.report.forYear;
		}
		else if($scope.report.excelFormatType == "2")
		{
			var reportYear = $scope.report.forYear;
		}
		else if($scope.report.excelFormatType == "3")
		{
			var reportYear = (end_date).substr(6,4);
		}
		
		$scope.getReportCashFlowSummary(start_date,end_date,reportYear);
	}
	
	$scope.setReportType = function(reportType) 
	{
		$scope.queryReportType = $scope.queryReportSelect.reportType;
	}
	
	$scope.tableToExcel = (function() {
	
		var reportYear = ($scope.report.endDate).substr(6,4);
		
		//if($scope.report.excelFormatType == 1 || $scope.report.excelFormatType == 3)
		//{
		// if($scope.sessionUserData.packageValid !== true)
		if(false)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			document.location.href = 'php_data/cashFlowExport.php?business_id=1&report_start_date='+$scope.report.startDate+'&report_end_date='+$scope.report.endDate+'&report_year='+reportYear+'&display_report_type='+$scope.queryReportType+'&display_report_type='+$scope.queryReportType+'&excel_report_format='+$scope.report.excelFormatType+'&report_for_year='+$scope.report.forYear+'&report_start_month='+$scope.report.startMonth+'&report_end_month='+$scope.report.endMonth+'&download=true';
		}
		//}
		//else
		//{
		//	$http.get('php_data/cashFlowExport.php?business_id=1&report_start_date='+$scope.report.startDate+'&report_end_date='+$scope.report.endDate+'&report_year='+reportYear+'&display_report_type='+$scope.queryReportType+'&display_report_type='+$scope.queryReportType+'&excel_report_format='+$scope.report.excelFormatType+'&report_for_year='+$scope.report.forYear+'&report_start_month='+$scope.report.startMonth+'&report_end_month='+$scope.report.endMonth)
		//	.success(function(result) {	
		//			console.log(result)
		//		}).error(function(errRes) {
		//			console.log('err');
		//			console.log(errRes);
		//	});
		//}
	})
	
			
	$scope.$watch('report.startMonth', function() {
		$scope.report.endMonth = ($scope.report.endMonth < $scope.report.startMonth) ? $scope.report.startMonth : $scope.report.endMonth;
	});

	$scope.$watch('report.endMonth', function() {
		$scope.report.startMonth = ($scope.report.startMonth > $scope.report.endMonth) ? $scope.report.endMonth : $scope.report.startMonth;
	});
	
}]);
