angular.module('MetronicApp').controller('ReportCreditorTableController', function($rootScope, $scope, settings, $accData, filterFilter, $http, $dbService) {
    $scope.$on('$viewContentLoaded', function() {   
		// initialize core components
		App.initAjax();
	    });
	/**init acc data via resolve **/
	$scope.accountsData = $accData.data;
	//console.log($accData.data);
	$scope.currentDateTimeStamp = $accData.currentDate;
	//console.log(($scope.accountsData));
	// set default layout mode
	$rootScope.settings.layout.pageContentWhite = true;
	$rootScope.settings.layout.pageBodySolid = false;
	$rootScope.settings.layout.pageSidebarClosed = false;

	$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
	var monthNames = [ "มกราคม", "กุมภาพันธ์", "มีนาคม", "เมษายน", "พฤษภาคม", "มิถุนายน", "กรกฎาคม", "สิงหาคม", "กันยายน",  "ตุลาคม",  "พฤศจิกายน", "ธันวาคม"];
	var date = new Date();
	var firstDayTemp = new Date(date.getFullYear(), date.getMonth(), 1);
	var firstDay = ("0"+(firstDayTemp.getDate())).slice(-2)+"-"+("0"+(firstDayTemp.getMonth()+1)).slice(-2)+"-"+firstDayTemp.getFullYear();
	var lastDayTemp = new Date(date.getFullYear(), date.getMonth() + 1, 0);
	var lastDay = ("0"+(lastDayTemp.getDate())).slice(-2)+"-"+("0"+(lastDayTemp.getMonth()+1)).slice(-2)+"-"+lastDayTemp.getFullYear();

	$scope.report = {
		'startDate'	:	firstDay,
		'endDate'	:	lastDay,
		'monthName'	:	monthNames[date.getMonth()]
	};

	$scope.compareZero = 0.00;
	$scope.accountDetailView = 0;
	$scope.showDate = "";
	
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = local.getFullYear()+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+("0"+(local.getDate())).slice(-2)+" 00:00:00";
		return newDate;
	});
	var curDate = new Date(date.toDateInputValue().split(' ').join('T'));
	$scope.currentDateTimeStamp = curDate.getTime() / 1000;

	$scope.unsetAccountDetails = function() {
		$scope.accountDetails = {
				'Name' 		: "",
				'Phone' 		: "",
				'Email' 		: "",
				'Address' 	: "",
				'Comment' 	: ""
			};		
		$scope.accountDetailView = 0;	
		$scope.showDate = "";
	}
	
	$scope.accountSummaryDetail = function (id){
		var selectedAcc = filterFilter($scope.accountsData,{account_id:id})[0];
		var accDetails = selectedAcc['account_details'];
		var accTrans = selectedAcc['data'];
		$scope.accountDetails = {
			'Name' 		: accDetails['name'],
			'Phone' 	: accDetails['telephone'],
			'Email' 	: accDetails['email'],
			'Address' 	: typeof accDetails['address'] == "string" ? accDetails['address'] : accDetails.address.addr + " " + accDetails.address.subdistrict + " " + accDetails.address.district + " " + accDetails.address.province + " " + accDetails.address.postcode ,
			'Comment' 	: accDetails['comment']
		};		
		$scope.pendingTransactions = accTrans;
		$scope.accountDetailView = 1;
		$scope.showDate = "none";
		//$('#form_accountModal').modal({
		//		backdrop: 'static',
		//		show: 'true'
		//});
	}

	$scope.fetchNewData = function(d1,d2){
		//console.log(d1+d2);
		$dbService.getAccDataSum(d1,d2,'exp').then(
			function(dat){
				console.log(dat.data);
				$scope.accountsData = dat.data.data;
				$scope.currentDateTimeStamp = $accData.data.currentDate;
				$scope.table.applyFilter();
			},
			function(err){console.log(err);}
		);
	}

	$scope.sortKey = '';
	$scope.reverse = true;
    
	$scope.tableToExcel = (function() {
		//if($scope.sessionUserData.packageValid !== true)
		if(false)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			var uri = 'data:application/vnd.ms-excel;base64,'
			, template = '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>'+$scope.report.startDate+"_"+$scope.report.endDate+'</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body><h2 style="font-weight: 500" class="center">รายงานเจ้าหนี้</h2><h3 class="center">'+$scope.sessionUserData.businessName+'</h3><div class="center">'+$scope.report.startDate+' ถึง '+$scope.report.endDate+'</div><table>{table}</table></body></html>'
			, base64 = function(s) { return window.btoa(unescape(encodeURIComponent(s))) }
			, format = function(s, c) { return s.replace(/{(\w+)}/g, function(m, p) { return c[p]; }) }
			
			return function(table, name) {
				if (!table.nodeType) table = document.getElementById(table)
				var ctx = {worksheet: name || 'Worksheet', table: table.innerHTML}
				//window.location.href = uri + base64(format(template, ctx))          
				var a = document.createElement('a');
				a.href = uri + base64(format(template, ctx));
				a.download = $scope.sessionUserData.businessName+"_รายงานเจ้าหนี้_"+$scope.report.startDate+"_"+$scope.report.endDate+'.xls';
				a.click();  
			}
		}
	})()
	
	$scope.detailedAccountsExcel = (function() {
		//if($scope.sessionUserData.packageValid !== true)
		if(false)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			var uri = 'data:application/vnd.ms-excel;base64,'
			, template = '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>'+$scope.report.startDate+"_"+$scope.report.endDate+'</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body><h2 style="font-weight: 500" class="center">รายงานเจ้าหนี้</h2><h3 class="center">'+$scope.sessionUserData.businessName+'</h3><div class="center">'+$scope.report.startDate+' ถึง '+$scope.report.endDate+'</div><table>{table}</table></body></html>'
			, base64 = function(s) { return window.btoa(unescape(encodeURIComponent(s))) }
			, format = function(s, c) { return s.replace(/{(\w+)}/g, function(m, p) { return c[p]; }) }
			
			return function(table, name) {
				if (!table.nodeType) table = document.getElementById(table)
				var ctx = {worksheet: name || 'Worksheet', table: table.innerHTML}
				//window.location.href = uri + base64(format(template, ctx))          
				var a = document.createElement('a');
				a.href = uri + base64(format(template, ctx));
				a.download = $scope.sessionUserData.businessName+"_รายงานเจ้าหนี้_"+$scope.report.startDate+"_"+$scope.report.endDate+'.xls';
				a.click();  
			}
		}
	})()
	
	
    $scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.accountsData.length
            ,maxPage:  Math.ceil($scope.accountsData.length/5)
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.accountsData.length,name:"All"}
        ],
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchTrans.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.accountsData.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        }
        // ,filter: function(mcf_id){
        //     if(mcf_id>0){
        //         $scope.filterTrans = filterFilter($scope.accountsData,{lv2_id:mcf_id});
        //     }else{
        //         $scope.filterTrans = $scope.accountsData;
        //     }
        //     this.applyFilter();
        // }
        ,applyFilter: function(){
            this.config.curPage = 1;
            this.config.records = $scope.accountsData.length;
            this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
			this.pagesOptions[3].id = this.config.records;
        }
    }		
});
