angular.module('MetronicApp').controller('RevenueHistoryCtrl',function($rootScope, $scope, settings, $http,filterFilter,$rcvMenus,$rcvTrans,$dbService,$stateParams) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();

        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;

		$scope.orgLv1Menu = ($stateParams.lv1Menu == "cfo" || $stateParams.lv1Menu == "cfi" || $stateParams.lv1Menu == "cff" ) ? $stateParams.lv1Menu : "cfo";
		$scope.orgMenuType = ($stateParams.menuType == "rcv" || $stateParams.menuType == "exp" ) ? $stateParams.menuType : "rcv" ;
		$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
	  	
		$scope.editTransId 		= 	"";
		$scope.editLv3Name		=   "";
		$scope.editLv1Menu		=   "";
		$scope.editAccountName	= 	"";
		$scope.editTransDate 	= 	"";
		$scope.editTransValue 	= 	0.00;
		$scope.editTransComment 	= 	"";
	});
    //init data from db
	$scope.rcvMenu = filterFilter($rcvMenus,{lv1_menu:$stateParams.lv1Menu});
	$scope.rcvTrans = filterFilter($rcvTrans,{lv1_menu:$stateParams.lv1Menu});
    $scope.filterTrans = $scope.rcvTrans;
	$scope.lv1Type = "";
	$scope.selectedLv2Menu = "0";
	
	$scope.rcvTransEdit = function(tranId,menuType,lv1Type) {
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.lv1Type = lv1Type;
			$dbService.getTranDetail(tranId,menuType,lv1Type)
			.success(function(dat1) {
				
				$scope.editTransId 		= 	tranId;
				$scope.editLv3Name		=   dat1[0].lv3_name;
				$scope.editLv1Menu		=   dat1[0].lv1_menu;
				$scope.editAccountName	= 	dat1[0].account_name;
				$scope.editTransValue 	= 	parseFloat(dat1[0].trans_val,2);
				$scope.editTransComment = 	dat1[0].trans_comment;
				$scope.editTransDate 	= 	dat1[0].trans_date;
				
				$('#form_editRcvTrans').modal({
					backdrop: 'static',
					show: 'true'
				});
			})
			.error(function(err) {console.log(err);} );
		}
	}
	
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	
	$scope.rcvTransDelete = function(tranId,menuType,lv1Type) {
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$dbService.delTran(tranId,menuType,lv1Type,$scope.sessionUserData.userId,$scope.sessionUserData.fullName)
			.success(function(dat1) {
				if(dat1.success){
					$dbService.getTrans(menuType).then(function(dat2){
						$scope.rcvTrans = filterFilter(dat2.data,{lv1_menu:$stateParams.lv1Menu});
						$scope.filterTrans = $scope.rcvTrans;
						$scope.table.applyFilter();
						window.location.reload();
					});				
				} else {
					alert('Update error'); }
			})
			.error(function(err) {console.log(err);} );
		}
	}
	
	$scope.doTransEdit = function(menuType) {
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.editTransDate = ($scope.editTransDate == "") ? (new Date()).toDateInputValue("") : $scope.editTransDate;
			$dbService.editTran($scope.editTransId,menuType,$scope.lv1Type,$scope.editTransDate,$scope.editTransComment,$scope.editTransValue,$scope.sessionUserData.userId,$scope.sessionUserData.fullName)
			.success(function(dat1) {
				if(dat1.success){
					$dbService.getTrans(menuType).then(function(dat2){
						$scope.rcvTrans = filterFilter(dat2.data,{lv1_menu:$stateParams.lv1Menu});
						$scope.filterTrans = $scope.rcvTrans;
					});
				} else {
					alert('Update error');
				}
			})
			.error(function(err) {console.log(err);} );
		}
	}
	
	$scope.sortKey = 'trans_date_original';
	$scope.reverse = true;

	$scope.table = {
		config:{
			curPagesOption: '5'
			,curPage: 1
			,records: $scope.rcvTrans.length
			,maxPage:  Math.ceil($scope.rcvTrans.length/5)
		},
		pagesOptions: [
			{id:5,name:5}
			,{id:10,name:10}
			,{id:15,name:15}
			,{id:$scope.rcvTrans.length,name:"All"}
		],
		fPage: function(){
			var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
			return num;
		},
		lPage: function(){
			var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
			return num;
		},
		newPagesOptions: function(){
			this.config.curPage = 1;
			this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
		},
		sort : function(keyname){
        	$scope.sortKey = keyname;   //set the sortKey to the param passed
        	$scope.reverse = !$scope.reverse; //if true make it false and vice versa			
		},
		doSearch: function(text){
			if(text != ""){
				this.config.records = $scope.searchTrans.length;
				this.config.curPage = 1;
				this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);				
			}else{
				this.config.records = $scope.filterTrans.length;
				this.config.curPage = 1;
				this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);				
			}

		},
		filter: function(mcf_id){
			if(mcf_id>0){
				$scope.filterTrans = filterFilter($scope.rcvTrans,{lv2_id:mcf_id});
			}else{
				$scope.filterTrans = $scope.rcvTrans;
			}
			this.applyFilter();
		},
		applyFilter: function(){
			this.config.curPage = 1;
			this.config.records = $scope.filterTrans.length;
			this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
		}
	}
	
	$scope.showConfirmDel = function(delVal) 
	{	
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			//console.log(delVal);
			$scope.delData = delVal;
			$scope.lv1Type = delVal.lv1_menu;
				$('#form_delete').modal({
					backdrop: 'static',
					show : 'true'
				});
		}
	} 
});

