angular.module('MetronicApp').controller('RevenueManageCtrl',function($rootScope, $scope, settings, $http,$rcvMenus,$dbService,$debtorAccounts,$creditorAccounts,$stateParams,toastr) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
		App.initAjax();
		//toastr.info('We are open today from 10 to 22', 'Information');
       toastr.info('เรียนรู้เพิ่มเติมเกี่ยวกับรับเงิน โดย<a href="#class?vid=11"><br>คลิกที่นี่</a>', 'เรียนรู้เพิ่มเติม');
        // set default layout mode
        $rootScope.settings.layout.pageContentWhite = true;
        $rootScope.settings.layout.pageBodySolid = false;
        $rootScope.settings.layout.pageSidebarClosed = false;
		$( ".date-picker" ).datepicker( "option", "maxDate",  new Date().toDateInputValue("") );
		console.log(  $scope.rcvMenu );
    });
	//console.log($stateParams);
	$scope.orgLv1Menu = ($stateParams.lv1Menu == "cfo" || $stateParams.lv1Menu == "cfi" || $stateParams.lv1Menu == "cff" ) ? $stateParams.lv1Menu : "cfo";
	$scope.orgMenuType = ($stateParams.menuType == "rcv" || $stateParams.menuType == "exp" ) ? $stateParams.menuType : "rcv" ;
	//$scope.orgMenuType = $stateParams.menuType;
	//$scope.orgLv1Menu = $stateParams.lv1Menu;
	$scope.menuDesc = { "cfo" : "ดำเนินงาน", "cff" : "จัดหาเงิน", "cfi" : "ลงทุน" };
	$scope.menuPic = { "cfo" : "operate.svg", "cff" : "finance.svg", "cfi" : "invest.svg" };
	$scope.formType = {
		'hasAccount' : false
	};
	
    //date parse for js date input
	Date.prototype.toDateInputValue = (function(date) {
		var local = new Date(this);
		var newDate = ("0"+(local.getDate())).slice(-2)+"-"+("0"+(local.getMonth()+1)).slice(-2)+"-"+local.getFullYear();
		return newDate;
	});
	
    //init data from db
    $scope.rcvMenu = $rcvMenus;
    $scope.debtorAccounts = $debtorAccounts;
	$scope.creditorAccounts = $creditorAccounts;
	
	var dummyAccount = {
		name		:	'',
		address 	:	{
						addr:"",
						subdistrict:"",
						district:"",
						province:"",
						postcode:""
		}, 
		telephone:	'', 
		email 	:	'',
		comment 	:	'',
		tax_id: ""
	};
	
	// $scope.debtorAccount = angular.extend({},dummyAccount);
	$scope.debtorAccount = angular.copy(dummyAccount);
	
	// $scope.creditorAccount = angular.extend({},dummyAccount);
	$scope.creditorAccount = angular.copy(dummyAccount);
	
	$scope.checkForm = {
		name	:	''
	}
	
	$scope.resetTranInputForm = function () {
		$scope.transInputForm = {
    		date: new Date().toDateInputValue("")
    		,amount: 0.00
    		,comment: ""
    		,title: ""
    	};
		//console.log($scope.transInputForm.date);
	}
	$scope.resetTranInputForm();
	
	$scope.ressetLv2Form = function(){
		$scope.newLv2Name = "";
	}

	$scope.ressetLv3Form = function(){
		$scope.newLv3Name = "";
	}	
    
	$scope.isValid = function(value) {
		return !value
	}
	
	$scope.curDate = new Date();
	
	//$(".date-picker").on('changeDate',function(event) {
	//	console.log('date_changed');
	//});
	
	//$('#form_modal2 .date-picker').each(function() {
	$('.date-picker').each(function() 
	{
		var elem = $(this);
		
		//console.log(elem.data('oldVal'));

		//elem.bind("propertychange change click keyup input paste", function(event){
		elem.bind("focus onkeydown onpaste oncut ", function(event){
			elem.data('oldVal', elem.val());
			//console.log('focus: '+elem.data('oldVal'));
		if(elem.data('oldVal') == "")
		{
			//console.log('blank');
			//$('#form_modal2 .date-picker').val(new Date().toDateInputValue(""));
			$('.date-picker').val(new Date().toDateInputValue(""));
		}
		});
		
		elem.bind("blur", function(event){
		if(elem.val() == "")
		{
			//console.log('blank');
			//$('#form_modal2 .date-picker').val(new Date().toDateInputValue(""));
			$('.date-picker').val(new Date().toDateInputValue(""));
		}
			//console.log('oldval: '+elem.data('oldVal'));
			//console.log('newval: '+elem.val());
			//if (elem.data('oldVal') == elem.val()) {
			//	console.log('same');
			//}
		});
	});
	
	//$('.date-picker').on('change',function(event){
	//	var curVal = $(this).val();
	//	var newFormatCurVal = curVal.substring(6,10)+"."+(curVal.substring(3,5))+"."+(curVal.substring(0,2));
	//	var curValUnixTime = parseInt((new Date(newFormatCurVal).getTime() / 1000).toFixed(0));
	//	
	//	var local = new Date();
	//	var newFormatCurDate =  local.getFullYear()+"."+("0"+(local.getMonth()+1)).slice(-2)+"."+("0"+(local.getDate())).slice(-2);
	//	var curDateUnixTime = parseInt((new Date(newFormatCurDate).getTime() / 1000).toFixed(0))
	//	if(curValUnixTime > curDateUnixTime)
	//	{
	//		$(this).value = new Date().toDateInputValue("");
	//		$(event).val(new Date().toDateInputValue(""));
	//		event.currentTarget.value = new Date().toDateInputValue("");
	//		$scope.transInputForm.date = new Date().toDateInputValue("");
	//		console.log($(event.target).text());
	//		$(this).val((new Date().toDateInputValue("")).toString());
	//		console.log(event.currentTarget.value);
	//	}
	//});
	
	
	$scope.checkNum = function (checkVal)
	{
		var selectR = 0;
		var elemR = 0;
		var startR = 0;
		var endR = 0;
		if(checkVal == "")
		{
			checkVal = 0;
			$scope.transInputForm.amount = 0;
		}
		else
		{
			var checkReg = new RegExp(/^\d+$/);
			checkValNum = Math.abs((parseFloat(checkVal).toFixed(2)));
			var checkOc = $scope.checkOccurrence(checkVal,".");
			if(checkReg.test(checkValNum) !== false || checkOc == 1 )
			{
				//console.log(checkVal);
				if(checkOc == 1)
				{
					//checkVal = checkVal+"01";
					endR = checkVal.length;
					startR = checkVal.length-2;
					elemR = $('[ng-model="transInputForm.amount"]');
					selectR = 1;
				}
				////$scope.transInputForm.amount = Math.abs((parseFloat(checkVal).toFixed(2)));
				//if(selectR = 1)
				//{
				//	selectRange(startR,endR,elemR);
				//}
			}
			else
			{
				if(checkVal.length == 1)
				{
					checkVal = 0;
				}
				else
				{
					checkVal = checkVal.substr(0,-1);
				}
				$scope.transInputForm.amount = checkVal;
			}
		}
	}

	
	var selectRange = function(start, end, elem) {
		var el = elem[0];

        if (el) {
            el.focus();
            
            if (el.setSelectionRange) {
                el.setSelectionRange(start, end);
                
            } else if (el.createTextRange) {
                var range = el.createTextRange();
                range.collapse(true);
                range.moveEnd('character', end);
                range.moveStart('character', start);
                range.select();
                
            } else if (el.selectionStart) {
                el.selectionStart = start;
                el.selectionEnd = end;
            }
        }
	};

	$scope.checkOccurrence = function occurrences(string, subString, allowOverlapping) {

		string += "";
		subString += "";
		if (subString.length <= 0) return (string.length + 1);
	
		var n = 0,
			pos = 0,
			step = allowOverlapping ? 1 : subString.length;
	
		while (true) {
			pos = string.indexOf(subString, pos);
			if (pos >= 0) {
				++n;
				pos += step;
			} else break;
		}
		return n;
	}
	
	$scope.openAddTrans = function (lv2id,lv3id,lv3_name,form_type)
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.transInputForm.title = lv3_name;
			$scope.lv2TransId = lv2id;
			$scope.lv3TransId = lv3id;
			$scope.formType.hasAccount = form_type == "2" ? true : false;
			$scope.transInputForm.Account = "0";
			$('#form_modal2').modal({
				backdrop: 'static',
				show: 'true'
			}); 
		}
	}
	
	$scope.execAddTrans = function (menuType,lv1)
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.transInputForm.date = ($scope.transInputForm.date == "") ? (new Date()).toDateInputValue("") : $scope.transInputForm.date;
			$dbService.newTran($scope.lv2TransId,$scope.lv3TransId,$scope.transInputForm.date,$scope.transInputForm.amount,menuType,lv1,$scope.transInputForm.comment,$scope.transInputForm.Account,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
			.success(function(dat1){
				$scope.resetTranInputForm();
			})
			.error(function(err){
				console.log(err);
			});
		}
	}
	
	$scope.openAddLv2Menu = function (lv1Menu,menuType)
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{	
			$scope.lv1Menu = lv1Menu;
			$scope.addMenuType = menuType;
			$dbService.checkLv2Max(lv1Menu,menuType)
			.success(function(maxResult){
				if(maxResult.success)
				{
					$('#mainMenu').modal({
						backdrop: 'static',
						show: 'true'
					}); 
				}
				else
				{
					swal({
						title: 'หมวดหมู่เต็มจำนวน',
						text: 'แพ็กเกจของท่านมีการเพิ่มหมวดหมู่เต็มจำนวน ทั้งนี้หากสนใจเพิ่มหมวดหมู่ <br>สามารถติดต่อเจ้าหน้าที่ดูแลลูกค้า วันจันทร์ - วันศุกร์ ช่วงเวลา 9:00 - 18:00 น. ผ่าน 3 ช่องทาง ดังนี้ค่ะ<br><br>'+
								'<span style="margin-left:-25px"><img src="../assets/layouts/app/img/telephone.png" width="30px" height="30px"> โทรศัพท์   : 094-824-6244</span></br></br>'+
								'<span style="margin-left:-20px"><img src="../assets/layouts/app/img/fb.png" width="30px" height="30px"> Facebook  : <a href="https://www.facebook.com/managecashflow/" target="_blank">MY CashFlow</a></span></br></br>'+
								'<span style="margin-left:-50px"><img src="../assets/layouts/app/img/line_icon.png" width="30px" height="30px"> Line : <a href="https://line.me/R/ti/p/%40mycashflow" target="_blank">@mycashflow</a></span>',
						html : true
					});
				}
			})
			.error(function(err){
				console.log(err);
			});
		}
	}	
	
	$scope.addLv2menu = function (lv2Name)
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			if(!lv2Name || lv2Name.length < 1)
			{
				//alert('กรุณากรอกชื่อหมวดหมู่');
				swal({
						title: 'กรุณากรอกชื่อหมวดหมู่'
					});
			}
			else
			{
				var lv1Menu = $scope.lv1Menu;
				var menuType = $scope.addMenuType;
				$dbService.checkLv2Name(lv2Name,menuType)
				.success(function(datResult){
					if(datResult.success)
					{
						$dbService.newLv2Menu(lv2Name,lv1Menu,menuType,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
						.success(function(dat1){
							$dbService.getMenus(menuType)
							.success(function(dat2){
								$scope.rcvMenu = dat2;
								$scope.ressetLv2Form();
							})
							.error(function(err){
								console.log(err);
							});
						})
						.error(function(err){
							console.log(err);
						});
					}
					else
					{
						//alert('ชื่อหมวดหมู่ซ้ำ');
						$scope.ressetLv2Form();	 
						swal({
							title: 'ชื่อหมวดหมู่ซ้ำ',
							text: 'กรุณาตั้งชื่อหมวดหมู่อีกครั้ง'
						});
					}
				})
				.error(function(err){
					console.log(err);
				});
			}
		}
	}	
	
	$scope.openAddSubMenu = function (lv2id,name)
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$scope.lv2RefId = lv2id;
			$dbService.checkLv3Max(lv2id,$scope.orgMenuType)
			.success(function(maxResult){
				if(maxResult.success)
				{
					$('#addChild').modal({
						backdrop: 'static',
						show: 'true'
					}); 
				}
				else
				{
					//alert('คุณได้ทำการเพิ่มรายการย่อยครบ 5 รายการแล้ว!!');
					swal({
						title: 'รายการย่อยเต็มจำนวน',
						text: 'แพ็กเกจของท่านมีการเพิ่มรายการย่อยเต็มจำนวน <br>ทั้งนี้หากสนใจเพิ่มรายการย่อย สามารถติดต่อเจ้าหน้าที่ดูแลลูกค้า <br>วันจันทร์ - วันศุกร์ ช่วงเวลา 9:00 - 18:00 น. ผ่าน 3 ช่องทาง ดังนี้ค่ะ<br><br>'+
								'<span style="margin-left:-25px"><img src="../assets/layouts/app/img/telephone.png" width="30px" height="30px"> โทรศัพท์   : 094-824-6244</span></br></br>'+
								'<span style="margin-left:-20px"><img src="../assets/layouts/app/img/fb.png" width="30px" height="30px"> Facebook  : <a href="https://www.facebook.com/managecashflow/" target="_blank">MY CashFlow</a></span></br></br>'+
								'<span style="margin-left:-50px"><img src="../assets/layouts/app/img/line_icon.png" width="30px" height="30px"> Line : <a href="https://line.me/R/ti/p/%40mycashflow" target="_blank">@mycashflow</a></span>',
						html : true
					});
				}
			})
			.error(function(err){
				console.log(err);
			});
		}
	}
	
	$scope.addLv3Menu = function (menuType,lv1,lv3Name)
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			if(!lv3Name || lv3Name.length < 1)
			{
				//alert('กรุณากรอกชื่อรายการย่อย');
				swal({
						title: 'กรุณากรอกชื่อรายการย่อย'
					});
	
			}
			// else if(0)
			// {
				// swal({
					// title: 'มีรายการย่อยนี้อยู่แล้ว กรุณากรอกชื่อรายการย่อยอื่น'
				// });
			// }
			else
			{
				var lv2RefId = $scope.lv2RefId;
				$dbService.checkLv3Name(lv3Name, menuType, lv2RefId)
				.success(function(datResult){
					// console.log(datResult);return;
					if(datResult.success)
					{
						$dbService.newLv3Menu(lv2RefId,menuType,lv1,lv3Name,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
						.success(function(dat1){
							$dbService.getMenus(menuType)
							.success(function(dat2){
								$scope.rcvMenu = dat2;
								$scope.ressetLv3Form();
							})
							.error(function(err){
								console.log(err);
							});
						})
						.error(function(err){
							console.log(err);
						});
					}
					else
					{
						//alert('ชื่อรายการย่อยซ้ำ');
						$scope.ressetLv3Form();	 
						swal({
							title: 'ชื่อรายการย่อยซ้ำ',
							text: 'กรุณาตั้งชื่อรายการย่อยอีกครั้ง'
						});
					}
				})
				.error(function(err){
					console.log(err);
				});
			}
		}
	}
	
	
	$scope.saveAccountsDebtor = function()
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			// var name 		= $scope.debtorAccount.name;
			// var address 	= $scope.debtorAccount.address;
			// var telephone 	= $scope.debtorAccount.telephone;
			// var email 		= $scope.debtorAccount.email;
			// var comment 	= $scope.debtorAccount.comment;
			var menuType 	= $scope.orgMenuType;
			
			let jsonDat = {
				menu_type: menuType,
				customer_detail: $scope.debtorAccount,
				user_id: $scope.sessionUserData.userId,
				user_name: $scope.sessionUserData.userName
			}; console.log($scope.debtorAccount.name);
			if($scope.debtorAccount.name !== "")
			{
				$scope.checkForm.name = "modal";
				//$dbService.addAccount(menuType,name,address,telephone,email,comment,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
				$dbService.addAccount(jsonDat)
				.success(function(dat1) {
				if(dat1.success) 
				{ 
					// $scope.debtorAccount.name = "";
					// $scope.debtorAccount.address = {
						// addr:"",
						// subdistrict:"",
						// district:"",
						// province:"",
						// postcode:""
					// };					
					// $scope.debtorAccount.address = "";
					// $scope.debtorAccount.telephone = "";
					// $scope.debtorAccount.email = "";
					// $scope.debtorAccount.comment = "";
					$scope.debtorAccount = angular.copy(dummyAccount);;
					$dbService.getAccounts(menuType).then(function(dat2){
					$scope.debtorAccounts = dat2.data;
					});
				}
				else
				{
					console.log('dd');
				}
				})
				.error(function(err) {console.log(err);} );
			}
			else
			{
				$scope.checkForm.name = "";
				swal({
					title: 'กรุณากรอกชื่อบริษัท'
				});
			}
		}
	}
	
	$scope.saveAccountsCreditor = function()
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			// var name 		= $scope.creditorAccount.name ;
			// var address 	= $scope.creditorAccount.address ;
			// var telephone 	= $scope.creditorAccount.telephone ;
			// var email 		= $scope.creditorAccount.email ;
			// var comment 	= $scope.creditorAccount.comment ;
			var menuType 	= "exp";
			let jsonDat = {
				menu_type: menuType,
				customer_detail: $scope.creditorAccount,
				user_id: $scope.sessionUserData.userId,
				user_name: $scope.sessionUserData.userName
			};					
			if($scope.creditorAccount.name !== "")
			{
				$scope.checkForm.name = "modal";
				//$dbService.addAccount(menuType,name,address,telephone,email,comment,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
				$dbService.addAccount(jsonDat)
				.success(function(dat1) {
				if(dat1.success) 
				{ 
					// $scope.creditorAccount.name = "";
					// $scope.creditorAccount.address = {
						// addr:"",
						// subdistrict:"",
						// district:"",
						// province:"",
						// postcode:""
					// };						
					// $scope.creditorAccount.companyAddress = "";
					// $scope.creditorAccount.telephone = "";
					// $scope.creditorAccount.email = "";
					// $scope.creditorAccount.comment = "";
					$scope.creditorAccount = angular.copy(dummyAccount);;
					$dbService.getAccounts(menuType).then(function(dat2){
						$scope.creditorAccounts = dat2.data;
					});
				}
				else
				{
					console.log('dd');
				}
				})
				.error(function(err) {console.log(err);} );
			}
			else
			{
				$scope.checkForm.name = "";
				swal({
					title: 'กรุณากรอกชื่อบริษัท'
				});
			}
		}
	}
	
	$scope.showAddDebtorModal = function() 
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$('#form_modal3').modal({
				backdrop: 'static',
				show : 'true'
			});
		}
	}
	
	$scope.showAddCreditorModal = function() 
	{
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			$('#form_modal4').modal({
				backdrop: 'static',
				show : 'true'
			});
		}
	}
	
	$scope.emptyAccount = function(scopeName){
		$scope[scopeName] = angular.copy(dummyAccount);;
	}
});

