angular.module('MetronicApp').controller('SettingsCreditorCtrl', function($rootScope, $scope, settings, $http, filterFilter,$creditors,$dbService, toastr) {
    $scope.$on('$viewContentLoaded', function() {   
        // initialize core components
        App.initAjax();     
        //toastr.info('We are ope# today from 10 to 22', 'Information');
       toastr.info('เรียนรู้เพิ่มเติมเกี่ยวกับตั้งค่าบัญชีเจ้าหนี้ โดย<a href="#class?vid=18"> คลิกที่นี่</a>', 'เรียนรู้เพิ่มเติม');
    });
    // set default layout mode
    $rootScope.settings.layout.pageBodySolid = true;
    $rootScope.settings.layout.pageSidebarClosed = false;

    $scope.menuType = "exp";
    //get accounts via resolve
    $scope.accounts = $creditors;
    //init data for modal
    $scope.selectedPerson = {};
    $scope.toSavePerson = {};
    //console.log($debtors);
    $scope.editAccount = function(account){
        $scope.saveDisable = true;
		account = serializeAccount(account); /*for ph2.1*/
        $scope.selectedPerson = angular.extend({},account);
        $scope.toSavePerson = angular.extend({},account);
        $('#formEditAcc').modal({
            backdrop: 'static',
            show: 'true'
        });        
    }

    $scope.saveAccount = function(){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			let acc = $scope.toSavePerson;
			//$dbService.editAccount($scope.menuType,acc.mcf_account_id,acc.name,acc.address,acc.telephone,acc.email,acc.comment,2,'Sarah Lee')
			let jsonDat = {
				customer_detail: acc,
				menu_type: $scope.menuType,
				user_id: $scope.sessionUserData.userId,
				user_name: $scope.sessionUserData.userName
			};
			$dbService.editAccount(jsonDat)
			.success(function(dat1){
			if(dat1.success){
					$dbService.getAccounts($scope.menuType).then(function(dat2){
						$scope.accounts = dat2.data;
					});               
			}else{
				console.log(dat1);
			}
			})
			.error(function(err) {console.log(err);} );
		}
    }

    $scope.deleteAccount = function(id){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
				//console.log(id);
			$dbService.delAccount($scope.menuType,id,$scope.sessionUserData.userId,$scope.sessionUserData.fullName)
			//.then(function(dat){console.log(dat);});
			.success(function(dat1){
				if(dat1.success){
						$dbService.getAccounts($scope.menuType).then(function(dat2){
							$scope.accounts = dat2.data;
							//console.log(dat1);
							window.location.reload();
						});               
				}else{
					console.log(dat1);
				}
			})
			.error(function(err) {console.log(err);} );
		}
    }

    $scope.table = {
        config:{
            curPagesOption: '5'
            ,curPage: 1
            ,records: $scope.accounts.length
            ,maxPage:  Math.ceil($scope.accounts.length/5)
        },
        pagesOptions: [
            {id:5,name:5}
            ,{id:10,name:10}
            ,{id:15,name:15}
            ,{id:$scope.accounts.length,name:"All"}
        ],
        fPage: function(){
            var num = 1+(this.config.curPagesOption*(this.config.curPage-1));
            return num;
        },
        lPage: function(){
            var num = this.config.curPage == this.config.maxPage ? this.config.records : this.config.curPage*this.config.curPagesOption;
            return num;
        },
        newPagesOptions: function(){
            this.config.curPage = 1;
            this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);
        },
        sort : function(keyname){
            $scope.sortKey = keyname;   //set the sortKey to the param passed
            $scope.reverse = !$scope.reverse; //if true make it false and vice versa            
        },
        doSearch: function(text){
            if(text != ""){
                this.config.records = $scope.searchAccounts.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }else{
                this.config.records = $scope.accounts.length;
                this.config.curPage = 1;
                this.config.maxPage = this.config.curPagesOption == '-1'? 1 : Math.ceil(this.config.records/this.config.curPagesOption);                
            }

        }
        // filter: function(mcf_id){
        //     if(mcf_id>0){
        //         $scope.filterTrans = filterFilter($scope.expTrans,{lv2_id:mcf_id});
        //     }else{
        //         $scope.filterTrans = $scope.expTrans;
        //     }
        //     this.applyFilter();
        // },
        // applyFilter: function(){
        //     this.config.curPage = 1;
        //     this.config.records = $scope.filterTrans.length;
        //     this.config.maxPage = Math.ceil($scope.table.config.records/$scope.table.config.curPagesOption);
        // }
    }
	$scope.showConfirmDel = function(delVal) 
	{	
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			//console.log(delVal);
			$scope.delAccount = delVal;
				$('#form_delete').modal({
					backdrop: 'static',
					show : 'true'
				});
		}
	}
	
	function serializeAccount(input){
		if( typeof input.address  == "string"){
			input.address = {
				addr: input.address,
				subdistrict:"",
				district:"",
				province:"",
				postcode:""
			};
		}
		//console.log(account);
		return input;
	}	
  
});
