angular.module('MetronicApp').controller('SettingsInvoiceCtrl', function($rootScope, $scope, $state, filterFilter, settings, $http, $dbService, invoiceConfigs, userDefault) {
    $scope.$on('$viewContentLoaded', function() {   
        App.initAjax(); // initialize core components
			
        //Layout.setAngularJsSidebarMenuActiveLink('set', $('#sidebar_menu_link_settings'), $state); // set profile link active in sidebar menu //
		if($scope.userPermissions)
		{
			if($state.current.data.module == "settings-personal" && $scope.userPermissions['settings-personal'] !== true)
			{
				$('.profile-content :input').prop('disabled',true);
			}
		}		
    });
    // set sidebar closed and body solid layout mode
    $rootScope.settings.layout.pageBodySolid = true;
    $rootScope.settings.layout.pageSidebarClosed = false;

	
	$scope.hasError = function(field, validation){
    if(validation){
      return ($scope.form[field].$dirty && $scope.form[field].$error[validation]) || ($scope.submitted && $scope.form[field].$error[validation]);
    }
    return ($scope.form[field].$dirty && $scope.form[field].$invalid) || ($scope.submitted && $scope.form[field].$invalid);
	  };
	
	//keep original header id for reference
	var originalHeaderId = userDefault.header_number_id;
	
	$scope.user = {
		default: userDefault
	};
	
	$scope.ui = {
		testFile : null,
		configs: invoiceConfigs,
		images: {
			logo: null,
			signature: null,
			stamp: null
		},		
		changeHeaderNumber: function(h){
			var now = new Date();
			if(h == 1){
				for(var doc in $scope.user.default.document_configs){
					$scope.user.default.document_configs[doc].middle = now.getFullYear();
				}
			}
			if(h == 2){
				for(var doc in $scope.user.default.document_configs){
					$scope.user.default.document_configs[doc].middle = now.getFullYear()+("0"+(now.getMonth()+1)).slice(-2);
				}
			}
		},
		taxInvoice: {
			dettach: function(){
				$scope.user.default.tax_invoice.attach_with = "";
			}
		},
		save: function(settings){
			var userInfo = {
				user_name: $scope.sessionUserData.userName,
				user_id: $scope.sessionUserData.userId
			};
			//if change header option then reset all indexes
			if(originalHeaderId !== settings.header_number_id){
				settings.document_configs = resetInvoiceIndexes(settings.document_configs);
			}
			
			//console.log(settings.document_configs);return;
			var jsonData = {user: userInfo, settings: settings};
			//console.log(jsonData);return;
			var formData = new FormData();
			formData.append('logo', this.images.logo);
			formData.append('signature', this.images.signature);
			formData.append('stamp', this.images.stamp);
			formData.append('jsonData', JSON.stringify(jsonData));
			
			$dbService.editSettingsInvoice(formData).then(
				function(dat){
					window.location.reload(true);
					//console.log(dat.data);
				},
				function(err){console.log(err);});
		},
		resetVAT: function(input){
			if(input == 0){
				$scope.user.default.VAT_item_type = 0;
			}
		}
	};
		
	$scope.$watch('ui.images.logo', function(event) {
		if($scope.ui.images.logo != null || $scope.ui.images.stamp != null || $scope.ui.images.signature != null)
		{
			$scope.user.default.logo.active = true;
			$scope.ui.save($scope.user.default);
		}
	});
	$scope.$watch('ui.images.stamp', function(event) {
		if($scope.ui.images.stamp != null)
		{
			$scope.user.default.stamp.active = true;
			$scope.ui.save($scope.user.default);
		}
	});
	$scope.$watch('ui.images.signature', function(event) {
		if($scope.ui.images.signature != null)
		{
			$scope.user.default.signature.active = true;
			$scope.ui.save($scope.user.default);
		}
	});

			
	
	
	function resetInvoiceIndexes(documentConfigs){
		for(let prop in documentConfigs){
			documentConfigs[prop].last_used_id = "";
		}
		return documentConfigs;
	}
}); 


