angular.module('MetronicApp').controller('SettingsRevenueCtrl', function($rootScope, $scope, $http, $timeout, $state,filterFilter, $dbService,$menus, toastr) { //minify implicit antonation
    $scope.$on('$viewContentLoaded', function() {   
        App.initAjax(); // initialize core components
        Layout.setAngularJsSidebarMenuActiveLink('set', $('#sidebar_menu_link_settings'), $state); // set profile link active in sidebar menu 
        //toastr.info('We are ope# today from 10 to 22', 'Information');
       toastr.info('เรียนรู้เพิ่มเติมเกี่ยวกับตั้งค่าหมวดหมู่รับ โดย<a href="#class?vid=17"> คลิกที่นี่</a>', 'เรียนรู้เพิ่มเติม');
    });

    // set sidebar closed and body solid layout mode
    $rootScope.settings.layout.pageBodySolid = true;
    $rootScope.settings.layout.pageSidebarClosed = false;
    $scope.menuType = "rcv";
    $scope.menuDesc = { cfo : "ดำเนินงาน", cff : "จัดหาเงิน", cfi : "ลงทุน" };
    //get all menus from db via resolve
    $scope.menus = $menus;
    $scope.selectedMenu = {};
    $scope.toSaveMenu = {};
    //show menu's visibility
    $scope.isVisible = function(key){
        var result = key == 1? "แสดง" : "ซ่อน";
        return result;
    }
    //toggle menu's visibility
    $scope.toggleVisible = function(lv2id,lv3id,show){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		} else {
			var visible = show == 0 ? 1 : 0;
			$dbService.editMenuVisibility(lv2id,lv3id,$scope.menuType,visible)
			//.then(function(dat){console.log(dat.data);},function(err){console.log(err);});
			.success(function(dat1){
				if(dat1.success){
					$dbService.getMenus($scope.menuType,'settings').then(function(dat2){
						//var query = dat2.data;
						$scope.menus = dat2.data;
					});
				}else{
					console.log("error");
				}
			})
			.error(function(err) {console.log(err);} );			
		}		

    }
    //edit menu's name
    $scope.editMenu = function(menu){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
				$scope.saveDisable = true;
				$scope.selectedMenu = angular.extend({},menu); //clone object witout reference
				$scope.toSaveMenu = angular.extend({},menu);
				$('#formEditMenu').modal({
					backdrop: 'static',
					show: 'true'
				});
		}
    }

    $scope.doEditMenu = function(){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
				var mcf_id = $scope.toSaveMenu.mcf_id;
				var mcf_sub_id = $scope.toSaveMenu.mcf_sub_id ? $scope.toSaveMenu.mcf_sub_id : -1;
				var newName = $scope.toSaveMenu.mcf_sub_id ? $scope.toSaveMenu.lv3_name : $scope.toSaveMenu.lv2_name;
		
				$dbService.editMenuName(mcf_id,mcf_sub_id,$scope.menuType,newName)
				.success(function(dat1){
				if(dat1.success){
						$dbService.getMenus($scope.menuType,'settings').then(function(dat2){
							$scope.menus = dat2.data;
						});               
				}else{
					console.log(dat1);
				}
			})
			.error(function(err) {console.log(err);} );
		}
    }

    $scope.deleteMenu = function(menu){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			var lv2id = menu.mcf_id;
			var lv3id = menu.mcf_sub_id ? menu.mcf_sub_id : -1;
			$dbService.delLv3Menu(lv2id,lv3id,$scope.menuType)
			//.then(function(dat){console.log(dat);});
			.success(function(dat1){
			if(dat1.success){
					$dbService.getMenus($scope.menuType,'settings').then(function(dat2){
						$scope.menus = dat2.data;
						window.location.reload();
					});               
			}else{
				console.log(dat1);
			}
			})
			.error(function(err) {console.log(err);} );
		}
    }

    $scope.changeMenuName = function(){
        var valid = false;
        var islv3 = $scope.toSaveMenu.mcf_sub_id ? true : false;
        if(islv3){
            var change = $scope.toSaveMenu.lv3_name != $scope.selectedMenu.lv3_name;
            if(change){
                var isUnique = filterFilter($scope.menus,{lv3_name:$scope.toSaveMenu.lv3_name},true).length == 0;
                valid = isUnique;
            }
        }else{
            var change = $scope.toSaveMenu.lv2_name != $scope.selectedMenu.lv2_name;
            if(change){
                var isUnique = filterFilter($scope.menus,{lv2_name:$scope.toSaveMenu.lv2_name},true).length == 0;
                valid = isUnique;
            }
        }
        $scope.saveDisable = valid ? false : true;
    }
	
	$scope.showConfirmDel = function(delVal) 
	{	
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			//console.log(delVal);
			$scope.delData = delVal;
			$('#form_delete').modal({
				backdrop: 'static',
				show : 'true'
			});
		}
	} 
}); 
