angular.module('MetronicApp').controller('SettingsUsersCtrl', function($rootScope, $scope, settings, $http, $users, $getQuery, $dbService, toastr) {
    $scope.$on('$viewContentLoaded', function() {   
        App.initAjax(); // initialize core components
	setTimeout(function(){ 
	$scope.checkPermissions = $scope.accounts[$scope.sessionUserData.userId].permissions;
	$scope.checkEditPermissions = ($scope.checkPermissions).split(",");
	$scope.permissionsList = {};
	angular.forEach($scope.checkEditPermissions,function(key) {
			           
                if(key.indexOf("-") >= 1)
                {
                    var tempPerm = key.replace(/-/g,"_");
                    $scope.permissionsList[tempPerm] = true;
                }
                else
                {
                    $scope.permissionsList[key] = true;
                }
		});
	}, 100);
    //Layout.setAngularJsSidebarMenuActiveLink('set', $('#sidebar_menu_link_settings'), $state); // set profile link active in sidebar menu 
	toastr.info('เรียนรู้เพิ่มเติมเกี่ยวกับตั้งค่าพนักงาน โดย<a href="#class?vid=16"> คลิกที่นี่</a>', 'เรียนรู้เพิ่มเติม');
    });

	$scope.doAdd = 0;
    // set sidebar closed and body solid layout mode
    $rootScope.settings.layout.pageBodySolid = true;
    $rootScope.settings.layout.pageSidebarClosed = false;
	$scope.userName = {
		'duplicateCheck'	:	0
	}
    //console.log($personal);

	    $scope.accounts = $users.data;

        $scope.modPermissions = {
        home : false,
        revenue_operating_main : false,
        revenue_operating_history : false,
        expense_operating_main : false,
        expense_operating_history : false,
        creditor_edit : false,
        debtor_edit : false,
        cashflow_table : false,
        cashflow_graph : false,
        creditor_table : false,
        debtor_table : false,
        class : false,
        settings_users : false,
        settings_personal : false,
        settings_revenue : false,
        settings_debtor : false,
        settings_creditor : false,
        help : false
    };
    //console.log($scope.accounts);
    
    $scope.userData = {
        'id'            :   -1,
        'user_name'     :   '',
        'password'      :   '',
        'first_name'    :   '',
        'last_name'     :   '',
        'permissions'   :   '',
        'editor'        :   -1
    }

    $scope.addUsers = function(){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
				//$("#users_modal input[type='checkbox'").each(function(){
				//	$(this).prop('checked',false);
				//});
				$scope.doAdd = 1;
				$scope.userData.id = -1;
				$scope.userData.user_name = '';
				$scope.userData.password = '';
				$scope.userData.first_name = '';
				$scope.userData.last_name = '';
				$scope.userData.permissions = '';
				$scope.userData.editor = -1;
				$dbService.checkUserMax()
				.success(function(datResult){ 
					if(datResult.success)
					{
						$('#users_modal').modal({
							backdrop: 'static',
							show: 'true'
						});
					}
					else
					{
						//alert('เพิ่มจำนวนพนักงานครบแล้ว');
						swal({
							title: 'ผู้ใช้งานเต็มจำนวน',
							text: 'แพ็กเกจของท่านมีการเพิ่มผู้ใช้งานเต็มจำนวน ทั้งนี้หากสนใจเพิ่มผู้ใช้งาน <br>สามารถติดต่อเจ้าหน้าที่ดูแลลูกค้า วันจันทร์ - วันศุกร์ ช่วงเวลา 9:00 - 18:00 น. ผ่าน 3 ช่องทาง ดังนี้ค่ะ<br><br>'+
									'<span style="margin-left:-25px"><img src="../assets/layouts/app/img/telephone.png" width="30px" height="30px"> โทรศัพท์   : 094-824-6244</span></br></br>'+
									'<span style="margin-left:-20px"><img src="../assets/layouts/app/img/fb.png" width="30px" height="30px"> Facebook  : <a href="https://www.facebook.com/managecashflow/" target="_blank">MY CashFlow</a></span></br></br>'+
									'<span style="margin-left:-50px"><img src="../assets/layouts/app/img/line_icon.png" width="30px" height="30px"> Line : <a href="https://line.me/R/ti/p/%40mycashflow" target="_blank">@mycashflow</a></span>',
							html : true
						});
					}
				})
				.error(function(err){
							console.log(err);
				});
		}
    }

    $scope.editUser = function(userId){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
				//$("#users_modal input[type='checkbox'").each(function(){
				//	$(this).prop('checked',false);
				//});
				$scope.doAdd = 0;
				$scope.userData.id = userId;
				$scope.userData.user_name = $scope.accounts[userId].user_name;
				$scope.userData.password = $scope.accounts[userId].password;
				$scope.userData.first_name = $scope.accounts[userId].first_name;
				$scope.userData.last_name = $scope.accounts[userId].last_name;
				$scope.userData.permissions = $scope.accounts[userId].permissions;
				$scope.userData.editor = 1;
			$('#users_modal').modal({
					backdrop: 'static',
					show: 'true'
				});
		
		
			$scope.modPermissions = {
				home : false,
				revenue_operating_main : false,
				revenue_operating_history : false,
				expense_operating_main : false,
				expense_operating_history : false,
				creditor_edit : false,
				debtor_edit : false,
				cashflow_table : false,
				cashflow_graph : false,
				creditor_table : false,
				debtor_table : false,
				class : false,
				settings_users : false,
				settings_personal : false,
				settings_revenue : false,
				settings_debtor : false,
				settings_creditor : false,
				help : false
			};
			$scope.tempPermissions = $scope.userData.permissions.split(",");
			// console.log($scope.tempPermissions);
				angular.forEach($scope.tempPermissions,function(key) {
					
					if(key.indexOf("-") >= 1)
					{
						var tempPerm = key.replace(/-/g,"_");
						$scope.modPermissions[tempPerm] = true;
					}
					else
					{
						$scope.modPermissions[key] = true;
					}
				});
				//console.log($scope.modPermissions);
		}
    }

	$scope.saveUser = function(){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			if($scope.userData.id !== -1)
			{
				if($scope.userData.password !== "")
				{
						$scope.userData.password = ($scope.userData.password == $scope.accounts[$scope.userData.id].password) ? $scope.userData.password : (CryptoJS.MD5($scope.userData.password)).toString();
				}
			}
			else
			{
				$scope.userData.password = (CryptoJS.MD5($scope.userData.password)).toString();
			}
			var modifiedPermissions = "";
				angular.forEach($scope.modPermissions,function(value,key) {
					if(value)
					{
						if(key.indexOf("_") >= 1)
						{
							modifiedPermissions += key.replace(/_/g,"-")+",";
						}
						else
						{
							modifiedPermissions += key+",";
						}
					}
				});
			$scope.userData.permissions = modifiedPermissions.slice(0,-1);
			//console.log($scope.userData);
			var formData = $.param($scope.userData);
			if($scope.userData.id !== -1)
			{
				$dbService.editUser(formData,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
				.success(function(dat1){
					if(!dat1.success){
						alert('Error');
						console.log(dat1);
					}
					else
					{
						
						window.location.reload();
					}
				})
				.error(function(err) {console.log(err);} );
			}
			else
			{
				$dbService.addUser(formData,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
				.success(function(dat1){
					if(!dat1.success){
						alert('Error');
						console.log(dat1);
					}
					else
					{
						window.location.reload();
					}
				})
				.error(function(err) {console.log(err);} );
			}
		}
    }
	
	$scope.removeUser = function(idToRemove){
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			if(idToRemove !== 1 && idToRemove !== "")
			{
				$dbService.removeUser(idToRemove,$scope.sessionUserData.userId,$scope.sessionUserData.userName)
				.success(function(dat1){
					if(!dat1.success){
						alert('Error');
						//console.log(dat1);
						window.location.reload();
					}
					else
					{
						window.location.reload();
					}
				})
			}
			else
			{
				alert('ไม่สามารถลบพนักงานคนนี้ได้');
			}
		}
	}
	
	$scope.showConfirmDel = function(delVal) 
	{	
		if($scope.sessionUserData.packageValid !== true)
		{
			$('#expiredModal').modal({
				backdrop: 'static',
				show: 'true'
			});
		}
		else
		{
			//console.log(delVal);
			$scope.delData = delVal;
				$('#form_delete').modal({
					backdrop: 'static',
					show : 'true'
				});
		}
	} 

	$scope.$watch('modPermissions.revenue_operating_main',function(){
		if ($scope.modPermissions.revenue_operating_main == false)
		{
			$scope.modPermissions.revenue_operating_history = false;
		}
	});

	$scope.$watch('modPermissions.expense_operating_main',function(){
		if ($scope.modPermissions.expense_operating_main == false)
		{
			$scope.modPermissions.expense_operating_history = false;
		}
	});
	
	
	$scope.checkDupUser = function(curName,newName,userNameId)
	{
		if(userNameId > 1)
		{
			if(curName !== $scope.accounts[userNameId].user_name)
			{
			$dbService.checkDuplicateUser(newName)
				.success(function(dat1){
					if(!dat1.success){
						$scope.userName.duplicateCheck = 1;
					}
					else
					{
						$scope.userName.duplicateCheck = 0;		
					}
				})
			}
			else
			{
				$scope.userName.duplicateCheck = 0;		
			}
		}
	}
	// var checkDuplicateUser = function(userName)
	// {
		// $dbService.checkDuplicateUser(userName)
			// .success(function(dat1){
				// if(!dat1.success){
					// $scope.userName.duplicateCheck = 1;
				// }
				// else
				// {
					// $scope.userName.duplicateCheck = 0;		
				// }
			// })
	// }
	
}); 
