angular.module('MetronicApp') 
.service('$getQuery',function($http) {
	//get cashflow summary
	this.getCashFlowSummary = function(){
		return $http.get('php_data/getCashflowSummary.php?business_id=1').then(function(data){return data.data;},function(err){return {error:err};});
	}
	//get menus
	//this.getMenus = function(menuType,mod=false){
	this.getMenus = function(menuType,mod){
		return $http.get('php_data/getMenusData.php?business_id=1&menu_type='+menuType+'&mod='+mod,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	}
	//get trans
	this.getTrans = function(menuType){
		return $http.get('php_data/getTransData.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	},
	//get advance trans
	this.getAdvTrans = function(menuType){
		return $http.get('php_data/getAdvTransData.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	}	
	//get lv3 menus
	this.getLv3Menus = function(menuType){
		return $http.get('php_data/getLv3Menus.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	}
	//get creditors/debtors accounts
	this.getAccounts = function(menuType){
		return $http.get('php_data/getAccounts.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	}
	this.getAmount = function(sDate,eDate,reportType,category){
		return $http.get('php_data/getCashflowGraph.php?business_id=1&startDate='+sDate+'&endDate='+eDate+'&type='+reportType+'&category='+category,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	}
	this.getUsers = function(businessId) {
		return $http.get('php_data/getUsers.php?business_id='+businessId).then(function(data){return data.data;},
	  function(err){return {error:err};})
	}
	
	this.getPersonal = function(PersonalId){
        return $http.get('php_data/getPersonal.php?business_id=1&id='+PersonalId).then(function(data){return data.data;},
      function(err){return {error:err};}) 
    }
	this.getAccDataSum = function(d1,d2,menuType){
		return $http.get('php_data/getAccountsDataSummary.php?business_id=1&start_date='+d1+'&end_date='+d2+'&menu_type='+menuType).then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getReportSettings = function(){
		return $http.get('php_data/getSettingsReportOptions.php?business_id=1').then(function(data){return data.data;},function(err){return {error:err};});
	}	
	//get all creditors & debtors accounts
	// this.getAllAccounts = function(){
		// return $http.get('php_data/getAllAccounts.php?business_id=1',{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} ).then(function(data){return data.data;});
	// } 
	this.getInvoice = function(type, form){
		return $http.get('php_data/getInvoice.php?type='+type+'&form='+form).then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getInvoiceReference = function(form,is_item_VAT){
		return $http.get('php_data/getInvoiceReference.php?form='+form+'&is_item_VAT='+is_item_VAT).then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getInvoiceItem = function(){
		return $http.get('php_data/getInvoiceItem.php').then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getInvoiceSettings = function(){
		return $http.get('php_data/getInvoiceSettings.php').then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getInvoiceData = function(type, mongoId, docId){
		header = mongoId ? 'type='+type+'&mongo_id='+mongoId : 'type='+type+'&doc_id='+docId;
		return $http.get('php_data/getInvoiceData.php?'+header).then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getInvoiceCount = function(jsonString){
		return $http.get('php_data/getInvoiceCount.php?jsonString='+jsonString).then(function(data){return data.data;},function(err){return {error:err};});
	}
	this.getInvoiceDashboard = function(start_date){
		return $http.get('php_data/getInvoiceDashboardSummary.php?start_date='+start_date);
	}
})
.service('$dbService',function($http){
	//Check Lv3 Max
	this.checkLv3Max = function(lv2Id,menuType){
		return $http.get('php_data/checkLv3Max.php?business_id=1&lv2id='+lv2Id+'&menu_type='+menuType);
	}	//Check Lv3 name
	this.checkLv3Name = function(lv3Name,menuType, lv2Id){
		return $http.get('php_data/checkLv3Name.php?business_id=1&lv3name='+lv3Name+'&menu_type='+menuType+'&lv2_id='+lv2Id);
	}
	//Add lv3 menu
	this.newLv3Menu = function(lv2RefId,menuType,lv1,lv3Name,userId,userName){
		return $http.get('php_data/insertLv3Menu.php?business_id=1&lv2id='+lv2RefId+'&lv3name='+lv3Name+'&menu_type='+menuType+'&lv1='+lv1+'&user_id='+userId+'&user_name='+userName);
	}
	//Check Lv2 Maximum
	this.checkLv2Max = function(lv1,menuType){
		return $http.get('php_data/checkLv2Max.php?business_id=1&lv1='+lv1+'&menu_type='+menuType);
	}	//Check Lv2 name
	this.checkLv2Name = function(lv2Name,menuType){
		return $http.get('php_data/checkLv2Name.php?business_id=1&lv2name='+lv2Name+'&menu_type='+menuType);
	}
	//Add lv2 menu
	this.newLv2Menu = function(lv2Name,Lv1Menu,menuType,userId,userName){
		return $http.get('php_data/insertLv2Menu.php?business_id=1&lv2name='+lv2Name+'&lv1_menu='+Lv1Menu+'&menu_type='+menuType+'&user_id='+userId+'&user_name='+userName);
	}
	//Add transaction
	this.newTran = function(lv2TransId,lv3TransId,transDate,transValue,menuType,lv1,transComment,transAccount,userId,userName){
		return $http.get('php_data/insertTransData.php?business_id=1&lv2id='+lv2TransId+'&lv3id='+lv3TransId+'&transdate='+transDate+'&transval='+transValue+'&menutype='+menuType+'&lv1='+lv1+'&transcomment='+transComment+'&transaccount='+transAccount+'&user_id='+userId+'&user_name='+userName);
	}
	//get transaction detail
	this.getTranDetail = function(tranId,menuType,lv1Type){
		return $http.get('php_data/getTransDetail.php?business_id=1&transid='+tranId+'&menu_type='+menuType+'&lv1_type='+lv1Type);
	}
	//get advance transaction detail
	this.getAdvTranDetail = function(tranId,menuType,lv1Type){
		return $http.get('php_data/getAdvTransDetail.php?business_id=1&transid='+tranId+'&menu_type='+menuType+'&lv1_type='+lv1Type);
	}	
	//edit transaction detail
	this.editTran = function(tranId,menuType,lv1Type,tranDate,tranComment,tranValue,userId,userName){
		return $http.get('php_data/editTransDetail.php?business_id=1&transid='+tranId+'&menu_type='+menuType+'&trans_date='+tranDate+'&trans_comment='+tranComment+'&trans_value='+tranValue+'&user_id='+userId+'&user_name='+userName+'&lv1_type='+lv1Type);
	}
	//edit advanced transaction detail
	this.editAdvTran = function(tranId,menuType,lv1Type,tranDate,tranComment,transVal,userId,userName){
		return $http.get('php_data/editAdvTransDetail.php?business_id=1&transid='+tranId+'&menu_type='+menuType+'&trans_date='+tranDate+'&trans_comment='+tranComment+'&trans_value='+transVal+'&user_id='+userId+'&user_name='+userName+'&lv1_type='+lv1Type);
	}
	//delete transaction detail
	this.delTran = function (tranId,menuType,lv1Type,userId,userName) {
		return $http.get('php_data/deleteTransDetail.php?business_id=1&transid='+tranId+'&menu_type='+menuType+'&user_id='+userId+'&user_name='+userName+'&lv1_type='+lv1Type);
	}
	//delete transaction detail
	this.delAdvTran = function (tranId,menuType,lv1Type,userId,userName) {
		return $http.get('php_data/deleteAdvTransDetail.php?business_id=1&transid='+tranId+'&menu_type='+menuType+'&user_id='+userId+'&user_name='+userName+'&lv1_type='+lv1Type);
	}	
	//add advance transaction
	this.newAdvanceTran = function(lv2Id,lv3Id,transDate,transVal,menuType,lv1Type,transComment,creditor,userId,userName){
		return $http.get('php_data/insertAdvancedTransData.php?business_id=1&lv2id='+lv2Id+'&lv3id='+lv3Id+'&transdate='+transDate+'&transval='+transVal+'&menutype='+menuType+'&lv1='+lv1Type+'&transcomment='+transComment+'&account='+creditor+'&user_id='+userId+'&user_name='+userName);
	}
	//add account bu
/* 	this.addAccount = function(menuType,name,address,telephone,email,comment,tax_id,userId,userName){
		return $http.get('php_data/insertAccounts.php?business_id=1&name='+name+'&address='+address+'&tax_id='+tax_id+'&telephone='+telephone+'&email='+email+'&menu_type='+menuType+'&comment='+comment+'&user_id='+userId+'&user_name='+userName);
	} */
	//add account ph2.1
	this.addAccount = function(jsonData){
		return $http.post('php_data/insertAccounts.php',jsonData);
	}
	//get accounts
	this.getAccounts = function(menuType){
		return $http.get('php_data/getAccounts.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} );
	}	
	//get menus
	//this.getMenus = function(menuType,mod=false){
	this.getMenus = function(menuType,mod){
		return $http.get('php_data/getMenusData.php?business_id=1&menu_type='+menuType+'&mod='+mod,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} );
	}
	//get trans
	this.getTrans = function(menuType){
		return $http.get('php_data/getTransData.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} );
	}
	//get advance trans
	this.getAdvTrans = function(menuType){
		return $http.get('php_data/getAdvTransData.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} );
	}		
	//toggle menu visiblility
	this.editMenuVisibility = function (lv2id,lv3id,menuType,visible,userId,userName) {
		return $http.get('php_data/editMenuVisibility.php?business_id=1&mcf_id='+lv2id+'&mcf_sub_id='+lv3id+'&menu_type='+menuType+'&visible='+visible+'&user_id='+userId+'&user_name='+userName);
	}	
	//delete menu
	this.delLv3Menu = function(lv2id,lv3id,menuType,userId,userName){
		return $http.get('php_data/deleteMenu.php?business_id=1&mcf_id='+lv2id+'&mcf_sub_id='+lv3id+'&menu_type='+menuType+'&user_id='+userId+'&user_name='+userName);
	}
	//get lv3 menus
	this.getLv3Menus = function(menuType){
		return $http.get('php_data/getLv3Menus.php?business_id=1&menu_type='+menuType,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}} );
	}
	//edit menu
	this.editMenuName = function(lv2id,lv3id,menuType,newName,userId,userName){
		return $http.get('php_data/editMenuName.php?business_id=1&mcf_id='+lv2id+'&mcf_sub_id='+lv3id+'&menu_type='+menuType+'&new_name='+newName+'&user_id='+userId+'&user_name='+userName);
	}
	//edit account bu
/* 	this.editAccount = function(menuType,id,name,address,tel,email,comment,tax_id,user_id,user_name){
		return $http.get('php_data/editAccount.php?business_id=1&menu_type='+menuType+'&tax_id='+tax_id+'&acc_id='+id+'&acc_name='+name+'&acc_addr='+address+'&acc_tel='+tel+'&acc_email='+email+'&acc_comment='+comment+'&user_id='+user_id+'&user_name='+user_name);
	} */
	//edit account ph2.1
	this.editAccount = function(jsonData){
		return $http.post('php_data/editAccount.php',jsonData);
	}	
	//edit users  -- Need to check!!!
	this.editUser = function(data,userId,userName){
		return $http.get('php_data/editUsers.php?business_id=1&creator_id='+userId+'&creator_name='+userName+'&'+data);
	}
	//check max users -- Need to check!!!!
	this.checkUserMax = function(){
		return $http.get('php_data/checkUsersMax.php?business_id=1');
	}	//add users -- Need to check!!!!
	this.addUser = function(data,userId,userName){
		return $http.get('php_data/insertUsers.php?business_id=1&creator_id='+userId+'&creator_name='+userName+'&'+data);
	}
	//remove users -- Need to check!!!!
	this.removeUser = function(data,userId,userName){
		return $http.get('php_data/removeUsers.php?business_id=1&target_user='+data+'&remover_id='+userId+'&remover_name='+userName);
	}
	this.checkDuplicateUser = function(userName){
		return $http.get('php_data/checkUsernameDuplicate.php?user_name='+userName+'&business_id=1');
	}
	//delete account
	this.delAccount = function(menuType,id,user_id,user_name){
		return $http.get('php_data/deleteAccount.php?business_id=1&menu_type='+menuType+'&acc_id='+id+'&user_id='+user_id+'&user_name='+user_name);
	}
	//edit personal setting
	//this.savePersonal = function(companyName,companyAddress,companyProvince,companyMobile,companyTel,companyEmail,user_id,user_name){
    //    return $http.get('php_data/savePersonal.php?acc_name='+companyName+'&acc_addr='+companyAddress+'&acc_province='+companyProvince+'&acc_mobile='+companyMobile+'&acc_tel='+companyTel+'&acc_email='+companyEmail+'&user_id='+user_id+'&user_name='+user_name);
    //}
        
    //Insert personal setting
    this.insertPersonal = function(personalId,companyName,companyAddress,companyProvince,companyMobile,companyTel,companyEmail,user_id,user_name){
        return $http.get('php_data/insertPersonal.php?business_id=1&id='+personalId+'&acc_name='+companyName+'&acc_addr='+companyAddress+'&acc_province='+companyProvince+'&acc_mobile='+companyMobile+'&acc_tel='+companyTel+'&acc_email='+companyEmail+'&user_id='+user_id+'&user_name='+user_name);
    }
    
    //edit personal setting bu
    // this.editPersonal = function(personalId,companyName,companyAddress,companyProvince,companyMobile,companyTel,companyEmail,tax_id,user_id,user_name){
        // return $http.get('php_data/editPersonal.php?business_id=1&id='+personalId+'&acc_name='+companyName+'&tax_id='+tax_id+'&acc_addr='+companyAddress+'&acc_province='+companyProvince+'&acc_mobile='+companyMobile+'&acc_tel='+companyTel+'&acc_email='+companyEmail+'&user_id='+user_id+'&user_name='+user_name);
    // }
	//edit personal setting, ph2.1
	this.editPersonal = function(jsonData){
		return $http.post('php_data/editPersonal.php',jsonData);
	}
	//get accounts summary data
	this.getAccDataSum = function(d1,d2,menuType){
		return $http.get('php_data/getAccountsDataSummary.php?business_id=1&start_date='+d1+'&end_date='+d2+'&menu_type='+menuType);
	}
	//edit notifications, if there are more noti, add argument after advTransData
	this.editNotification = function(notiData){
		//data = advTransData.assign({},advTransData);
		return $http.post('php_data/editSettingsNotification.php',notiData);
	}
	//edit report settings
	this.editReportOptions = function(reportSettings){
		//data = advTransData.assign({},advTransData);
		return $http.post('php_data/editSettingsReportOptions.php',reportSettings);
	}	
	// validate coupon code
	this.couponValidate = function(couponData){
	//data = advTransData.assign({},advTransData);
	return $http.post('https://www.myinvoice.asia/remote_con/coupon_validate',couponData,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
	}
    //Insert Invoice item
    this.insertInvoiceItem = function(itemData,userData){
        return $http.post('php_data/insertInvoiceItem.php',{item:itemData ,user:userData},{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
    }
    //Edit Invoice item
    this.editInvoiceItem = function(itemData,userData){
        return $http.post('php_data/editInvoiceItem.php',{item:itemData ,user:userData},{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
    }
	//fetch Invoice item
	this.getInvoiceItem = function(){
		return $http.get('php_data/getInvoiceItem.php');
	}	
	//delete Invoice item
	this.deleteInvoiceItem = function(item_id,userData){
		return $http.post('php_data/deleteInvoiceItem.php',{item_id:item_id ,user:userData},{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
	}
    //Insert Invoice
    this.insertInvoice = function(jsonDat){
        return $http.post('php_data/insertInvoice.php',jsonDat,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
    }
	//update settings invoice
	this.editSettingsInvoice = function(jsonDat){
        return $http.post('php_data/editSettingsInvoice.php',jsonDat,{
			withCredentials: true,
			headers: {'Content-Type': undefined },
			transformRequest: angular.identity
	  });
    }
	//update invoice
	this.editInvoice = function(jsonDat){
        return $http.post('php_data/editInvoice.php',jsonDat,{
			withCredentials: true,
			headers: {'Content-Type': undefined },
			transformRequest: angular.identity
	  });
    }
	//update invoice index
	   this.updateInvoiceIndex = function(form,index){
        return $http.get('php_data/updateInvoiceIndex.php?form='+form+'&index='+index);
		//$http.get('php_data/getAccountsDataSummary.php?business_id=1&start_date='+d1+'&end_date='+d2+'&menu_type='+menuType);
    }
	//udpate invoice referrer
	this.updateInvoiceReferrer = function(ref_id,ref_number,ref_by){
		return $http.get('php_data/updateInvoiceReferrer.php?ref_id='+ref_id+'&ref_number='+ref_number+'&ref_by='+ref_by);
	}
	//get invoice dashboard summary
	this.getInvoiceDashboard = function(start_date){
		return $http.get('php_data/getInvoiceDashboardSummary.php?start_date='+start_date);
	}
	//delete invoice
	this.deleteInvoice = function(jsonDat){
		return $http.post('php_data/deleteInvoice.php',jsonDat);
	}
	//get Invoice
	this.getInvoice = function(type, form){
		return $http.get('php_data/getInvoice.php?type='+type+'&form='+form);
	}
	//update business initial setup data
	this.updateInitialSetup = function(jsonDat){
		return $http.post('php_data/updateInitialSetup.php',jsonDat);
	}
	//bulk auto add invoice items
    this.bulkInsertInvoiceItem = function(jsonDat){
        return $http.post('php_data/bulkInsertInvoiceItem.php',jsonDat,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
    }
	//update inserted cashflow id to root invoice document
	this.updateInvoiceTransInfo = function(type, doc_id, trans_id){
		return $http.get('php_data/updateInvoiceTransInfo.php?type='+type+'&doc_id='+doc_id+'&trans_id='+trans_id);
	}
})
.service('$membershipService',function($http){
	this.getActivePackage = function(userPackageId){
		return	$http.get('https://www.myinvoice.asia/remote_con/get_packages?user_package_id='+userPackageId,{headers : {'Content-Type' : 'application/json; charset=UTF-8'}});
		//.then(function(data){return data.data;},function(err){return {error:err};});
	}
})
.service('$invoiceService',function($http){
	var id = null;
	this.setInvoiceId = function(input){
		id = input;
	}
	this.getInvoiceId = function(){
		return id;
	}
})
.service('$mathService',function(){

	this.notZeroDevision = function(dividend, divisor){
		var result = dividend/divisor;
		result = isNaN(result) || result === Infinity || result === -Infinity ? 0 : result;
		return result;
	}
})

.service('$sessionService',function($http){
	this.getUserData = function(){
		var promise;
		return $http.get('php_data/getLoginDomain.php?business_id=1').then(function(dat){
			promise = dat.data;
			return promise;
		});
	} 

});