(function() {
	
	// Get Angular's modules.
	var initInjector = angular.injector(['ng','ngCookies']);
	//var $http = initInjector.get('$http');
	//var $cookies = initInjector.get('$scope');
	initInjector.invoke(function($http, $cookies, $q) {

		
		// define valid server headers
		$http.defaults.headers.common["X-Requested-With"] = "XMLHttpRequest";
		$http.defaults.headers.common["X-Requested-By"] = "MCFApplication";
		var scope = {
			webSettings: {
				loginURL : "",
				registerURL : ""
			}
		};
		
		var rootScope = {};
		var stateParams = {};
		
		var hostUrl = window.location.hostname;
		if(hostUrl == "localhost") {
			var shopPathName = window.location.pathname;
			var shopPathSegment = shopPathName.split("/");
			scope.webSettings.loginURL = "http://localhost/"+shopPathSegment[1]+"/login";
			scope.webSettings.registerURL = "http://localhost/"+shopPathSegment[1]+"/register";
		} else {
			scope.webSettings.loginURL = "https://" + hostUrl +  "/login";
			scope.webSettings.registerURL = "https://" + hostUrl +  "/register";
		}
		
		
		scope.usingCookies = $cookies.get('mcf_data_session');
		scope.connectorCookies = $cookies.get('mcf_data_identity');
		scope.doLogout = doLogout;
		rootScope.doLogout = doLogout;
		rootScope.readyLoad = false;
		
		if(!scope.usingCookies || !scope.connectorCookies) {
			console.log("No cookies");
			doLogout();
			//test();
		} else {
			/* define promises */
			var promises = {
				loginDomain: getLoginDomain(),
				userData: getUserData()
			};
			/* wait for all promises then assign $scope variables */
			$q.all(promises).then(function(response){
				//console.log(response);
				setLoginDomain(response.loginDomain);
				setUserSession(response.userData.session);
				setUserPermission(response.userData.permission);
				//init userData
				let userData = {scope: scope, rootScope: rootScope, stateParams: stateParams};
				angular.module('userData', []).constant('userData', userData);
				// Start myAngularApp manually.
				angular.element(document).ready(function() {
					angular.bootstrap(document, ['MetronicApp']);
				});
			});
			/* get login domain */
			function getLoginDomain(){
				return $http.get('php_data/getLoginDomain.php?business_id=1')
					.then(function (response) {
						return response.data;
					}, function (err) {
						return err;
					});
			}
			/* get user session data & user permission */
			function getUserData() {
				return $http.get('php_data/getUserSessions.php?business_id=1&session_id=' + scope.usingCookies).then(
					function(response1) {
						return $http.get('php_data/getUserPermissions.php?business_id=1&user_id='+response1.data.userID).then(
							function(response2){
								return {session: response1.data, permission: response2.data};
							},
							function(err2){});
					},
					function (err1) {console.log(err1);});
			}
		
			function setLoginDomain(data) {
				if(scope.usingCookies !== "" && scope.connectorCookies !== ""){
					scope.webSettings.loginURL = data['loginURL'];
					scope.webSettings.registerURL = data['registerURL'];
				} else {
					console.log('no session');
					rootScope.forcedRedirectLogin = 1;
					rootScope.loginURL = scope.webSettings.loginURL;
					//window.location.href = $scope.webSettings.loginURL;
					doLogout();
				}
			}
		
			function setUserSession(data) {
			//console.log(data);
				if(data.success) {
					rootScope.readyLoad = true;
					/* Add initial setup flag & company info & user info */
					rootScope.initialSetupFlag = data.initialSetupFlag; 
					rootScope.companyData = data.companyData;
					rootScope.userData = {
						userId : data.userID,
						userName : data.userName,
						firstName : data.firstName,
						lastName : data.lastName
					};
					stateParams.userId = data.userID;
					scope.userId = data.userID;
					rootScope.userId = data.userID;
					scope.sessionUserData = {
						businessName : data.businessName,
						userId : data.userID,
						userName : data.userName,
						firstName : data.firstName,
						lastName : data.lastName,
						fullName : data.firstName + " " + data.lastName,
						packageID : data.packageID,
						packageName : data.packageName,
						packageStart : data.packageStart,
						packageEnd : data.packageEnd,
						memberId : data.mcf_member_id,
						paymentStatus : data.payment_pending,
						/*====Added New for Reports====*/
						reportHidden : data.report_hidden,
						reportDeleted : data.report_deleted,
						reportLevels : data.report_levels,
						/*====End Added New for Reports===*/
						/* ===Add initial setup flag=== */
						//initialSetupFlag : data.initialSetupFlag
					}; 
					scope.validatePaymentData = 0;
					scope.sessionUserData.packageValid = true;
					//scope.sessionUserData.disableButton = "";							  
					var packageValid  = data.package_valid;
					if(packageValid == 0) {
						scope.sessionUserData.packageValid = false;
						//scope.sessionUserData.disableButton = "disabled";
					}
					// var menuType = stateParams.menuType; console.log(menuType);
					// var lv1Menu = stateParams.lv1Menu;
					var userId = scope.userId;
					//scope.state = state.current
					//scope.params = stateParams;			
				} else {
					console.log('session_error');
					//console.log(data2);
					//window.location.href = $scope.webSettings.loginURL;
					doLogout();
				}
			}
			
			function setUserPermission(data) {
				if(data.success) {
					scope.userPermissions = data.permissions;
					rootScope.userPermissions = data.permissions;
					stateParams.userPermissions = data.permissions;
				}
			}
			
			function checkInitialSetup(){
				
			}
		}
		
		function doLogout() {
			var hostUrl = window.location.hostname;
			if(hostUrl == "localhost")
			{
				var shopPathName = window.location.pathname;
				var shopPathSegment = shopPathName.split("/");
				scope.webSettings.loginURL = "http://localhost/"+shopPathSegment[1]+"/login";
				scope.webSettings.registerURL = "http://localhost/"+shopPathSegment[1]+"/register";
			}
			else
			{
				scope.webSettings.loginURL = "https://" + hostUrl +  "/login";
				scope.webSettings.registerURL = "https://" + hostUrl +  "/register";
			}
			$cookies.remove("mcf_data_session", {path: "/"});
			$cookies.remove("mcf_data_identity", {path: "/"});
			$cookies.remove("mcf_chosen_module", {path: "/"});
			var loginURL = scope.webSettings.loginURL;
			window.location.href=loginURL;  
		}		
	});//End injector.invoke
})();
