<?php

/*===========Include MongoDB connections and settings==========*/
include('collection_lists.php');
/*==========Error Reporting - Uncomment for Debugging only==============*/		
//error_reporting(-1);
//ini_set('display_errors', 1);
		
		
/*===========GET PHP Data==========*/
$business_id = $_GET['business_id'] == "" ? 1 : (int)$_GET['business_id'];
$report_year = $_GET['startDate'] == "" ? date("Y") : date("Y",strtotime($_GET['startDate']));
$downloadFlag = $_GET['download'] == "" ? "false" : $_GET['download'];
$excel_report_format ="2";

$report_start_month = $_GET['startDate'] == "" ? date("m") : date("m",strtotime($_GET['startDate']));
$report_end_month = $_GET['endDate'] == "" ? date("m",strtotime("+1month")) 	: date("m",strtotime($_GET['endDate']));

$report_start_date = $_GET['startDate'] == "" ? date("01-m-Y") : $_GET['startDate'];
$report_end_date = $_GET['endDate'] == "" ? date("t-m-Y") : $_GET['endDate'];

$start_day = strtotime($report_start_date);
$start_day_formatted = date("d-m-Y",$start_day);
$end_day = strtotime($report_end_date);
$end_day_formatted = date("d-m-Y",$end_day);


/*=============Get Thai Month Array==================*/
$month_array = array(
			"01"		=>		'ม.ค.',
			"02"		=>		'ก.พ.',
			"03"		=>		'มี.ค.',
			"04"		=>		'เม.ษ.',
			"05"		=>		'พ.ค.',
			"06"		=>		'มิ.ย.',
			"07"		=>		'ก.ค.',
			"08"		=>		'ส.ค.',
			"09"		=>		'ก.ย.',
			"10"		=>		'ต.ค.',
			"11"		=>		'พ.ย.',
			"12"		=>		'ธ.ค.'
	);
$month_column_array = array(
			"01"		=>		'B',
			"02"		=>		'C',
			"03"		=>		'D',
			"04"		=>		'E',
			"05"		=>		'F',
			"06"		=>		'G',
			"07"		=>		'H',
			"08"		=>		'I',
			"09"		=>		'J',
			"10"		=>		'K',
			"11"		=>		'L',
			"12"		=>		'M'
);


/*===========Get Business and Report Settings==========*/
$collection = $client->$dbNameConnector->settings_personal;
$filter  = [ 'business_id' => $business_id];
$cursor = $collection->findOne($filter);
$business_name = $cursor['name'];
$report_levels = isset($cursor['report_settings']['show_levels']) ? $cursor['report_settings']['show_levels'] : "lv2_lv3";
$report_hidden = isset($cursor['report_settings']['show_hidden']) ? $cursor['report_settings']['show_hidden'] : true;
$report_deleted = isset($cursor['report_settings']['show_deleted']) ? $cursor['report_settings']['show_deleted'] : true;

$report_hidden = false;
$report_deleted = false;

$report_type = array(
	'1' 	=>	'rcv_trans',
	'2'	=>	'rcv_adv',
	'3'	=>	'exp_trans',
	'4'	=>	'exp_adv',
);

/*================GET MENU HEADERS================*/
$filter  = [ 'business_id' => (int)$business_id];
$lv3_visible = 0;
$lv3_active = 0;
/*=======Filter deleted and hidden menus======*/
if($report_hidden !== true)
{
	$filter['visible'] = 1;
	$lv3_visible = 1;
}
if($report_deleted !== true)
{
	$filter['active'] = 1;
	$lv3_active = 1;
}


$rcvMenu = $client->$dbNameConnector->receivings_menu;
$cursorRcv = $rcvMenu->find($filter);
$rcvMenuHeaders = array();
foreach($cursorRcv as $doc)
{
	$rcvMenuHeaders[$doc['lv1_menu']][$doc['name']] = array();
	foreach($doc['lv3'] as $lv3)
	{
		if($lv3_active == 1 && (int)$lv3['active'] !== (int)$lv3_active)
		{
			continue;
		}
		if($lv3_visible == 1 && (int)$lv3['visible'] !== (int)$lv3_visible)
		{
			continue;
		}
		$rcvMenuHeaders[$doc['lv1_menu']][$doc['name']][] = array('name'=>$lv3['name'],'lv2_id'=>$doc['mcf_id'],'lv3_id'=>$lv3['mcf_sub_id']);
		$cursorRcvArray[$doc['lv1_menu']][]= array('name' => $lv3['name'], 'id' => $doc['mcf_id'], 'lv3_id' => $lv3['mcf_sub_id']);
	}
}
$expMenu = $client->$dbNameConnector->expenses_menu;
$cursorExp = $expMenu->find($filter);
$expMenuHeaders = array();
foreach($cursorExp as $doc)
{
	$expMenuHeaders[$doc['lv1_menu']][$doc['name']] = array();
	foreach($doc['lv3'] as $lv3)
	{
		if($lv3_active == 1 && (int)$lv3['active'] !== (int)$lv3_active)
		{
			continue;
		}
		if($lv3_visible == 1 && (int)$lv3['visible'] !== (int)$lv3_visible)
		{
			continue;
		}
		$expMenuHeaders[$doc['lv1_menu']][$doc['name']][] = array('name'=>$lv3['name'],'lv2_id'=>$doc['mcf_id'],'lv3_id'=>$lv3['mcf_sub_id']);
		$cursorExpArray[$doc['lv1_menu']][] = array('name' => $lv3['name'], 'id' => $doc['mcf_id'], 'lv3_id' => $lv3['mcf_sub_id']);
	}
}


/*====================Data Query==================*/
$filter  = [ 'business_id' => $business_id, 'trans_date' => ['$gte'=>$start_day,'$lte'=>$end_day] ];
if($report_deleted !== true)
{
	$filter['visible'] = 1;
}
$options = ['sort' => ['mcf_trans_id' => 1]];

$trans_rcv_act = $collection_menu_types[$report_type[1]];
$trans_rcv_adv = $collection_menu_types[$report_type[2]];
$trans_exp_act = $collection_menu_types[$report_type[3]];
$trans_exp_adv = $collection_menu_types[$report_type[4]];

$rcv_act_collection = $client->$dbNameConnector->$trans_rcv_act;
$rcv_adv_collection = $client->$dbNameConnector->$trans_rcv_adv;
$exp_act_collection = $client->$dbNameConnector->$trans_exp_act;
$exp_adv_collection = $client->$dbNameConnector->$trans_exp_adv;


$summaryCashflow = array();
$cursor = $rcv_act_collection->find($filter,$options);
$rcvMenuQuery = array( 'period' => array() );
foreach ($cursor as $doc) {
	if(array_key_exists($doc['lv2_name'],$rcvMenuQuery['period'][$doc['lv1_menu']]))
	{	
		if($rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] == $doc['lv2_id'])
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$current_val = $rcvMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]['lv2_val'];
			$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = floatval(bcadd($current_val,$new_val,2));
			if(array_key_exists($doc['lv3_name'],$rcvMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]))
			{
				if(isset($rcvMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]))
				{
					$current_lv3_val = floatval($rcvMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]);
					$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval(bcadd($current_lv3_val,$new_val,2));
				}
				else
				{
					$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
				}
			}
			else
			{
				$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			}
			foreach($rcvMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary'] = floatval(bcadd($current_summary_val,$new_val,2));	
						$summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']] = floatval(bcadd($current_lv2_summary_val,$new_val,2));
						$total_summary = floatval($summaryCashflow['period']['actual']['total_summary']);
						$summaryCashflow['period']['actual']['total_summary'] = floatval(bcadd($total_summary,$new_val,2));
				}
			}
		}
		else
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
			$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
			$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			
			foreach($rcvMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary'] = floatval(bcadd($current_summary_val,$new_val,2));
						$summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']] = floatval(bcadd($current_lv2_summary_val,$new_val,2));
						$total_summary = floatval($summaryCashflow['period']['actual']['total_summary']);
						$summaryCashflow['period']['actual']['total_summary'] = floatval(bcadd($total_summary,$new_val,2));
				}
			}
		}
	}
	else 
	{
		$new_val_substring = str_replace(",","",$doc['trans_val']);
		$new_val = floatval($new_val_substring);
		$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
		$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
		$rcvMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
	
		foreach($rcvMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
		{	
			if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
			{
					$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary']);
					$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']]);
					$summaryCashflow['period'][$doc['lv1_menu']]['summary'] = floatval(bcadd($current_summary_val,$new_val,2));
					$summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']] = floatval(bcadd($current_lv2_summary_val,$new_val,2));
					$total_summary = floatval($summaryCashflow['period']['actual']['total_summary']);
					$summaryCashflow['period']['actual']['total_summary'] = floatval(bcadd($total_summary,$new_val,2));
			}
		}
	}
}

$cursor = $rcv_adv_collection->find($filter,$options);
$rcvAdvTransQuery = array('period'=>array() );
foreach ($cursor as $doc) {
	if(array_key_exists($doc['lv2_name'],$rcvAdvTransQuery['period'][$doc['lv1_menu']]))
	{	
		if($rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] == $doc['lv2_id'])
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$current_val = $rcvAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]['lv2_val'];
			$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = floatval(bcadd($current_val,$new_val,2));
			if(array_key_exists($doc['lv3_name'],$rcvAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]))
			{
				if(isset($rcvAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]))
				{
					$current_lv3_val = floatval($rcvAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]);
					$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval(bcadd($current_lv3_val,$new_val,2));
				}
				else
				{
					$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
				}
			}
			else
			{
				$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			}
			foreach($rcvMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast'] = floatval(bcadd($current_summary_val,$new_val,2));	
						$summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']] = floatval(bcadd($current_lv2_summary_val,$new_val,2));
						$total_summary = floatval($summaryCashflow['period']['advanced']['total_summary']);
						$summaryCashflow['period']['advanced']['total_summary'] = floatval(bcadd($total_summary,$new_val,2));
				}
			}
		}
		else
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
			$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
			$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			
			foreach($rcvMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast'] = floatval(bcadd($current_summary_val,$new_val,2));
						$summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']] = floatval(bcadd($current_lv2_summary_val,$new_val,2));
						$total_summary = floatval($summaryCashflow['period']['advanced']['total_summary']);
						$summaryCashflow['period']['advanced']['total_summary'] = floatval(bcadd($total_summary,$new_val,2));
				}
			}
		}
	}
	else 
	{
		$new_val_substring = str_replace(",","",$doc['trans_val']);
		$new_val = floatval($new_val_substring);
		$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
		$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
		$rcvAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
	
		foreach($rcvMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
		{	
			if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
			{
					$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast']);
					$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']]);
					$summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast'] = floatval(bcadd($current_summary_val,$new_val,2));
					$summaryCashflow['period'][$doc['lv1_menu']]['rcv'][$doc['lv2_id']] = floatval(bcadd($current_lv2_summary_val,$new_val,2));
					$total_summary = floatval($summaryCashflow['period']['advanced']['total_summary']);
					$summaryCashflow['period']['advanced']['total_summary'] = floatval(bcadd($total_summary,$new_val,2));
			}
		}
	}
}


$expMenuQuery = array();
$cursor = $exp_act_collection->find($filter,$options);

foreach ($cursor as $doc) {
	if(array_key_exists($doc['lv2_name'],$expMenuQuery['period'][$doc['lv1_menu']]))
	{	
		if($expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] == $doc['lv2_id'])
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$current_val = $expMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]['lv2_val'];
			$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = floatval(bcadd($current_val,$new_val,2));
			if(array_key_exists($doc['lv3_name'],$expMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]))
			{
				if(isset($expMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]))
				{
					$current_lv3_val = floatval($expMenuQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]);
					$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval(bcadd($current_lv3_val,$new_val,2));
				}
				else
				{
					$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
				}
			}
			else
			{
				$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			}
			foreach($expMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary'] = floatval(bcsub($current_summary_val,$new_val,2));	
						$summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']] = floatval(bcsub($current_lv2_summary_val,$new_val,2));	
						$total_summary = floatval($summaryCashflow['period']['actual']['total_summary']);
						$summaryCashflow['period']['actual']['total_summary'] = floatval(bcsub($total_summary,$new_val,2));
				}
			}
		}
		else
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
			$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
			$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			
			foreach($expMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary'] = floatval(bcsub($current_summary_val,$new_val,2));
						$summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']] = floatval(bcsub($current_lv2_summary_val,$new_val,2));
						$total_summary = floatval($summaryCashflow['period']['actual']['total_summary']);
						$summaryCashflow['period']['actual']['total_summary'] = floatval(bcsub($total_summary,$new_val,2));
				}
			}
		}
	}
	else 
	{
		$new_val_substring = str_replace(",","",$doc['trans_val']);
		$new_val = floatval($new_val_substring);
		$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
		$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
		$expMenuQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
	
		foreach($expMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
		{	
			if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
			{
					$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary']);
					$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']]);
					$summaryCashflow['period'][$doc['lv1_menu']]['summary'] = floatval(bcsub($current_summary_val,$new_val,2));
					$summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']] = floatval(bcsub($current_lv2_summary_val,$new_val,2));
					$total_summary = floatval($summaryCashflow['period']['actual']['total_summary']);
					$summaryCashflow['period']['actual']['total_summary'] = floatval(bcsub($total_summary,$new_val,2));
			}
		}
	}
}
$expAdvTransQuery = array();
$cursor = $exp_adv_collection->find($filter,$options);

foreach ($cursor as $doc) {
	if(array_key_exists($doc['lv2_name'],$expAdvTransQuery['period'][$doc['lv1_menu']]))
	{	
		if($expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] == $doc['lv2_id'])
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$current_val = $expAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]['lv2_val'];
			$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = floatval(bcadd($current_val,$new_val,2));
			if(array_key_exists($doc['lv3_name'],$expAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']]))
			{
				if(isset($expAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]))
				{
					$current_lv3_val = floatval($expAdvTransQuery['period'][$doc['lv1_menu']][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']]);
					$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval(bcadd($current_lv3_val,$new_val,2));
				}
				else
				{
					$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
				}
			}
			else
			{
				$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			}
			foreach($expMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast'] = floatval(bcsub($current_summary_val,$new_val,2));	
						$summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']] = floatval(bcsub($current_lv2_summary_val,$new_val,2));	
						$total_summary = floatval($summaryCashflow['period']['advanced']['total_summary']);
						$summaryCashflow['period']['advanced']['total_summary'] = floatval(bcsub($total_summary,$new_val,2));
				}
			}
		}
		else
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
			$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
			$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
			
			foreach($expMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
			{	
				if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
				{
						$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast']);
						$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']]);
						$summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast'] = floatval(bcsub($current_summary_val,$new_val,2));
						$summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']] = floatval(bcsub($current_lv2_summary_val,$new_val,2));
						$total_summary = floatval($summaryCashflow['period']['advanced']['total_summary']);
						$summaryCashflow['period']['advanced']['total_summary'] = floatval(bcsub($total_summary,$new_val,2));
				}
			}
		}
	}
	else 
	{
		$new_val_substring = str_replace(",","",$doc['trans_val']);
		$new_val = floatval($new_val_substring);
		$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_val'] = $new_val;
		$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']]['lv2_id'] = $doc['lv2_id'];
		$expAdvTransQuery['period'][($doc['lv1_menu'])][$doc['lv2_name']][$doc['lv3_name']][$doc['lv3']] = floatval($new_val);
	
		foreach($expMenuHeaders[$doc['lv1_menu']][$doc['lv2_name']] as $key=>$val)
		{	
			if($val['lv2_id'] == $doc['lv2_id'] && $val['lv3_id'] == $doc['lv3'])
			{
					$current_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast']);
					$current_lv2_summary_val = floatval($summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']]);
					$summaryCashflow['period'][$doc['lv1_menu']]['summary_forecast'] = floatval(bcsub($current_summary_val,$new_val,2));
					$summaryCashflow['period'][$doc['lv1_menu']]['exp'][$doc['lv2_id']] = floatval(bcsub($current_lv2_summary_val,$new_val,2));
					$total_summary = floatval($summaryCashflow['period']['advanced']['total_summary']);
					$summaryCashflow['period']['advanced']['total_summary'] = floatval(bcsub($total_summary,$new_val,2));
			}
		}
	}
}


$queryFilter = $filter;

$summaryCashflow['period']['cfo']['summary_difference'] = floatval(bcsub($summaryCashflow['period']['cfo']['summary'],$summaryCashflow['period']['cfo']['summary_forecast'],2));
$summaryCashflow['period']['cff']['summary_difference'] = floatval(bcsub($summaryCashflow['period']['cff']['summary'],$summaryCashflow['period']['cff']['summary_forecast'],2));
$summaryCashflow['period']['cfi']['summary_difference'] = floatval(bcsub($summaryCashflow['period']['cfi']['summary'],$summaryCashflow['period']['cfi']['summary_forecast'],2));
$summaryCashflow['period']['total_difference'] = floatval(bcsub($summaryCashflow['period']['actual']['total_summary'],$summaryCashflow['period']['advanced']['total_summary'],2));

//foreach($expMenuHeaders['cfo'] as $key=>$val)
//{
//	for($k=0;$k<sizeof($val);$k++)
//		{
//			for ($i=0;$i<sizeof($cursorExpArray['cfo']);$i++)
//			{
//				print_r($expMenuQuery["period"]["cfo"][$key]);
//				//print_r($val[$k]['name']);
//				//print_r('...');
//			}
//		}
//}

//echo json_encode(array('rcv'=>$rcvMenuQuery,'exp'=>$expMenuQuery,'summary'=>$summaryCashflow,'month'=>$month_name,'number_of_days'=>$number_of_days,'start_date'=>$start_date,'end_date'=>$end_date,'rcv_header'=>$rcvMenuHeaders,'exp_header'=>$expMenuHeaders,'advRcv'=>$rcvAdvTransQuery,'advExp'=>$expAdvTransQuery));
 
date_default_timezone_set('Asia/Bangkok'); 

require  '../../Classes/PHPExcel.php';
if (PHP_SAPI == 'cli')
	die('This example should only be run from a Web Browser');

use PhpOffice\PhpSpreadsheet\Cell\DataType;
use PhpOffice\PhpSpreadsheet\Style\Alignment;
use PhpOffice\PhpSpreadsheet\Style\Border;
use PhpOffice\PhpSpreadsheet\Style\Color;

// Create new PHPExcel object
$objPHPExcel = new PHPExcel();
$excelFileName = date("d-m-Y")."_".$business_name."_".$report_year."cashflow_compare.xlsx";
$excelFileName2 = date("d-m-Y")."_".$business_name."_".$report_year."cashflow_compare-".strtotime('now').".xlsx";

//print_r($excel_report_format);
//exit;

// Redirect output to a client’s web browser (Excel2007)
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="'.$excelFileName.'"');
header('Cache-Control: max-age=0');

// If you're serving to IE 9, then the following may be needed
header('Cache-Control: max-age=1');

// If you're serving to IE over SSL, then the following may be needed
header ('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
header ('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT'); // always modified
header ('Cache-Control: cache, must-revalidate'); // HTTP/1.1
header ('Pragma: public'); // HTTP/1.0

// Set document properties
$objPHPExcel->getProperties()->setCreator("MyCashFlow System")
							 ->setLastModifiedBy("MyCashFlow System")
							 ->setTitle("Office 2007 Cashflow Summary Report")
							 ->setSubject("Office 2007 Cashflow Summary Report")
							 ->setDescription("Document for Office 2007 XLSX, generated by MyCashFlow.")
							 ->setKeywords("office 2007 openxml php")
							 ->setCategory("Business Cashflow Summary");
$rowNum = 1;
$objPHPExcel->setActiveSheetIndex(0)->setCellValue('A'.$rowNum, 'รายงานกระแสเงินสด');
$objPHPExcel->getActiveSheet()->getStyle('A1')->getFont()->setBold(true);						 
$objPHPExcel->getActiveSheet()->getStyle('A1')->getFont()->setSize(20);
$rowNum++;
$objPHPExcel->setActiveSheetIndex(0)->setCellValue('A'.$rowNum, $business_name);
$rowNum++;

// Include report view type
include('partial_reports/cashflow_compare.php');

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objPHPExcel->setActiveSheetIndex(0);

//Create file and sent to output
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');

if($downloadFlag == "true")
{
	$objWriter->save('php://output');
	// Done!
	exit; 
}
else if($downloadFlag == "false")
{
	//$objWriter->save('/opt/bitnami/apache2/htdocs/uploads/'.$excelFileName2);
	echo json_encode(array('success'=>true,'rcv'=>$rcvMenuQuery,'rcvAdv'=>$rcvAdvTransQuery,'exp'=>$expMenuQuery,'expAdv'=>$expAdvTransQuery,'summary'=>$summaryCashflow,'fileName'=>'https://'.$_SERVER['HTTP_HOST'].'/uploads/'.$excelFileName2,'sheetName'=>'CashflowCompareSummary-'.$report_year));
}
?>