<?php
include('collection_lists.php');


$collection = $client->$dbNameConnector->receivings_trans;

date_default_timezone_set('Asia/Bangkok'); 

$business_id = $_GET['business_id'] !== "" ? (int)$_GET['business_id'] : 1;
//$query_period_string_start = "-".date("m")."-".date("Y");
//$query_period_string_end = "-".date("m")."-".date("Y");

$query_period_string_start = strtotime(date('01-m-Y',strtotime('this month')));
$query_period_string_end =   strtotime(date('t-m-Y',strtotime('this month')));


$month_names = array("01"=>"มกราคม",  
        "02"=>"กุมภาพันธ์",  
        "03"=>"มีนาคม",  
        "04"=>"เมษายน",  
        "05"=>"พฤษภาคม",  
        "06"=>"มิถุนายน",  
        "07"=>"กรกฎาคม",  
        "08"=>"สิงหาคม",  
        "09"=>"กันยายน", 
        "10"=>"ตุลาคม", 
        "11"=>"พฤศจิกายน", 
        "12"=>"ธันวาคม" 
); 
$month_name = $month_names["".date("m").""];


/* Actual Receivings Data */

$rcvMenuQuery = array();

//$filter  = [ 'visible' => 1 , 'trans_date' => new MongoDB\BSON\Regex($query_period_string.'$', 'i')];
$filter  = [ 'visible' => 1 , 'business_id' => $business_id, 'trans_date' => ['$gte' => $query_period_string_start, '$lte' => $query_period_string_end]  ];
$options = ['sort' => ['mcf_trans_id' => 1]];

$cursor = $collection->find($filter,$options);
foreach ($cursor as $doc) {
	$rcvMenuQuery[] = ($doc);
}

/* Actual Expense Data */

	$expMenuQuery = array();
	$collection = $client->$dbNameConnector->expenses_trans;
	$cursor = $collection->find($filter,$options);
	foreach ($cursor as $doc) {
		$expMenuQuery[] = ($doc);
	}


/* Advanced Receivings Data */

$advRcvMenuQuery = array();

//$filter  = [ 'visible' => 1 , 'trans_date' => new MongoDB\BSON\Regex($query_period_string.'$', 'i')];
$filter  = [ 'visible' => 1 , 'business_id' => $business_id, 'trans_date' => ['$gte' => $query_period_string_start, '$lte' => $query_period_string_end]  ];
$options = ['sort' => ['mcf_advanced_trans_id' => 1]];

$collection = $client->$dbNameConnector->advanced_receivings;
$cursor = $collection->find($filter,$options);
foreach ($cursor as $doc) {
	$advRcvMenuQuery[] = ($doc);
}


/* Advanced Expense Data */

$advExpMenuQuery = array();

$collection = $client->$dbNameConnector->advanced_expenses;
$cursor = $collection->find($filter,$options);
foreach ($cursor as $doc) {
	$advExpMenuQuery[] = ($doc);
}


$number_of_days = cal_days_in_month(CAL_GREGORIAN, date('m'), date('Y')); 
$days_object = new ArrayObject();
for($i=1;$i<=$number_of_days;$i++)
{
	$days_object->append($i);
}




$rcv_data_size = sizeof($rcvMenuQuery);
$exp_data_size = sizeof($expMenuQuery);
$adv_rcv_data_size = sizeof($advRcvMenuQuery);
$adv_exp_data_size = sizeof($advExpMenuQuery);


$sum_receivings = 0.00;
$sum_expenses = 0.00;
$sum_adv_receivings = 0.00;
$sum_adv_expenses = 0.00;
$sum_total = 0.00;
$recv_data = new ArrayObject();
$adv_recv_data = new ArrayObject();
$exp_data = new ArrayObject();
$adv_exp_data = new ArrayObject();


$rcv_summ_array = array();
$exp_summ_array = array();
$adv_rcv_summ_array = array();
$adv_exp_summ_array = array();
// Create summary for each date
for($i=0;$i<$rcv_data_size;$i++)
{
	$formatted_date = date("d-m-Y",$rcvMenuQuery[$i]->trans_date);
	$rcvMenuQuery[$i]->original_date = $rcvMenuQuery[$i]->trans_date;
	$rcvMenuQuery[$i]->trans_date = $formatted_date;
	$trans_date = substr($formatted_date,0,2);
	$val = str_replace(",","",($rcvMenuQuery[$i]->trans_val));
	$float_val = floatval($val);
	if($rcv_summ_array[$trans_date])
	{
		$old_sum = $rcv_summ_array[$trans_date]['sum'];
		$rcv_summ_array[$trans_date]['sum'] = floatval(bcadd($old_sum,$float_val,2));
	}
	else
	{
		$rcv_summ_array[$trans_date]['sum'] = $float_val;
	}
	$sum_receivings = floatval(bcadd($sum_receivings,$float_val,2));
}

for($i=0;$i<$exp_data_size;$i++)
{
	$formatted_date = date("d-m-Y",$expMenuQuery[$i]->trans_date);
	$trans_date = substr($formatted_date,0,2);
	$val = str_replace(",","",($expMenuQuery[$i]->trans_val));
	$float_val = floatval($val);
	if(($exp_summ_array[$trans_date]))
	{
		$old_sum = $exp_summ_array[$trans_date]['sum'];
		$exp_summ_array[$trans_date]['sum'] = floatval(bcadd($old_sum,$float_val,2));
	}
	else
	{
		$exp_summ_array[$trans_date]['sum'] = $float_val;
	}
	$sum_expenses = floatval(bcadd($sum_expenses,$float_val,2));
}

for($i=0;$i<$adv_rcv_data_size;$i++)
{
	$formatted_date = date("d-m-Y",$advRcvMenuQuery[$i]->trans_date);
	$trans_date = substr($formatted_date,0,2);
	$val = str_replace(",","",($advRcvMenuQuery[$i]->trans_val));
	$float_val = floatval($val);
	if(($adv_rcv_summ_array[$trans_date]))
	{
		$old_sum = $adv_rcv_summ_array[$trans_date]['sum'];
		$adv_rcv_summ_array[$trans_date]['sum'] = floatval(bcadd($old_sum,$float_val,2));
	}
	else
	{
		$adv_rcv_summ_array[$trans_date]['sum'] = $float_val;
	}
	$sum_adv_receivings = floatval(bcadd($sum_adv_receivings,$float_val,2));
}


for($i=0;$i<$adv_exp_data_size;$i++)
{
	$formatted_date = date("d-m-Y",$advExpMenuQuery[$i]->trans_date);
	$trans_date = substr($formatted_date,0,2);
	$val = str_replace(",","",($advExpMenuQuery[$i]->trans_val));
	$float_val = floatval($val);
	if(($adv_exp_summ_array[$trans_date]))
	{
		$old_sum = $adv_exp_summ_array[$trans_date]['sum'];
		$adv_exp_summ_array[$trans_date]['sum'] = floatval(bcadd($old_sum,$float_val,2));
	}
	else
	{
		$adv_exp_summ_array[$trans_date]['sum'] = $float_val;
	}
	$sum_adv_expenses = floatval(bcadd($sum_adv_expenses,$float_val,2));
}



// Create arrayobject for all dates and add summary date if available
for ($i=1;$i<=$number_of_days;$i++)
{
	$cur_date = str_pad($i, 2, "0", STR_PAD_LEFT);
	if(($rcv_summ_array[$cur_date]))
	{
		$recv_data->append($rcv_summ_array[$cur_date]['sum']);
	}
	else 
	{
		$recv_data->append(floatval("0"));
	}
	
	if(($exp_summ_array[$cur_date]))
	{
		$exp_data->append($exp_summ_array[$cur_date]['sum']);
	}
	else 
	{
		$exp_data->append(floatval("0"));
	}

	if(($adv_rcv_summ_array[$cur_date]))
	{
		$adv_recv_data->append($adv_rcv_summ_array[$cur_date]['sum']);
	}
	else 
	{
		$adv_recv_data->append(floatval("0"));
	}

	if(($adv_exp_summ_array[$cur_date]))
	{
		$adv_exp_data->append($adv_exp_summ_array[$cur_date]['sum']);
	}
	else 
	{
		$adv_exp_data->append(floatval("0"));
	}
}

$sum_total = floatval(bcsub($sum_receivings,$sum_expenses,2));
$sum_total_positive = bcadd($sum_receivings,$sum_expenses,2);
$rcv_percent = $sum_receivings == 0 ? 0.00 : number_format(($sum_receivings/$sum_total_positive)*100,0);
$exp_percent = $sum_expenses == 0 ? 0.00 : number_format(($sum_expenses/$sum_total_positive)*100,0);
echo json_encode(array('rcv'=>$rcvMenuQuery,'adv_rcv'=>$sum_adv_receivings,'adv_exp'=>$sum_adv_expenses,'adv_rcv_data'=>$adv_recv_data,'rcv_data'=>$recv_data,'summary_receivings'=>$sum_receivings,'adv_exp_data'=>$adv_exp_data,'exp_data'=>$exp_data,'summary_expenses'=>$sum_expenses,'summary_total'=>$sum_total,'rcv_percent'=>$rcv_percent,'exp_percent'=>$exp_percent,'month'=>$month_name,'number_of_days'=>$number_of_days,'x-axis'=>$days_object,'date_start'=>date('01-m-Y',strtotime('this month')),'start'=>$query_period_string_start,'date_end'=>date('t-m-Y',strtotime('this month')),'end'=>$query_period_string_end));
?>