<?php
//include('collection_lists.php');
require '../../vendor/autoload.php';
$host = "mongodb://ec2-54-179-138-82.ap-southeast-1.compute.amazonaws.com:27017";
$client = new MongoDB\Client($host);
$collection_menu_types = array(
	'rcv'			=>	'receivings_menu',
	'rcv_adv'			=>	'advanced_receivings',
	'rcv_adv_trans'	=>	'advanced_receivings',
	'rcv_trans'		=>	'receivings_trans',
	'rcv_acc'			=>	'debtor_accounts',
	'exp'			=>	'expenses_menu',
	'exp_adv'			=>	'advanced_expenses',
	'exp_adv_trans'	=>	'advanced_expenses',
	'exp_trans'		=>	'expenses_trans',
	'exp_acc'			=>	'creditor_accounts'
);

$business_id = $_GET['business_id'] == "" ? 1 : (int)$_GET['business_id'];
$report_year = $_GET['report_year'] == "" ? date("Y") : $_GET['report_year'];
$collection = $client->mcf_tiffany_801->setting_personal;
//$collection = $client->$dbNameConnector->setting_personal;
$filter  = [ 'business_id' => (int)$business_id];
$cursor = $collection->findone($filter);
$business_name = $cursor['name'];
$start_day  = strtotime(date("01-01-".$report_year));
$end_day  = strtotime(date("31-12-".$report_year));



$report_type = array(
	'1' 	=>	'rcv_trans',
	'2'	=>	'exp_trans'
);

$filter  = [ 'visible' => 1 , 'business_id' => $business_id, 'trans_date' => ['$gte'=>$start_day,'$lte'=>$end_day] ];
$options = ['sort' => ['mcf_trans_id' => 1]];

$trans_menu_rcv = $collection_menu_types[$report_type[1]];
$trans_menu_exp = $collection_menu_types[$report_type[2]];
$rcv_collection = $client->mcf_tiffany_801->receivings_trans;
$cursor = $rcv_collection->find($filter,$options);

$summaryCashflow = array( 
	'cfo'	=>	array('summary' => 0, 'summary_forecast' => 0),
	'cff'	=>	array('summary' => 0, 'summary_forecast' => 0),
	'cfi'	=>	array('summary' => 0, 'summary_forecast' => 0)
	);
	
$rcvMenuQuery = array();
foreach ($cursor as $doc) {
	$month = date("m",$doc['trans_date']);
	if(array_key_exists($month,$rcvMenuQuery))
	{
		if(array_key_exists($doc['lv2_name'],$rcvMenuQuery[$month][$doc['lv1_menu']]))
		{	
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$current_val = $rcvMenuQuery[$month][$doc['lv1_menu']][$doc['lv2_name']]['trans_val'];
			$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['trans_val'] = floatval(bcadd($current_val,$new_val));
			if(array_key_exists($doc['lv3_name'],$rcvMenuQuery[$month][$doc['lv1_menu']]))
			{

				$current_lv3_val = floatval($rcvMenuQuery[$month][$doc['lv1_menu']][$doc['lv3_name']]);
				$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval(bcadd($current_lv3_val,$new_val));
			}
			else
			{
				$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval($new_val);
			}
			
			$current_summary_val = floatval($summaryCashflow[$month][$doc['lv1_menu']]['summary']);
			$summaryCashflow[$month][$doc['lv1_menu']]['summary'] = floatval(bcadd($current_summary_val,$new_val));		
		}
		else 
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['trans_val'] = $new_val;
			$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['lv1'] = $doc['lv1_menu'];
			
			$current_summary_val = floatval($summaryCashflow[$month][$doc['lv1_menu']]['summary']);
			$summaryCashflow[$month][$doc['lv1_menu']]['summary'] = floatval(bcadd($current_summary_val,$new_val));
			$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval($new_val);
		}
	}
	else
	{
		$new_val_substring = str_replace(",","",$doc['trans_val']);
		$new_val = floatval($new_val_substring);
		$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['trans_val'] = $new_val;
		$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['lv1'] = $doc['lv1_menu'];
		
		$current_summary_val = floatval($summaryCashflow[$month][$doc['lv1_menu']]['summary']);
		$summaryCashflow[$month][$doc['lv1_menu']]['summary'] = floatval(bcadd($current_summary_val,$new_val));
		$rcvMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval($new_val);
	}
}

//print_r($summaryCashflow['05']['cfo']);
$expMenuQuery = array();
$exp_collection = $client->mcf_tiffany_801->$trans_menu_exp;
$cursor = $exp_collection->find($filter,$options);

foreach ($cursor as $doc) {
	$month = date("m",$doc['trans_date']);
	if(array_key_exists($month,$expMenuQuery))
	{
		if(array_key_exists($doc['lv2_name'],$expMenuQuery[$month][$doc['lv1_menu']]))
		{	
	
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$current_val = $expMenuQuery[$doc['lv1_menu']][$doc['lv2_name']]['trans_val'];
			$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['trans_val'] = floatval(bcadd($current_val,$new_val));
			if(array_key_exists($doc['lv3_name'],$expMenuQuery[$month][$doc['lv1_menu']]))
			{
				$current_lv3_val = $expMenuQuery[$month][$doc['lv1_menu']][$doc['lv3_name']];
				$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval(bcadd($current_lv3_val,$new_val));
			}
			else
			{
				$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval($new_val);
			}
			$current_summary_val = floatval($summaryCashflow[$month][$doc['lv1_menu']]['summary']);
			$summaryCashflow[$month][$doc['lv1_menu']]['summary'] = floatval(bcsub($current_summary_val,$new_val));		
		}
		else 
		{
			$new_val_substring = str_replace(",","",$doc['trans_val']);
			$new_val = floatval($new_val_substring);
			$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['trans_val'] = $new_val;
			$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['lv1'] = $doc['lv1_menu'];
			
			$current_summary_val = floatval($summaryCashflow[$month][$doc['lv1_menu']]['summary']);
			$summaryCashflow[$month][$doc['lv1_menu']]['summary'] = floatval(bcsub($current_summary_val,$new_val));
			$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval($new_val);
		}
	}
	else
	{
		$new_val_substring = str_replace(",","",$doc['trans_val']);
		$new_val = floatval($new_val_substring);
		$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['trans_val'] = $new_val;
		$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv2_name']]['lv1'] = $doc['lv1_menu'];
		
		$current_summary_val = floatval($summaryCashflow[$month][$doc['lv1_menu']]['summary']);
		$summaryCashflow[$month][$doc['lv1_menu']]['summary'] = floatval(bcsub($current_summary_val,$new_val));
		$expMenuQuery[$month][($doc['lv1_menu'])][$doc['lv3_name']] = floatval($new_val);
	}
}

$filter  = [ 'business_id' => (int)$business_id];
$rcvMenu = $client->mcf_tiffany_801->receivings_menu;
$cursorRcv = $rcvMenu->find($filter);
foreach($cursorRcv as $doc)
{
	foreach($doc['lv3'] as $lv3)
	{
		$cursorRcvArray[$doc['lv1_menu']][]= array('name' => $lv3['name'], 'id' => $doc['mcf_id']);
		//$cursorRcvArray[$doc['lv1_menu']][]['id'] = $doc['mcf_id'];
	}
}


$expMenu = $client->mcf_tiffany_801->expenses_menu;
$cursorExp = $expMenu->find($filter);
foreach($cursorExp as $doc)
{
	foreach($doc['lv3'] as $lv3)
	{
		$cursorExpArray[$doc['lv1_menu']][] = array('name' => $lv3['name'], 'id' => $doc['mcf_id']);
		//$cursorExpArray[$doc['lv1_menu']][]['id'] = $doc['mcf_id'];
	}
}
$summCash = array();
$summAll = array();
for($i=1;$i<=12;$i++)
{
	$keyI = str_pad($i, 2, "0", STR_PAD_LEFT);
	$summaryCashflow[$keyI]['total_summary'] = $summaryCashflow[$keyI]['cfo']['summary']+$summaryCashflow[$keyI]['cfi']['summary']+$summaryCashflow[$keyI]['cff']['summary'];
}

$summKey = array();
ksort($summaryCashflow);
$prev_key = "";
foreach ($summaryCashflow as $key=>$value)
{
	if($key !== "cfo" && $key !== "cfi" && $key !== "cff")
	{
		$summCash[$key]['total_summary'] = $summaryCashflow[$key]['cfo']['summary']+$summaryCashflow[$key]['cfi']['summary']+$summaryCashflow[$key]['cff']['summary'];
		if($prev_key !== "")
		{
			$summAll[$key] = bcadd($summCash[$key]['total_summary'],$summAll[$prev_key]);
		}
		else
		{
			$summAll[$key] = $summCash[$key]['total_summary'];
		}
		$prev_key = $key;
		array_push($summKey,$key);
	}
}

//print_r($summAll);
include('test_report_view.php');
print_r($fileExport);

//echo json_encode(array($summaryCashflow));

?>